<?php
namespace App\Http\Controllers\DPR;

use App\Http\Controllers\Controller;
use App\Models\DPRCom;
use App\Models\DPRDensityData;
use App\Models\DPRDom;
use App\Models\DprGCVReport;
use App\Models\DprInputs;
use App\Models\DPRJambusarBarmerLoading;
use App\Models\DPRSug;
use App\Models\DPRTankerUnloading;
use App\Models\DPRUnAccountedKnownGasLoss;
use App\Models\DprDistrictCNGReport;
use App\Models\DprDistrictCGDRecoReport;
use App\Models\DPRPELinePack;
use App\Models\DPRSteelLinePack;
use App\Models\MasterNetworks;
use App\Models\User;
use App\Models\DprGaSalesReport;
use App\Models\EDCompressor;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use DB;
use DateTime;

class DPRController extends Controller
{
    /**
     * Write code on Method
     *
     * @return response()
     */
    public function densityData()
    {
        $user = auth()->user();
        if (Auth::check()) {
            $allDensityData = DPRDensityData::all();
            return view('dpr.densityData', ['allDensityData' => $allDensityData]);
        } else {
            return redirect("/")->withSuccess('Opps! You do not have access');

        }
    }
    public function postDensityData(Request $request)
    {
        $alldata = $request->all();
        //print_r($alldata);exit;
        $dcudate = date("Y-m-d", strtotime($request->dcu_date));
        $data = array(
            "userId" => $alldata['user_id'],
            "tanker_loading_date" => $request->tanker_loading_date,
            "source" => $request->source,
            "type" => $request->type,
            "tanker_unloading_date" => $request->tanker_unloading_date,
            "invoice_quantity" => $request->invoice_quantity,
            "mmbtu_cross" => $request->mmbtu_cross,
            "invoice_value" => $request->invoice_value,
            "rs_kg" => $request->rs_kg,
            "methane_percentage" => $request->methane_percentage,
            "mmbtu_per_mt" => $request->mmbtu_per_mt,
            "tank" => $request->tank,
             "tanker_no" => $request->tanker_no,
        );

        /* $row_status = DPRDensityData::where("dcu_date", $dcudate)->first(); // check for the unique date
        if (!is_null($row_status)) {
        return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Date value is already exists!"]);
        } */
        $create = DPRDensityData::insert($data);
        if ($create) {
            return back()->with(["status" => 200, "msg" => "Data inserted successfully.", "code" => config("constants.CODE_SUCCESS")]);
        }
    }

    public function dprDom(Request $request)
    {
        $user = auth()->user();
        $data = $request->input();
        if (Auth::check()) {
            $allDomData = DPRDom::all();
            $ga = dd_masters("ga", "ga_code");
            $district = dd_masters("district", "address_district");
            if (isset($data['id'])) {
                $dId = $data['id'];
                $singleDomData = DPRDom::where('id', $dId)->get();
                return view('dpr.dprDomSheet', ['ga' => $ga, 'district' => $district, 'allDomData' => $allDomData, 'singleDomData' => $singleDomData]);
            } else {
                return view('dpr.dprDomSheet', ['ga' => $ga, 'district' => $district, 'allDomData' => $allDomData]);
            }
        } else {
            return redirect("/")->withSuccess('Opps! You do not have access');

        }
    }
    public function postDomData(Request $request)
    {
        $alldata = $request->all();
        //$dcudate = date("Y-m-d", strtotime($request->dcu_date));
        $data = array(
            "userId" => $alldata['user_id'],
            "ga_code" => $request->ga_code,
            "district" => $request->district,
            "financial_year" => $request->financial_year,
            "month" => $request->month,
            "date" => $request->date,
            "total_customers_commissoned" => $request->total_customers_commissoned,
            "average_days" => $request->dom_average,
            "total_estimated_consumption" => $request->total_estimated_consumption,
            "house_locked" => $request->house_locked,
            "actual_live_active_customers" => $request->actual_live_active_customers,
            "dom_average" => $request->dom_average,
            "la_customer" => $request->la_customer,
            "dom_volume_actual" => $request->dom_volume_actual,
            "count_move_sap" => $request->count_move_sap,
            "count_active_move_sap" => $request->count_active_move_sap,
            "cf" => $request->cf,
            "actual_domestic_volume" => $request->actual_domestic_volume,
        );

        /* $row_status = DPRDensityData::where("dcu_date", $dcudate)->first(); // check for the unique date
        if (!is_null($row_status)) {
        return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Date value is already exists!"]);
        } */
       if(isset($request->did)){
$create = DPRDom::where('id', $request->did)->update($data);
       }
       else{
        $create = DPRDom::create($data);
       }
        if ($create) {
            return back()->with(["status" => 200, "msg" => "Data inserted successfully.", "code" => config("constants.CODE_SUCCESS")]);
        }
    }
    public function dprCom(Request $request)
    {
        $user = auth()->user();
        $data = $request->input();
        if (Auth::check()) {
            $allComData = DPRCom::all();
            $ga = dd_masters("ga", "ga_code");
            $district = dd_masters("district", "address_district");
            if (isset($data['id'])) {
                $cId = $data['id'];
                $singleComData = DPRCom::where('id', $cId)->get();
                return view('dpr.dprCom', ['ga' => $ga, 'district' => $district, 'allComData' => $allComData, 'singleComData' => $singleComData]);
            } else {
            return view('dpr.dprCom', ['ga' => $ga, 'district' => $district, 'allComData' => $allComData]);
            }
        } else {
            return redirect("/")->withSuccess('Opps! You do not have access');

        }
    }
    public function postComData(Request $request)
    {
        $alldata = $request->all();
        //print_r($alldata);exit;
        //$dcudate = date("Y-m-d", strtotime($request->dcu_date));
        $data = array(
            "userId" => $alldata['user_id'],
            "ga_code" => $request->ga_code,
            "district" => $request->district,
            "financial_year" => $request->financial_year,
            "month" => $request->month,
            "date" => $request->date,
            "total_customers_commissoned" => $request->total_customers_commissoned,
            "average_days" => $request->average_days,
            "total_billed_volume" => $request->total_billed_volume,
            "house_locked" => $request->house_locked,
            "actual_live_active_customers" => $request->actual_live_active_customers,
            "comm_average" => $request->comm_average,
            "la_customer" => $request->la_customer,
            "comm_volume_actual" => $request->comm_volume_actual,
        );

        /* $row_status = DPRDensityData::where("dcu_date", $dcudate)->first(); // check for the unique date
        if (!is_null($row_status)) {
        return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Date value is already exists!"]);
        } */
       if(isset($request->cid)){
$create = DPRCom::where('id', $request->cid)->update($data);
       }
       else{
        $create = DPRCom::insert($data);
       }
        if ($create) {
            return back()->with(["status" => 200, "msg" => "Data inserted successfully.", "code" => config("constants.CODE_SUCCESS")]);
        }
    }
    public function dprSug(Request $request)
    {
        $user = auth()->user();
        if (Auth::check()) {
            $allSugData = DPRSug::all();
            $ga = dd_masters("ga", "ga_code");
            $district = dd_masters("district", "address_district");
            return view('dpr.dprSug', ['ga' => $ga, 'district' => $district, 'allSugData' => $allSugData]);
        } else {
            return redirect("/")->withSuccess('Opps! You do not have access');

        }
    }
    public function grossSUGKgValue(Request $request)
    {
        $data = $request->input();
        $sqlData = DprGCVReport::where('gcv_date_of_unloading', $data['date'])->value('gcv_total_volume_in_kg');
        $calculatedValue = $sqlData / $data['gross_sug_scm'];
        return $calculatedValue;
        //print_r($sqlData); exit;
    }
    public function gasFilledToMCVPerMonthInKg(Request $request)
    {
        return 0;
        /* $data = $request->input();
    $sqlData = DprGCVReport::where('gcv_date_of_unloading', $data['date'])->value('gcv_total_volume_in_kg');
    $calculatedValue = $sqlData / $data['gross_sug_scm'];
    return $calculatedValue; */
    }
    public function postSugData(Request $request)
    {
        $alldata = $request->all();
        //print_r($alldata);exit;
        //$dcudate = date("Y-m-d", strtotime($request->dcu_date));
        $data = array(
            "userId" => $alldata['user_id'],
            "date" => $request->date,
            "ga_code" => $request->ga_code,
            "district" => $request->district,
           /* "financial_year" => $request->financial_year,
            "month" => $request->month,
            "opening_reading_mfm_gg_1" => $request->opening_reading_mfm_gg_1,
            "closing_reading_mfm_gg_1" => $request->closing_reading_mfm_gg_1,
            "gg_1_sug" => $request->gg_1_sug,
            "opening_reading_mfm_gg_2" => $request->opening_reading_mfm_gg_2,
            "closing_reading_mfm_gg_2" => $request->closing_reading_mfm_gg_2,
            "gg_2_sug" => $request->gg_2_sug,
            "gross_sug_scm" => $request->gross_sug_scm,
            "cum_monthly_purchase" => $request->cum_monthly_purchase,
            "cum_yearly_purchase" => $request->cum_yearly_purchase,
            "gross_sug_kg" => $request->gross_sug_kg,
            "gas_filled_to_mcv_from_salawas" => $request->gas_filled_to_mcv_from_salawas,*/
            "mcv_fuel" => $request->mcv_fuel,
            "admin_cab_fuel" => $request->admin_cab_fuel,
            "gas_engine_genset_fuel" => $request->gas_engine_genset_fuel,
            "engine_composer_fuel" => $request->engine_composer_fuel,
            "total_cng_used" => $request->total_cng_used,
            "total_png_used" => $request->total_png_used,
        );

        /* $row_status = DPRDensityData::where("dcu_date", $dcudate)->first(); // check for the unique date
        if (!is_null($row_status)) {
        return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Date value is already exists!"]);
        } */
        $create = DPRSug::insert($data);
        if ($create) {
            return back()->with(["status" => 200, "msg" => "Data inserted successfully.", "code" => config("constants.CODE_SUCCESS")]);
        }
    }
    public function CumMonthlyPurchaseInSCM(Request $request)
    {
        $data = $request->input();
        $date = date('Y-m-d', strtotime('-1 day', strtotime($data['date'])));
        //print $date; exit;
        $sqlData = DPRSug::where('date', $date)->value('cum_monthly_purchase');
        $calculatedValue = $sqlData + $data['gross_sug_scm'];
        return $calculatedValue;
    }
    public function CumYearlyPurchaseInSCM(Request $request)
    {
        $data = $request->input();
        $date = date('Y-m-d', strtotime('-1 day', strtotime($data['date'])));
        //print $date; exit;
        $sqlData = DPRSug::where('date', $date)->value('cum_yearly_purchase');
        $calculatedValue = $sqlData + $data['gross_sug_scm'];
        return $calculatedValue;
    }
    public function GasFilledtoMCVFromSalawas(Request $request)
    {
        $data = $request->input();
        $previousDate = date('Y-m-d', strtotime('-1 day', strtotime($data['date'])));
        $selectedDate = $data['date'];
        //print $date; exit;
        $sqlData = DPRSug::where('month', $data['month'])
            ->sum('gas_filled_to_mcv_from_salawas');
        //$calculatedValue = $sqlData + $data['gross_sug_scm'];
        return $sqlData;
    }
    public function dprTankerUnloading(Request $request)
    {
        $user = auth()->user();
        if (Auth::check()) {
            $allSugData = DPRTankerUnloading::all();
            $ga = dd_masters("ga", "ga_code");
            $district = dd_masters("district", "address_district");
            return view('dpr.dprTankerUnloading', ['ga' => $ga, 'district' => $district, 'allSugData' => $allSugData]);
        } else {
            return redirect("/")->withSuccess('Opps! You do not have access');

        }
    }
    public function quantityOfLNGInvoiced(Request $request)
    {
        $quantityOfLNGInvoiced = DprInputs::where('input_date', $request->date)->where('district', $request->district)->where('input_month', $request->month)->value('quantity_of_LNG_invoiced_at_the_LNG_terminal');
        $quantityOfLNGUnloaded = DprInputs::where('input_date', $request->date)->where('district', $request->district)->where('input_month', $request->month)->value('quantity_of_LNG_unloaded_at_the_LNG_terminal_as_per_MFM');
        $quantityOfLNGUnloadedAtLNGTerminal = DprInputs::where('input_date', $request->date)->where('district', $request->district)->where('input_month', $request->month)->value('quantity_of_LNG_unloaded_at_the_LCNG_station_as_per_weighment');
        $closingLevelOfTank1 = DprInputs::where('input_date', $request->date)->where('district', $request->district)->where('input_month', $request->month)->value('tank_1');
        $closingLevelOfTank2 = DprInputs::where('input_date', $request->date)->where('district', $request->district)->where('input_month', $request->month)->value('tank_2');
        $closingLevelOfTank3 = DprInputs::where('input_date', $request->date)->where('district', $request->district)->where('input_month', $request->month)->value('tank_3');
        $closingLevelOfTank4 = DprInputs::where('input_date', $request->date)->where('district', $request->district)->where('input_month', $request->month)->value('tank_4');
        $returnData = array("quantityOfLNGInvoiced" => $quantityOfLNGInvoiced,
            "quantityOfLNGUnloaded" => $quantityOfLNGUnloaded,
            "quantityOfLNGUnloadedAtLNGTerminal" => $quantityOfLNGUnloadedAtLNGTerminal,
            "closingLevelOfTank1" => $closingLevelOfTank1,
            "closingLevelOfTank2" => $closingLevelOfTank2,
            "closingLevelOfTank3" => $closingLevelOfTank3,
            "closingLevelOfTank4" => $closingLevelOfTank4,
        );
        return $returnData;
    }
    public function volumeAvailableStationaryCascade(Request $request)
    {
        $volumeAvailableInStationaryCascade = DprInputs::where('input_date', $request->date)->where('district', $request->district)->where('input_month', $request->month)->value('volume_Available_in_Stationary_Cascade');
        $GCVConversionFactor = DprGCVReport::where('gcv_date_of_unloading', $request->date)->value('gcv_conversion_factor_scm_kg');
        $returnData = $volumeAvailableInStationaryCascade * $GCVConversionFactor;
        return $returnData;
    }
    public function totalClosingStock(Request $request)
    {
        $data = $request->input();
        $quantity_of_lng_invoiced_terminal_kgs = $data['quantity_of_lng_invoiced_terminal_kgs'];
        $quantity_of_lng_invoiced_terminal_as_per_kgs = $data['quantity_of_lng_invoiced_terminal_as_per_kgs'];
        $transit_loss = $this->transitLossGasVolumes($data['date'], $quantity_of_lng_invoiced_terminal_kgs, $quantity_of_lng_invoiced_terminal_as_per_kgs);
        $GCVConversionFactorSCMKL = DprGCVReport::where('gcv_date_of_unloading', $request->date)->value('gcv_conversion_factor_scm_kl');
        $total_closing_stock_in_scm_h = $data['volume_available_in_stationary_cascade'] + ($data['total_closing_stock_g_e_f_k_l'] * $GCVConversionFactorSCMKL);
        $returnData = array(
            "total_closing_stock_in_scm_h" => $total_closing_stock_in_scm_h,
            "transit_loss" => $transit_loss,
        );
        return $returnData;
    }
    public function transitLossGasVolumes($date, $quantity_of_lng_invoiced_terminal_kgs, $quantity_of_lng_invoiced_terminal_as_per_kgs)
    {
        $subtractionValue = $quantity_of_lng_invoiced_terminal_kgs - $quantity_of_lng_invoiced_terminal_as_per_kgs;
        $GCVConversionFactor = DprGCVReport::where('gcv_date_of_unloading', $date)->value('gcv_conversion_factor_scm_kg');
        $returnData = $subtractionValue * $GCVConversionFactor;
        return $returnData;
    }
    public function lossCalculation(Request $request)
    {
        $data = $request->input();
        $quantity_of_lng_invoiced_terminal_kgs = $data['quantity_of_lng_invoiced_terminal_kgs'];
        $transit_loss_gas_volumes_scm_c = $data['transit_loss_gas_volumes_scm_c'];
        $GCVConversionFactor = DprGCVReport::where('gcv_date_of_unloading', $data['date'])->value('gcv_conversion_factor_scm_kg');
        $returnData = ($transit_loss_gas_volumes_scm_c / $GCVConversionFactor) / $quantity_of_lng_invoiced_terminal_kgs;
        return number_format($returnData * 100, 2);

    }
    public function lossCalculationMTD(Request $request)
    {
        $data = $request->input();
        $mtd_purchased = $data['mtd_purchased'];
        $cumulative_transit_loss_gas_volumes_scm_c = $data['cumulative_transit_loss_gas_volumes_scm_c'];
        $GCVConversionFactor = DprGCVReport::where('gcv_date_of_unloading', $data['date'])->value('gcv_conversion_factor_scm_kg');
        $returnData = ($cumulative_transit_loss_gas_volumes_scm_c / $GCVConversionFactor) / $mtd_purchased;
        return number_format($returnData * 100, 2);
    }
    public function lossCalculationYTD(Request $request)
    {
        $data = $request->input();
        $ytd_purchased = $data['ytd_purchased'];
        $cumulative_transit_loss_gas_volumes_scm_c = $data['cumulative_transit_loss_gas_volumes_scm_c'];
        $GCVConversionFactor = DprGCVReport::where('gcv_date_of_unloading', $data['date'])->value('gcv_conversion_factor_scm_kg');
        $returnData = ($cumulative_transit_loss_gas_volumes_scm_c / $GCVConversionFactor) / $ytd_purchased;
        return number_format($returnData * 100, 2);
    }
    public function postTankerUnloadingData(Request $request)
    {
        $alldata = $request->all();
        $data = array(
            "date" => $request->date,
            "opening_level_of_tank_1_a_kl" => $request->opening_level_of_tank_1_a_kl,
            "opening_level_of_tank_2_b_kl" => $request->opening_level_of_tank_2_b_kl,
            "opening_level_of_tank_3_i_kl" => $request->opening_level_of_tank_3_i_kl,
            "month" => $request->month,
            "opening_level_of_tank_4_j_kl" => $request->opening_level_of_tank_4_j_kl,
            "total_opening_stock_c_a_b_i_j" => $request->total_opening_stock_c_a_b_i_j,
            "total_opening_stock_in_scm_d" => $request->total_opening_stock_in_scm_d,
            "quantity_of_lng_invoiced_in_kg_q" => $request->quantity_of_lng_invoiced_terminal_q,
            "quantity_of_lng_unloaded_mfm_kg_q_1" => $request->quantity_of_lng_invoiced_terminal_q1,
            "quantity_of_lng_unloaded_mfm_weighment_q_2" => $request->quantity_of_lng_invoiced_terminal_q2,
            "closing_level_tank_1_e_kl" => $request->closing_level_of_tank_1_e_kl,
            "closing_level_tank_2_f_kl" => $request->closing_level_of_tank_2_f_kl,
            "closing_level_tank_3_e_kl" => $request->closing_level_of_tank_3_k_kl,
            "closing_level_tank_4_i_kl" => $request->closing_level_of_tank_4_l_kl,
            "total_closing_g_e_f_k_l_in_kl" => $request->total_closing_stock_g_e_f_k_l,
            "volume_available_stationary_cascade" => $request->volume_available_in_stationary_cascade,
            "total_closing_stock_scm_kl" => $request->total_closing_stock_in_scm_h,
            "transit_loss_gas_volumes_c" => $request->transit_loss_gas_volumes_scm_c,
            "loss_percentage" => $request->loss_i_f,
            "mtd_purchased" => $request->mtd_purchased,
            "cumulative_transit_loss_gas_volumes_scm_c" => $request->cumulative_transit_loss_gas_volumes_scm_c,
            "percentage_loss_mtd" => $request->loss_mtd,
            "ytd_purchased" => $request->ytd_purchased,
            "cumilative_transit_loss_gas_volume_scm_c" => $request->cumulative_transit_loss_gas_volumes_scm_c1,
            "percentage_loss_ytd" => $request->precentage_loss_ytd,
        );

        /* $row_status = DPRDensityData::where("dcu_date", $dcudate)->first(); // check for the unique date
        if (!is_null($row_status)) {
        return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Date value is already exists!"]);
        } */
        $create = DPRTankerUnloading::insert($data);
        if ($create) {
            return back()->with(["status" => 200, "msg" => "Data inserted successfully.", "code" => config("constants.CODE_SUCCESS")]);
        }
    }

    public function checkIfRecordExsists(Request $request)
    {
        $date = $request->date;
        $sql = DPRTankerUnloading::where('date', $date)->get();
        $count = $sql->count();
        //print $count; exit;
        if ($count >= 1) {
            $sql = DPRTankerUnloading::where('date', $date)->get();
            if ($sql) {
                //print_r($sql); exit;
                $total_opening_stock = $sql[0]['closing_level_tank_1_e_kl'] + $sql[0]['closing_level_tank_2_f_kl'] + $sql[0]['closing_level_tank_3_e_kl'] + $sql[0]['closing_level_tank_4_i_kl'];
                $data = array(
                    "closing_level_tank_1_e_kl" => $sql[0]['closing_level_tank_1_e_kl'],
                    "closing_level_tank_2_f_kl" => $sql[0]['closing_level_tank_2_f_kl'],
                    "closing_level_tank_3_e_kl" => $sql[0]['closing_level_tank_3_e_kl'],
                    "closing_level_tank_4_i_kl" => $sql[0]['closing_level_tank_4_i_kl'],
                    "total_opening_stock" => $total_opening_stock,
                    "total_closing_stock_scm_kl" => $sql[0]['total_closing_stock_scm_kl'],
                );
                return $data;
            }
        } else {
            //
        }
    }

    public function dprUnAccountedKnownGasLoss(Request $request)
    {
        $user = auth()->user();
        if (Auth::check()) {
            $allUnAccountedKnownGasLossData = DPRUnAccountedKnownGasLoss::all();
            $ga = dd_masters("ga", "ga_code");
            $district = dd_masters("district", "address_district");
            return view('dpr.dprUnAccountedKnownGasLoss', ['ga' => $ga, 'district' => $district, 'allUnAccountedKnownGasLossData' => $allUnAccountedKnownGasLossData]);
        } else {
            return redirect("/")->withSuccess('Opps! You do not have access');

        }
    }

    public function postdprUnAccountedKnownGasLoss(Request $request)
    {
        $alldata = $request->all();
        $data = array(
            "user_id" => $request->user_id,
            "date" => $request->date,
            "loss_during_unloading" => $request->loss_during_unloading,
            "approx_loss" => $request->approx_loss,
            "cng_side_loss" => $request->cng_side_loss,
            "line_damage" => $request->line_damage,
            "venting_purging_vol" => $request->venting_purging_vol,
            "line_pack" => $request->line_pack,
            "identified_theft" => $request->identified_theft,
            "amc" => $request->amc,
            "others" => $request->others,
            "total_unaccounted" => $request->total_unaccounted,
        );

        $create = DPRUnAccountedKnownGasLoss::insert($data);
        if ($create) {
            return back()->with(["status" => 200, "msg" => "Data inserted successfully.", "code" => config("constants.CODE_SUCCESS")]);
        }

    }

    public function lossDuringUnloading(Request $request)
    {
        $data = $request->input();
        $date = $data['date'];
        $approx_gas_loss = DPRTankerUnloading::where('date', $date)->value('transit_loss_gas_volumes_c');
        return $approx_gas_loss;
    }

    public function dprJambusarBarmerLoading(Request $request)
    {
        $user = auth()->user();
        if (Auth::check()) {
            $allUnAccountedKnownGasLossData = DPRJambusarBarmerLoading::all();
            $ga = dd_masters("ga", "ga_code");
            $district = dd_masters("district", "address_district");
            return view('dpr.dprJambusarBarmerLoading', ['ga' => $ga, 'district' => $district, 'allUnAccountedKnownGasLossData' => $allUnAccountedKnownGasLossData]);
        } else {
            return redirect("/")->withSuccess('Opps! You do not have access');

        }
    }

    public function postDprJambusarBarmerLoading(Request $request)
    {
        $alldata = $request->all();
        $data = array(
            "user_id" => $request->user_id,
            "date" => $request->date,
            "vehicle_number" => $request->vehicle_number,
            "product" => $request->product,
            "source" => $request->source,
            "initial_reading" => $request->initial_reading,
            "final_reading" => $request->final_reading,
            "actual_weight" => $request->actual_net_weight,
        );

        $create = DPRJambusarBarmerLoading::insert($data);
        if ($create) {
            return back()->with(["status" => 200, "msg" => "Data inserted successfully.", "code" => config("constants.CODE_SUCCESS")]);
        }

    }

    public function districtWiseSalesReport(Request $request){
        return view('dpr.districtWiseSalesReport');
    }

    public function generateSalesReport(Request $request){
        ini_set('memory_limit', '-1');
        $user_details = $request->input();
        //print_r($user_details); exit;
        $district = $user_details['district'];
        $user_id = "GI1864";
        $ids = array();
        //Get Search Details
        $form = $request->input('formdata');
        $params = array();
        parse_str($form, $params);
        $currentYear = date("Y");
        $previousYear = $currentYear - 1;
        /* if ($params['fromDate']) {
            $fromDate = date("Y-m-d", strtotime($params['fromDate']));
        } else {
            $fromDate = $currentYear . date("mm-dd");
        }

        if ($params['toDate']) {
            $toDate = date("Y-m-d", strtotime($params['toDate']));
        } else {
            $toDate = $previousYear . date("mm-dd");
        } */
       $fromDate = $previousYear . date("-03-30");
       $toDate = $currentYear . date("-04-01");
        //print $toDate; exit;
        //Get Search Details
        $columns = array(
            0 => 'id',
        );
        /* if (empty($ids)) {
            return response()->json([
                "success" => false,
                "message" => "No data available!!",
                "code" => 1,
                "data" => "",
            ]);

        } */
        $totalData = DprGaSalesReport::where('district', $district)->get();
        //print_r($totalData); exit;
        $totalData = $totalData->count();
        if ($request->input('length')) {
            $limit = $request->input('length');
        } else {
            $limit = 10;
        }
        if ($request->input('start')) {
            $start = $request->input('start');
        } else {
            $start = 0;
        }
        if ($request->input('order.0.columns')) {
            $order = $columns[$request->input('order.0.columns')];
        } else {
            $order = "id";
        }
        if ($request->input('order.0.dir')) {
            $dir = $request->input('order.0.dir');
        } else {
            $dir = "desc";
        }
        $query = DprGaSalesReport::query();
        if ($fromDate) {
            //print "Here"; exit;
            $query = $query->where('input_date', '>=', "$fromDate");
            //$query = $query->where('start_date_time', 'LIKE', "'%{$fromDate}%'");
        }
        if ($toDate) {
            //print "here"; exit;
            $newdate = date("Y-m-d", strtotime('+1 day', strtotime($toDate)));
            $query = $query->where('input_date', '<=', "$newdate");
            //$query = $query->where('end_date_time', 'LIKE', "'%{$toDate}%'");
        }
        $totalFiltered = $query->count();
        if ($limit == -1) {
    $posts = $query->orderBy($order, $dir)->get();
} else {
    $posts = $query->offset($start)
        ->limit($limit)
        ->orderBy($order, $dir)
        ->get();

}
//print_r($posts); exit;
        $data = array();
        $icon = "fa-eye";
        $icon1 = "fa-solid fa-car";
        $title = "Attendance Details";
        $title1 = "Visit Details";
        if (!empty($posts)) {
            if ($start == 0) {
    $sl = 1;
} else {
    $sl = $start + 1;
}
            foreach ($posts as $post) {
                //print_r($post); exit;
                $nestedData['id'] = $sl;
$nestedData['input_date'] = $post->input_date;
$nestedData['ga_code'] = $post->ga_code;
$nestedData['district'] = $post->district;
$nestedData['total_sales_scm'] = $post->total_sales_scm;
$nestedData['png_domestic_sales_scm'] = $post->png_domestic_sales_scm;
$nestedData['png_commercial_sales_scm'] = $post->png_commercial_sales_scm;
$nestedData['png_industrial_sales_scm'] = $post->png_industrial_sales_scm;
$nestedData['cng_sales_scm'] = $post->cng_sales_scm;
$nestedData['conversion_factor'] = $post->conversion_factor;
$nestedData['direct_lng_sales_scm'] = $post->direct_lng_sales_scm;
$nestedData['compression_services'] = $post->compression_services;
$nestedData['agp_ga_scm'] = $post->agp_ga_scm;
$nestedData['others_scm'] = $post->others_scm;
$nestedData['domestic_sale_kg'] = $post->domestic_sale_kg;
$nestedData['commercial_sale_kg'] = $post->commercial_sale_kg;
$nestedData['industrial_sale_in_kg_sale_kg'] = $post->industrial_sale_in_kg_sale_kg;
$nestedData['total_sale_luag_finance'] = $post->total_sale_luag_finance;
$nestedData['sale_domestic_commercial'] = $post->sale_domestic_commercial;
$nestedData['storage_tank_closing_stock_kl'] = $post->storage_tank_closing_stock_kl;
$nestedData['storage_tank_closing_stock_kg'] = $post->storage_tank_closing_stock_kg;
$nestedData['actual_closing_stock_scm'] = $post->actual_closing_stock_scm;
$nestedData['actual_closing_stock_kg'] = $post->actual_closing_stock_kg;
$nestedData['cumulative_line_pack_kg'] = $post->cumulative_line_pack_kg;
$nestedData['total_receipt_scm'] = $post->total_receipt_scm;
$nestedData['total_receipt_kg'] = $post->total_receipt_kg;
$nestedData['actual_closing_stock_SPN_SCM'] = $post->actual_closing_stock_SPN_SCM;
$nestedData['actual_closing_stock_SPN_KG'] = $post->actual_closing_stock_SPN_KG;
$nestedData['actual_closing_stock_SPN_CLPK'] = $post->actual_closing_stock_SPN_CLPK;
$nestedData['total_receipt_USM_SCM'] = $post->total_receipt_USM_SCM;
$nestedData['total_receipt_USM_KG'] = $post->total_receipt_USM_KG;
$data[] = $nestedData;
$sl++;
            }
        }
        $json_data = array(
            "draw" => intval($request->input('draw')),
            "recordsTotal" => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data" => $data,
        );

        /* $CGDRecoData = DprDistrictCNGReport::
        $finalData = array(); */
        return view('dpr.districtWiseSalesReport', ['finalData' => $data]);
    }

    public function dprPELinePack(Request $request)
    {
        $user = auth()->user();
        if (Auth::check()) {
            $allDPRLinePackData = DPRPELinePack::all();
            $ga = dd_masters("ga", "ga_code");
            $district = dd_masters("district", "address_district");
            $networks = MasterNetworks::where('category', 'PE')->get();
            return view('dpr.dprPELinePack', ['ga' => $ga, 'district' => $district, 'allDPRLinePackData' => $allDPRLinePackData, 'networks' => $networks]);
        } else {
            return redirect("/")->withSuccess('Opps! You do not have access');

        }
    }

    public function postdprPELinePack(Request $request)
    {
        $alldata = $request->all();
        //print_r($alldata); exit;
        $checkDuplicateCount = DPRPELinePack::where('date', $alldata['date'])->where('network', $alldata['network'])->count();
        if($checkDuplicateCount>=1){
            return back()->with(["status" => 200, "msg" => "Duplicate Entry.", "code" => config("constants.CODE_ERROR")]);
        }
        $data = array(
            "userId" => $alldata['user_id'],
            "district" => $request->district,
            "date" => $request->date,
            "network" => $request->network,
            "weighted_average_correction_factor" => $request->weighted_average_correction_factor,
            "nominal_wall_thickness" => $request->nominal_wall_thickness,
            "pipe_line_length" => $request->pipe_line_length,
            "pressure" => $request->pressure,
            "temperature" => $request->temperature,
            "specific_gravity" => $request->specific_gravity,
            "calculated_line_id" => $request->calculated_line_id,
            "physical_actual_volume" => $request->physical_actual_volume,
            "calculated_temp" => $request->calculated_temp,
            "calculated_actual_compressibility_factor" => $request->calculated_actual_compressibility_factor,
            "calculated_standard_volume" => $request->calculated_standard_volume,
        );

        $create = DPRPELinePack::insert($data);
        if ($create) {
            return back()->with(["status" => 200, "msg" => "Data inserted successfully.", "code" => config("constants.CODE_SUCCESS")]);
        }

    }

    public function dprSteelLinePack(Request $request)
    {
        $user = auth()->user();
        if (Auth::check()) {
            $allDPRLinePackData = DPRSteelLinePack::all();
            $ga = dd_masters("ga", "ga_code");
            $district = dd_masters("district", "address_district");
            return view('dpr.dprSteelLinePack', ['ga' => $ga, 'district' => $district, 'allDPRLinePackData' => $allDPRLinePackData]);
        } else {
            return redirect("/")->withSuccess('Opps! You do not have access');

        }
    }

    public function postDprSteelLinePack(Request $request)
    {
        $alldata = $request->all();
        //print_r($alldata); exit;
        $checkDuplicateCount = DPRSteelLinePack::where('date', $alldata['date'])->where('network', $alldata['network'])->count();
        if($checkDuplicateCount>=1){
            return back()->with(["status" => 200, "msg" => "Duplicate Entry.", "code" => config("constants.CODE_ERROR")]);
        }
        $data = array(
            "userId" => $alldata['user_id'],
            "district" => $request->district,
            "date" => $request->date,
            "network" => $request->network,
            "weighted_average_correction_factor" => $request->weighted_average_correction_factor,
            "nominal_wall_thickness" => $request->nominal_wall_thickness,
            "pipe_line_length" => $request->pipe_line_length,
            "pressure" => $request->pressure,
            "temperature" => $request->temperature,
            "specific_gravity" => $request->specific_gravity,
            "calculated_line_id" => $request->calculated_line_id,
            "physical_actual_volume" => $request->physical_actual_volume,
            "calculated_temp" => $request->calculated_temp,
            "calculated_actual_compressibility_factor" => $request->calculated_actual_compressibility_factor,
            "calculated_standard_volume" => $request->calculated_standard_volume,
        );

        $create = DPRSteelLinePack::insert($data);
        if ($create) {
            return back()->with(["status" => 200, "msg" => "Data inserted successfully.", "code" => config("constants.CODE_SUCCESS")]);
        }

    }
    public function overAllGasRecoReport(Request $request)
    {
        $user = auth()->user();
        $user_details = $request->input();
        if (Auth::check()) {
            $ga = dd_masters("ga", "ga_code");
            $district = dd_masters("district", "address_district");
            if (isset($user_details['user_id']) && isset($user_details['date'])) {
                //print "I am here"; exit;
                //print $user_details['date']; exit;
                $searchDate = $user_details['date'];
    $data = DB::select("select * from dpr_overall_gas_reco_report where input_date='$searchDate'");
    return view('dpr.dprOverAllGasRecoReport', ['ga' => $ga, 'district' => $district, 'finalData' => $data]);
}
else{
    $data = DB::table('dpr_overall_gas_reco_report')->get()->toArray();
    return view('dpr.dprOverAllGasRecoReport', ['ga' => $ga, 'district' => $district, 'finalData' => $data]);
}
        } else {
            return redirect("/")->withSuccess('Opps! You do not have access');

        }
    }
    public function generateOverAllGasRecoReport(Request $request){
        ini_set('memory_limit', '-1');
        $user_details = $request->input();
        $data = DB::table('dpr_overall_gas_reco_report')->get();
        return view('dpr.districtWiseSalesReport', ['finalData' => $data]);
    }
    public function getWeightedAvreageCorrectionFactor(Request $request){
        $data = $request->input();
        $getWeightedAvreageCorrectionFactor = DprGCVReport::where('gcv_date_of_unloading', $data['date'])->value('gcv_conversion_factor_scm_kg');
        return $getWeightedAvreageCorrectionFactor;
    }
    public function getNominalThickness(Request $request){
        $data = $request->input();
        $nominalWallThickness = MasterNetworks::where('category', $data['category'])->where('network', $data['network'])->get();
        $nominalWallThickness = $nominalWallThickness[0]['nominal_wall_thickness'];
        return $nominalWallThickness;
    }
     public function edCompressor(Request $request)
    {
        $user = auth()->user();
        if (Auth::check()) {
            $allEDCompressor = EDCompressor::all();
            $ga = dd_masters("ga", "ga_code");
            $district = dd_masters("district", "address_district");
            return view('dpr.edCompressor', ['ga' => $ga, 'district' => $district, 'allEDCompressor' => $allEDCompressor]);
        } else {
            return redirect("/")->withSuccess('Opps! You do not have access');

        }
    }
    public function postEdCompressor(Request $request)
    {
        $alldata = $request->all();
        //print_r($alldata); exit;
        $data = array(
            "userId" => $alldata['user_id'],
             "date" => date("Y-m-d",strtotime($request->date)),
            "initial_suction_mfm" => $request->ism,
            "final_suction_mfm" => $request->fsm,
            "initial_discharge_mfm" => $request->idm,
            "final_discharge_mfm" => $request->fdm,
            "initial_fuel_consumption" => $request->ifc,
            "final_fuel_consumption" => $request->ffc,
            "specific_fuel_consumption" => $request->sfc,
            "initial_running_hours" => $request->irh,
            "final_running_hours" => $request->frh,
        );

        $create = EDCompressor::insert($data);
        if ($create) {
            return back()->with(["status" => 200, "msg" => "Data inserted successfully.", "code" => config("constants.CODE_SUCCESS")]);
        }

    }
    public function getFinalSuctionMFM(Request $request){
$date = new DateTime($request->date);
$prevDate = $date->modify("-1 days")->format('Y-m-d');
$sql = EDCompressor::where('date', $prevDate)->get();
return $sql;
    }
}
