<?php
namespace App\Http\Controllers\Survey;
  
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Session;
use App\Models\Logs;
use App\Models\User;
use App\Models\Customer;
use App\Models\SurveyAssignment;
use App\Models\SurveyDone;

use Illuminate\Support\Facades\Validator;
use Exception;
use Log;
use Illuminate\Support\Facades\Schema;
use Storage;
  
class SurveyCountController extends Controller
{
    /**
     * Write code on Method
     *
     * @return response()
     */
    public function customerList(Request $request)
    {
        $alldata=$request->all();
        if(isset($alldata['device']))
        {
            $device=$alldata['device'];
        }
        else
        {
            $device="";
        }
        if($device=="")
        {
            $assigned=SurveyAssignment::where("agp_user",$alldata['agpUser'])->count();
            $complete=SurveyAssignment::where("agp_user",$alldata['agpUser'])->where("status","Completed")->get()->toArray();
            $completed=count($complete);
            $query=SurveyAssignment::query();
            $query=$query->where("agp_user",$alldata['agpUser']);
            $customers=$query->whereIn("status",array("Pending","House Locked"))->orderBy("id","desc")->get()->toArray();
            $pending=count($customers);
            if(!empty($customers))
            {
                $dt=array();
                foreach($customers as $k=>$cus)
                {
                    $dt[$k]=$cus;
                    $dt[$k]['full_address_of_the_customer']=decryptIt($cus['full_address_of_the_customer']);
                    $dt[$k]['contact_no']=decryptIt($cus['contact_no']);
                    $dt[$k]['mobile_number']=decryptIt($cus['mobile_number']);
                    $dt[$k]['email_address']=decryptIt($cus['email_address']);
                }
                $logs = array(
                            'module' => "Survey",
                            'user' => $alldata['agpUser'],
                            'access_device' => "Mobile",
                            'called_api' => route('customerList'),
                            'called_to' => "web",
                            'request_data' => json_encode($alldata),
                            'response_data' => json_encode($dt),
                            'method_name' => "GET",
            
                        );
                $log = manageLogs($logs);
                return response()->json(["status" => 200,"code" => 1,   "msg" => "List fetched!","assigned"=>$assigned,"completed"=>$completed,"pending"=>$pending,"data"=>$dt]);
            }
            else
            {
                $logs = array(
                            'module' => "Survey",
                            'user' => $alldata['agpUser'],
                            'access_device' => "Mobile",
                            'called_api' => route('customerList'),
                            'called_to' => "web",
                            'request_data' => json_encode($alldata),
                            'response_data' => "User Not Found!",
                            'method_name' => "GET",
            
                        );
                $log = manageLogs($logs);
                return response()->json(["status" => 200,"code" => 1,"assigned"=>$assigned,"completed"=>$completed,"pending"=>$pending,  "msg" => "No Pending Survey!","data"=>array()]);
            }
        }
        else{
            $form=$request->input('formdata');
            $params = array();
            $uid=$alldata['agpUser'];
            $desig=User::where("userId",$uid)->value("role");
            $ga=User::where("userId",$uid)->value("ga");
            parse_str($form, $params);
            $query = SurveyAssignment::query();
            if($desig=="Super Admin" || $desig=="Admin")
            {
                $query = $query;
            }
            else
            {
                $cus = Customer::where("GA",$ga)->pluck("CA");
                $query=$query->whereIn("CA",$cus);
            }
            if(!empty($params))
            {
                foreach($params as $kk=>$vall)
                {
                    if($vall!="")
                    {
                        $query=$query->where($kk,$vall);
                    }
                }
            }
            $columns = [ 'assignment_id','agp_user','ca','name_of_the_customer', 'contact_no', 'customer_email',  'meter_serial_no', 'installation_no', 'application_no'];
            $totalData = SurveyAssignment::count();
            $totalFiltered = $totalData;
            $limit = $request->input('length');
            $start = $request->input('start');
            $order = $columns[$request->input('order.0.column')];
            $dir = $request->input('order.0.dir');
            if(!empty($request->input('search.value')))
            {
                $search = $request->input('search.value'); 
                 $query = $query->where(function ($query) use ($search) {
              $query-> where('name_of_the_customer', 'LIKE',"%{$search}%")
                    ->orWhere('application_no', 'LIKE',"%{$search}%") 
                    ->orWhere('ca', 'LIKE',"%{$search}%") 
                    ->orWhere('installation_no', 'LIKE',"%{$search}%") 
                    ->orWhere('meter_serial_no', 'LIKE',"%{$search}%");
                 });
            }
            $totalFiltered= $query->count();
            if ($limit== -1){
                    $posts = $query->orderBy($order,$dir)
                    ->get();   
                }
                else{
                   $posts = $query->offset($start)
                            ->limit($limit)
                            ->orderBy($order,$dir)
                            ->get(); 
                }
                if (!empty($posts)) { 
                    
                        $i=0;
                        foreach ($posts as $post) {
                            $i++;
                        $show=$extrarole="";
                        $nestedData["slno"]=$i;  
                        $nestedData["assignment_id"]=$post->assignment_id;  
                        $nestedData["agp_user"]=$post->agp_user;  
                        $nestedData['ca']=$post->ca;
                        $nestedData['name_of_the_customer'] = $post->name_of_the_customer;
                        $nestedData['contact_no'] = decryptIt($post->contact_no);
                        $nestedData['customer_email'] = decryptIt($post->customer_email);
                        $nestedData['meter_serial_no'] = $post->meter_serial_no;
                        $nestedData['installation_no'] = $post->installation_no;
                        $nestedData['application_no'] = $post->application_no;
                        $data[] = $nestedData;
                        }
                    }
        
                    $json_data = array(
                    "draw" => intval($request->input('draw')),
                    "recordsTotal" => intval($totalData),
                    "recordsFiltered" => intval($totalFiltered),
                    "data" => $data,);
                    echo json_encode($json_data);
                
        }
    }
    public function postSurvey(Request $request)
    {
        $alldata=$request->all();
        $user=User::where("userId",$alldata['agp_user'])->value("userId");
        if($user)
        {
            if($request->hasfile('meter_photo'))
            {
                /*if(isset($agp["meter_photo"]))
                {
                    if(File::exists(public_path('agp/meter_photo/'.$agp["meter_photo"]))){
                        File::delete(public_path('agp/meter_photo/'.$agp["meter_photo"]));
                    }
                }*/
                $alldata['meter_photo']=uploadDoc("agp/meter_photo",$request->meter_photo,"meter_photo".$alldata['ca']);
            }
            if($request->hasfile('site_photo'))
            {
                $alldata['site_photo']=uploadDoc("agp/site_photo",$request->site_photo,"site_photo".$alldata['ca']);
            }
            if($request->hasfile('house_photo'))
            {
                $alldata['house_photo']=uploadDoc("agp/house_photo",$request->house_photo,"house_photo".$alldata['ca']);
            }
            if($request->hasfile('gc_photo'))
            {
                $alldata['gc_photo']=uploadDoc("agp/gc_photo",$request->gc_photo,"gc_photo".$alldata['ca']);
            }
            if($request->hasfile('kitchen_photo'))
            {
                $alldata['kitchen_photo']=uploadDoc("agp/kitchen_photo",$request->kitchen_photo,"kitchen_photo".$alldata['ca']);
            }
            if($alldata['connection_status']=="House Locked")
            $status="House Locked";
            else
            $status="Completed";
            $create = SurveyDone::insertGetId($alldata); 
            if($create)
            {
                $crt = SurveyAssignment::where("id",$alldata['survey_assignment_id'])->update(array("status"=>$status)); 
                $logs = array(
                            'module' => "Survey",
                            'user' => $alldata['agp_user'],
                            'access_device' => "Mobile",
                            'called_api' => route('postSurvey'),
                            'called_to' => "web",
                            'request_data' => json_encode($alldata),
                            'response_data' => json_encode($alldata),
                            'method_name' => "POST",
            
                        );
                $log = manageLogs($logs);
                return response()->json(["status" => 200,"code" => 1,   "msg" => "Survey done","data"=>json_encode($alldata)]);
            }
            else
            {
                $logs = array(
                            'module' => "Survey",
                            'user' => $alldata['agp_user'],
                            'access_device' => "Mobile",
                            'called_api' => route('postSurvey'),
                            'called_to' => "web",
                            'request_data' => json_encode($alldata),
                            'response_data' => "Failed",
                            'method_name' => "POST",
            
                        );
                $log = manageLogs($logs);
                return response()->json(["status" => 200,"code" => 0,   "msg" => "Failed. Please try again!"]);
            }
        
        }
        else
        {
            $logs = array(
                        'module' => "Survey",
                        'user' => $alldata['agp_user'],
                        'access_device' => "Mobile",
                        'called_api' => route('postSurvey'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => "Failed",
                        'method_name' => "POST",
        
                    );
            $log = manageLogs($logs);
            return response()->json(["status" => 200,"code" => 0,   "msg" => "Invalid user!"]);
        }
    }
    public function getCompletedSurvey(Request $request)
    {
        $alldata=$request->all();
        $form=$request->input('formdata');
        $params = array();
        if(isset($request->device))
        {
            $device=$request->device;
        }
        else
        {
            $device="";
        } 
        $uid=$alldata['userId'];
        $desig=User::where("userId",$uid)->value("role");
        $ga=User::where("userId",$uid)->value("ga");
        parse_str($form, $params);
        $query = SurveyDone::query();
        /*if($desig=="Super Admin" || $desig=="Admin")
        {
            $query = $query;
        }
        else
        {
            $query=$query->where("GA",$ga);
        }*/
        //echo $query->toSql();
        if(!empty($params))
        {
            foreach($params as $kk=>$vall)
            {
                if($vall!="")
                {
                    $query=$query->where($kk,$vall);
                }
            }
        }
        if($device=="web") 
        {
            $columns = ['assignment_id', 'ca', 'agp_user', 'customer_name', 'customer_mobile', 'customer_email', 'rent_or_own', 'customer_address', 'connection_status', 'meter_no', 'meter_reading', 'meter_photo', 'site_photo', 'house_photo', 'gc_photo', 'geyser_connection', 'tube_status', 'date_visibility', 'created_at', 'survey_assignment_id', 'kitchen_photo'];
            $totalData = SurveyDone::count();
            $totalFiltered = $totalData;
            $limit = $request->input('length');
            $start = $request->input('start');
            $order = $columns[$request->input('order.0.column')];
            $dir = $request->input('order.0.dir');
             if(!empty($request->input('search.value')))
             {
                $search = $request->input('search.value'); 
                 $query = $query->where(function ($query) use ($search) {
              $query-> where('assiggnment_id', 'LIKE',"%{$search}%")
                    ->orWhere('agp_user', 'LIKE',"%{$search}%") 
                    ->orWhere('ca', 'LIKE',"%{$search}%") 
                    ->orWhere('customer_name', 'LIKE',"%{$search}%")
                    ->orWhere('customer_address', 'LIKE',"%{$search}%")
                    ->orWhere('connection_status', 'LIKE',"%{$search}%");
                 });
             }
            $totalFiltered= $query->count();
            if ($limit== -1){
                    $posts = $query->orderBy($order,$dir)
                    ->get();   
                }
                else{
                   $posts = $query->offset($start)
                            ->limit($limit)
                            ->orderBy($order,$dir)
                            ->get(); 
                }
            
        }
        else
        { 
            $posts = $query->get()->toArray();
        }
        $data = array();
        if (!empty($posts)) {
            if($device=="")
            {
                $data=$posts;
            }
            else
            {
                $i=0;
                foreach ($posts as $post) {
                    $i++;
                //$show = route('retailer.delete', $post->id);
                $path=url("uploads/");
                //echo $path;exit;
                $show=$extrarole="Assign";
                $nestedData["slno"]=$i;  
				$nestedData["assignment_id"]=$post->assignment_id;  
                $nestedData['surveyor']=$post->agp_user;
                $nestedData['ca'] = $post->ca;
                $nestedData['customer_name'] = $post->customer_name;
                $nestedData['customer_mobile'] = $post->customer_mobile;
                $nestedData['customer_email'] = $post->customer_email;
                $nestedData['customer_address'] = $post->customer_address;
                $nestedData['connection_status'] = $post->connection_status;
                $nestedData['meter_no'] = $post->meter_no;
                $nestedData['meter_reading'] = $post->meter_reading;
                if($post->meter_photo)
                $meter_photo="<a href='".$path."/agp/meter_photo/".$post->meter_photo."' target='_blank'>".$post->meter_photo."</a>";
                else
                $meter_photo="";
                if($post->site_photo)
                $site_photo="<a href='".$path."/agp/site_photo/".$post->site_photo."' target='_blank'><img src='".$path."/agp/site_photo/".$post->site_photo."' width='50' height='50' alt='".$post->site_photo."' /></a>";
                else
                $site_photo="";
                if($post->house_photo)
                $house_photo="<a href='".$path."/agp/house_photo/".$post->house_photo."' target='_blank'><img src='".$path."/agp/house_photo/".$post->house_photo."' width='50' height='50' alt='".$post->house_photo."' /></a>";
                else
                $house_photo="";
                if($post->gc_photo)
                $gc_photo="<a href='".$path."/agp/gc_photo/".$post->gc_photo."' target='_blank'><img src='".$path."/agp/gc_photo/".$post->gc_photo."' width='50' height='50' alt='".$post->gc_photo."' /></a>";
                else
                $gc_photo="";
                if($post->kitchen_photo)
                $kitchen_photo="<a href='".$path."/agp/kitchen_photo/".$post->kitchen_photo."' target='_blank'><img src='".$path."/agp/kitchen_photo/".$post->kitchen_photo."' width='50' height='50' alt='".$post->kitchen_photo."' /></a>";
                else
                $kitchen_photo="";
                $nestedData['meter_photo'] = $meter_photo;
                $nestedData['site_photo'] =  $site_photo;
                $nestedData['house_photo'] = $house_photo;
                $nestedData['gc_photo'] = $gc_photo;
                $nestedData['geyser_connection'] = $post->geyser_connection;
                $nestedData['tube_status'] = $post->tube_status;
                $nestedData['date_visibility'] = $post->date_visibility;
                $nestedData['created_at'] = $post->created_at;
                $nestedData['survey_assignment_id'] = $post->survey_assignment_id;
                $nestedData['kitchen_photo'] = $kitchen_photo;
                
                $nestedData['options'] =$show;
                $data[] = $nestedData;
                }
            }
        }
        if(!empty($data))
        {
            if($device=="web")
            {
                $json_data = array(
                "draw" => intval($request->input('draw')),
                "recordsTotal" => intval($totalData),
                "recordsFiltered" => intval($totalFiltered),
                "data" => $data,);
                echo json_encode($json_data);
            }
            else
            {
                $logs = array(
                            'module' => "Survey",
                            'user' => $alldata['userId'],
                            'access_device' => $device,
                            'called_api' => route('surveyDone'),
                            'called_to' => "web",
                            'request_data' => json_encode($alldata),
                            'response_data' => json_encode($data),
                            'method_name' => "POST",
            
                        );
                $log = manageLogs($logs);
                return response()->json(["status" => config("constants.OK"),"code" => 1, "msg" => "Survey Done Fetched!", "data"=>$data]);
            }
        }
        else
        {
            if($device=="web")
            {
                $json_data = array(
                "draw" => intval($request->input('draw')),
                "recordsTotal" => intval($totalData),
                "recordsFiltered" => intval($totalFiltered),
                "data" => $data,);
                echo json_encode($json_data);
            }
            else
            {
                $logs = array(
                            'module' => "Survey",
                            'user' => $alldata['userId'],
                            'access_device' => $device,
                            'called_api' => route('surveyDone'),
                            'called_to' => "web",
                            'request_data' => json_encode($alldata),
                            'response_data' => "No Data Found!",
                            'method_name' => "POST",
            
                        );
                $log = manageLogs($logs);
                return response()->json(["status" => config("constants.OK"),"code" => 0, "msg" => "No Data Found!"]);
            }
        }


    }
}
