@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">Daily MIS Report</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">Daily MIS Report Sheet</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
           
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
             $myga=anyFiled("User","ga",Auth::user()->id);
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 mt-2 text-white pull-left" id="gaDistrictInputname">Daily MIS Report Sheet</h4>
                </div>
                <form id="form-filter" class="form-horizontal" action="{{ route('cngPurchaseInput.post') }}" method="POST">
                     {{ csrf_field() }}
                    <input type="hidden" name="device" value="web">
                    <input type="hidden" name="user_id" value="{{Auth::user()->userId}}">
                    <div class="card-body">
                        <div class="form-body">
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <label class="form-label">GA</label>
                                            <select name="ga_code" id="ga_code"  class="form-control form-select" data-placeholder="Choose a GA">
                                                <option  value="">Please Select GA</option>
                                                @foreach($ga as $k=>$v)
                                                     @if($myga==$k)
                                                    <option value="{{$k}}">{{$v}} ({{$k}})</option>
                                                    @elseif($myga=="All")
                                                     <option value="{{$k}}">{{$v}} ({{$k}})</option>
                                                    @endif
                                                @endforeach
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <label class="form-label">Date</label>
                                            <input type="date" name="input_date" id="input_date"  class="form-control">
                                        </div>
                                    </div>
                                </div>
                            <div> &nbsp;</div>
                        </div>
                        <table id="customers" class="table table-bordered table-striped"  style="display:none;">
                            <thead>
                            <tr>
                                    <th></th>
                                    <th colspan="2">SCM </th>
                                    <th colspan="3">CNG Sales in SCM</th>
                                    <th>Total Sales  in SCM</th>
                                    <th colspan="2">MTD</th>
                                    <th colspan="2">YTD</th>
                                </tr>
                                <tr>
                                    <th>Date</th>
                                    <th>Purchase</th>
                                    <th>PNG-Sales</th>
                                    <th>CNG- Sales to DBS</th>
                                    <th>Dispenser Sales (MS)</th>
                                    <th>CNG Sales MP line</th>
                                    <th>Total Sales (PNG+CNG)</th>
                                    <th>Purchas</th>
                                    <th>Sales </th>
                                    <th>Purchas</th>
                                    <th>Sales </th>
                                </tr>
                            </thead>
                            <tbody id="new_data">
                            </tbody>
                        </table>     
                    </div>
                </form>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>
function load_it(ga_code,district)
{
    $("#customers").show();
     $.ajax({
            url: "{{url('api/getDailyMisReport')}}",
            type: "POST",
            data: {
             ga_code:ga_code,input_date:input_date, "device":"web",
                _token: '{{csrf_token()}}'
            },
            dataType: 'json',
            success: function (result) {
                console.log(result);
                $("#customers").dataTable().fnDestroy();
                $("#new_data").html(result);
                var table =  new DataTable('#customers', {  
                    dom: 'rti',
                    order:[0,"asc"],
                    scrollX:true,
                    scrollCollapse: true,
                    scrollY: '65vh',
                    autoWidth: true,
                 });
        }
    });
}

$(document).on("keyup","[id^='qty_']",function()
{
    var qty_c=$("#qty_c").val();
    var qty_d=$("#qty_d").val();
    if(qty_c=="" || qty_d=="" || qty_c==0 || qty_d==0)var v=0;
    else
    var v=parseFloat(qty_d)/parseFloat(qty_c);
   // alert(v);
    $("#CF").val(v);
});

$(document).on("blur","#qty_d",function()
{
    var MCV_Loading_Date=$("#MCV_Loading_Date").val();
    if(MCV_Loading_Date!="")
    {
     var form=$("#form-filter");
    $.ajax({
            url:form.attr("action"),
            data:$("#form-filter").serialize(),//only input
            type: "POST",
            Type: 'json',
            success: function (result) {
                if(result=="Success")
                {
                    $.toast({
                    heading: 'AG&P Pratham',
                    position: 'top-right',
                    loaderBg:'#ff6849',
                   hideAfter: 3500, 
                    stack: 6,
                     icon: 'success',
                    text: "Data submitted successfully!"
                  });
                }
                if(result=="Failed")
                {
                    $.toast({
                    heading: 'AG&P Pratham',
                    position: 'top-right',
                    loaderBg:'#ff6849',
                    hideAfter: 3500, 
                    stack: 6,
                    icon: 'error',
                    text: "Failed! Please try again!"
                  });
                }
               load_it();
            }
        });   
    }
    
});

$(document).on("change","#ga_code",function()
{
    var ga_code=$(this).val();
    var input_date=$("#input_date").val();
    load_it(ga_code,input_date);
})

</script>
@endpush