@extends('layout')
@section('content')
    <div class="container-fluid">
        <div class="row page-titles">
            <div class="col-md-12">
                <h4 class="text-white">Density Data</h4>
            </div>
            <div class="col-md-6">
                <ol class="breadcrumb justify-content-end">
                    <li class="breadcrumb-item"><a href="{{ route('dashboard') }}">Home</a></li>
                    <li class="breadcrumb-item active">Density Data</li>
                </ol>
            </div>
            <div class="col-md-6 text-end">
                <!--<form class="app-search d-none d-md-block d-lg-block">
                    <input type="text" class="form-control" placeholder="Search &amp; enter">
                </form>-->
            </div>
        </div>
        <!-- ============================================================== -->
        <!-- End Bread crumb and right sidebar toggle -->
        <!-- ============================================================== -->
        <!-- ============================================================== -->
        <!-- Start Page Content -->
        <!-- ============================================================== -->
        <!-- Row -->
        <?php //print Session::get('code'); exit;
?>
        @php
            $success = '';
            $error = '';
            if (Session::has('msg') && Session::has('code')) {
                if (Session::get('code') == 1) {
                    $success = Session::get('msg');
                } else {
                    $error = Session::get('msg');
                }
            }
        @endphp
        <div class="row">
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-body">
                        <div style="color:red; font-weight:bold;">{{ isset($msg) ? $msg : '' }}</div>
                        <form name="registration" action="{{ route('postDensityData') }}" method="POST"
                            class="needs-validation" novalidate>
                            {{ csrf_field() }}
                            <div class="form-body">
                                <h3 class="card-title">Density Data</h3>
                                <hr>
                                <input type="hidden" name="device" value="web">
                                <input type="hidden" name="user_id" value="{{ Auth::user()->userId }}">

                                <div class="row">
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Tanker Loading Date</label>
                                            <input type="date" name="tanker_loading_date" id="tanker_loading_date"
                                                required="true" class="form-control">
                                        </div>
                                    </div>
                                    <!--/span-->
                                    @php
                                    $source=dd_masters("source","source_code");
                                    @endphp
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Source</label>
                                            <select  name="source" class="form-control" required="true" >
                                                <option value="">Please select Source</option>
                                                @foreach($source as $k=>$v)
                                                <option value="{{$k}}">{{$v}}</option>
                                                @endforeach
                                                </select>
                                        </div>
                                    </div>
                                     @php
                                    $gastype=dd_masters("gastype","gastype_code");
                                    @endphp
                                     <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Gas Type</label>
                                           
                                            <select  name="type" class="form-control" required="true" >
                                                <option value="">Please select Gas Type</option>
                                                @foreach($gastype as $k=>$v)
                                                <option value="{{$k}}">{{$v}}</option>
                                                @endforeach
                                                </select>
                                        </div>
                                    </div>
                                    <!--/span-->
                                </div>
                                <div class="row">
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Tanker Unloading Date</label>
                                            <input type="date" name="tanker_unloading_date" id="tanker_unloading_date"
                                                required="true" class="form-control" value="">
                                        </div>
                                    </div>
                                    <!--/span-->
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Invoice Qty in KG</label>
                                            <input type="number" name="invoice_quantity" id="invoice_quantity"  step="0.001" class="form-control invoice_data" value="" required="true" />
                                        </div>
                                    </div>
                                     <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">MMBTU Cross</label>
                                            <input type="number" name="mmbtu_cross" step="0.001" class="form-control"  />
                                        </div>
                                    </div>
                                    <!--/span-->
                                </div>
                                <div class="row">
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Invoice Value</label>
                                            <input type="number" name="invoice_value" id="invoice_value"
                                                required="true" step="0.001" placeholder="" class="form-control invoice_data" value="" />
                                        </div>
                                    </div>
                                    <!--/span-->
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">RS/KG</label>
                                            <input type="number" name="rs_kg" class="form-control" step="0.001" id="rs_kg" value="" required="true" readonly />
                                        </div>
                                    </div>
                                     <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Methane Percentage</label>
                                            <input type="text" name="methane_percentage" class="form-control" value="" required="true" />
                                        </div>
                                    </div>
                                    <!--/span-->
                                </div>
                                <div class="row">
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">MMBTU per MT</label>
                                            <input type="number" name="mmbtu_per_mt" step="0.001" id="mmbtu_per_mt"
                                                required="true" placeholder="" class="form-control"
                                                value="">
                                        </div>
                                    </div>
                                    <!--/span-->
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Tank</label>
                                            <input type="text" name="tank" class="form-control" value="" required="true" />
                                        </div>
                                    </div>
                                    @php
                                    $tankerno=dd_masters("tankerno","tankerno_code");
                                    @endphp
                                     <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Tanker Number</label>
                                           
                                            <select  name="tanker_no" class="form-control" required="true" required>
                                                <option value="">Please select Tanker No</option>
                                                @foreach($tankerno as $k=>$v)
                                                <option value="{{$k}}">{{$v}}</option>
                                                @endforeach
                                                </select>
                                        </div>
                                    </div>
                                    <div class="col-md-4 p-t-30">
                                <button type="submit" name="submit" id="submit" value="Submit"
                                    class="btn btn-primary text-white"> <i class="fa fa-check"></i> Save</button>
                                <button type="reset" class="btn btn-secondary">Reset</button>
                                    </div>
                                    <!--/span-->
                                </div>

                            </div>
                        </form>
                        <!--Table Data-->
                            <div class="fixed-table-body"
                                style="overflow-x: scroll; overflow-y: auto; padding-bottom:20px; padding-right:10px;">
                                <table id="ga_log_entry" class="table table-bordered table-striped nowrap"
                                    data-show-columns="true" data-height="300">
                                    <thead>
                                        <tr>
                                            <th>SL#</th>
                                            <th>Loading Date</th>
                                            <th>Source</th>
                                            <th>Type</th>
                                            <th>Unloading Date</th>
                                            <th>Invoice Quantity</th>
                                            <th>MMBTU Cross</th>
                                            <th>Invoice Value</th>
                                            <th>RS/KG</th>
                                            <th>Methane Percentage</th>
                                            <th>MMBTU Per Mt</th>
                                            <th>Tank</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @if (!empty($allDensityData))
                                            @foreach ($allDensityData as $key => $value)
                                                <tr>
                                                    <td>{{ $loop->iteration }}</td>
                                                    <td>{{ $value['tanker_loading_date'] }}</td>
                                                    <td>{{ $value['source'] }}</td>
                                                    <td>{{ $value['type'] }}</td>
                                                    <td>{{ $value['tanker_unloading_date'] }}</td>
                                                    <td>{{ $value['invoice_quantity'] }}</td>
                                                    <td>{{ $value['mmbtu_cross'] }}</td>
                                                    <td>{{ $value['invoice_value'] }}</td>
                                                    <td>{{ $value['rs_kg'] }}</td>
                                                    <td>{{ $value['methane_percentage'] }}</td>
                                                    <td>{{ $value['mmbtu_per_mt'] }}</td>
                                                    <td>{{ $value['tank'] }}</td>
                                                </tr>
                                            @endforeach
                                        @endif
                                    </tbody>
                                </table>
                            </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- Row -->
    </div>
@endsection
@push('custom-scripts')
@endpush
<!-- Include jQuery -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<!-- Include Select2 JavaScript -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/js/select2.min.js"></script>
<script>
$(document).ready(function()
{
    var table =  new DataTable('#ga_log_entry', {  
                    dom: 'rti',
                    order:[1,"asc"],
                    scrollX:true,
                    scrollCollapse: true,
                    scrollY: '65vh',
                    autoWidth: true,
                 });
})
    $(document).ready(function() {
        $('.select2').select2({
            placeholder: "Select an option",
            allowClear: true // Add this if you want the "x" button to clear the selected option
        });
        $(".invoice_data").keyup(function(){
            var invoice_quantity = $("#invoice_quantity").val();
            var invoice_value = $("#invoice_value").val();
            invoice_quantity = parseFloat(invoice_quantity) || 0; // Default to 0 if empty
            invoice_value = parseFloat(invoice_value) || 0; // Default to 0 if empty
            var rs_kg = invoice_value / invoice_quantity;
            rs_kg = rs_kg.toFixed(3)
            if($.isNumeric(rs_kg)){
                $("#rs_kg").val(rs_kg);
            }
            else{
                $("#rs_kg").val(0);
            }
            //console.log(rs_kg);
        })
    });
</script> 
