@extends('layout')
@section('content')
    <script src="{{ asset('js/unAccountedKnownLoss.js') }}" defer></script>
    <div class="container-fluid">
        <div class="row page-titles">
            <div class="col-md-12">
                <h4 class="text-white">Jambusar Barmer Loading</h4>
            </div>
            <div class="col-md-6">
                <ol class="breadcrumb justify-content-end">
                    <li class="breadcrumb-item"><a href="{{ route('dashboard') }}">Home</a></li>
                    <li class="breadcrumb-item active">Jambusar Barmer Loading</li>
                </ol>
            </div>
            <div class="col-md-6 text-end">
                <!--<form class="app-search d-none d-md-block d-lg-block">
                    <input type="text" class="form-control" placeholder="Search &amp; enter">
                </form>-->
            </div>
        </div>
        <!-- ============================================================== -->
        <!-- End Bread crumb and right sidebar toggle -->
        <!-- ============================================================== -->
        <!-- ============================================================== -->
        <!-- Start Page Content -->
        <!-- ============================================================== -->
        <!-- Row -->
        <?php //print Session::get('code'); exit;
?>
        @php
            $success = '';
            $error = '';
            if (Session::has('msg') && Session::has('code')) {
                if (Session::get('code') == 1) {
                    $success = Session::get('msg');
                } else {
                    $error = Session::get('msg');
                }
            }
            $myga=anyFiled("User","ga",Auth::user()->id);
        @endphp
        <div class="row">
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-body">
                        <div style="color:red; font-weight:bold;">{{ isset($msg) ? $msg : '' }}</div>
                        <form name="registration" action="{{ route('postDprJambusarBarmerLoading') }}" method="POST"
                            class="needs-validation" novalidate>
                            {{ csrf_field() }}
                            <div class="form-body">
                                <h3 class="card-title">Jambusar Barmer Loading</h3>
                                <hr>
                                <input type="hidden" name="device" value="web">
                                <input type="hidden" name="user_id" value="{{ Auth::user()->userId }}">
                                <div class="row">
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Date</label>
                                            <input type="date" name="date" id="date"
                                                required="true" class="form-control">
                                        </div>
                                    </div>
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Vehicle Number</label>
                                            <input type="text" name="vehicle_number" id="vehicle_number"
                                                required="text" class="form-control calculation" value="">
                                        </div>
                                    </div>
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Product</label>
                                            <input type="text" name="product" id="product"
                                                required="text" class="form-control calculation" value="">
                                        </div>
                                    </div>
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Source</label>
                                            <input type="text" name="source" id="source"
                                                required="text" class="form-control calculation" value="">
                                        </div>
                                    </div>
                                
                                </div>
                                
                                <div class="row">
                                    <!--/span-->
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Initial Reading</label>
                                            <input type="text" name="initial_reading" id="initial_reading" class="form-control calculation" value="" required="true" />
                                        </div>
                                    </div>
                                     <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Final Reading</label>
                                            <input type="text" name="final_reading" id="final_reading" class="form-control calculation" value="" required="true" />
                                        </div>
                                    </div>
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <label class="form-label">Actual Net Weight</label>
                                            <input type="text" name="actual_net_weight" id="actual_net_weight" class="form-control calculation" value="" required="true" />
                                        </div>
                                    </div>
                                    <div class="col-md-4 p-t-30">
                                <button type="submit" name="submit" id="submit" value="Submit"
                                    class="btn btn-primary text-white"> <i class="fa fa-check"></i> Save</button>
                                <button type="reset" class="btn btn-secondary">Reset</button>
                                    </div>
                                </div>
                        </form>
                        <!--Table Data-->
                            <div class="fixed-table-body"
                                style="overflow-x: scroll; overflow-y: auto; padding-bottom:20px; padding-right:10px;">
                                <table id="ga_log_entry" class="table table-bordered table-striped nowrap"
                                    data-show-columns="true" data-height="300">
                                    <thead>
                                        <tr>
                                            <th>SL#</th>
                                            <th>User</th>
                                            <th>Date</th>
                                            <th>Vehicle Number</th>
                                            <th>Product</th>
                                            <th>Source</th>
                                            <th>Initial Reading</th>
                                            <th>Final reading</th>
                                            <th>Actual Net Weight(Kg)</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @if (!empty($allUnAccountedKnownGasLossData))
                                            @foreach ($allUnAccountedKnownGasLossData as $key => $value)
                                                <tr>
                                                    <td>{{ $loop->iteration }}</td>
                                                    <td>{{ $value['user_id'] }}</td>
                                                    <td>{{ $value['date'] }}</td>
                                                    <td>{{ $value['vehicle_number'] }}</td>
                                                    <td>{{ $value['product'] }}</td>
                                                    <td>{{ $value['source'] }}</td>
                                                    <td>{{ $value['initial_reading'] }}</td>
                                                    <td>{{ $value['final_reading'] }}</td>
                                                    <td>{{ $value['actual_weight'] }}</td>
                                                </tr>
                                            @endforeach
                                        @endif
                                    </tbody>
                                </table>
                            </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- Row -->
    </div>
@endsection
@push('custom-scripts')
@endpush
<!-- Include jQuery -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<!-- Include Select2 JavaScript -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/js/select2.min.js"></script>
<script>
    $(document).ready(function() {
        $(".calculation").keyup(function(){
            var final_reading = $("#final_reading").val();
            var initial_reading = $("#initial_reading").val();
            final_reading = parseFloat(final_reading) || 0; // Default to 0 if empty
            initial_reading = parseFloat(initial_reading) || 0; // Default to 0 if empty
            let calculated_val = final_reading-initial_reading;
            $("#actual_net_weight").val(calculated_val.toFixed(2));
        });
        $(document).on("change","#ga_code",function()
{
    var ga_code=$(this).val();
    $.ajax({
            url: "{{url('api/getDistrict')}}",
            type: "POST",
            data: {
              ga_code:ga_code,"device":"web",
                _token: '{{csrf_token()}}'
            },
            dataType: 'json',
            success: function (result) {
            $("#district").html('<option value="">Please Select</option>');
               $.each(result, function (key, value) {
                 $("#district").append('<option value="' + key + '">' + value + '</option>');
                });
            }
        });
})
$(document).on("change","#district",function()
{
    var ga_code=$("#ga_code").val();
    var district=$(this).val();

    $("#dcuname").html("DCU "+district);
    $("#customers").show();
     $.ajax({
            url: "{{url('api/getDcu')}}",
            type: "POST",
            data: {
              district:district,ga_code:ga_code,"device":"web",
                _token: '{{csrf_token()}}'
            },
            dataType: 'json',
            success: function (result) {
                console.log(result);
             $("#new_data").html(result);
            }
        });

})
    });
</script>
