@extends('layout')
@section('content')
    <script src="{{ asset('js/unAccountedKnownLoss.js') }}" defer></script>
    <div class="container-fluid">
        <div class="row page-titles">
            <div class="col-md-12">
                <h4 class="text-white">Un Accounted Known Gas Loss</h4>
            </div>
            <div class="col-md-6">
                <ol class="breadcrumb justify-content-end">
                    <li class="breadcrumb-item"><a href="{{ route('dashboard') }}">Home</a></li>
                    <li class="breadcrumb-item active">Un Accounted Known Gas Loss</li>
                </ol>
            </div>
            <div class="col-md-6 text-end">
                <!--<form class="app-search d-none d-md-block d-lg-block">
                    <input type="text" class="form-control" placeholder="Search &amp; enter">
                </form>-->
            </div>
        </div>
        <!-- ============================================================== -->
        <!-- End Bread crumb and right sidebar toggle -->
        <!-- ============================================================== -->
        <!-- ============================================================== -->
        <!-- Start Page Content -->
        <!-- ============================================================== -->
        <!-- Row -->
        <?php //print Session::get('code'); exit;
?>
        @php
            $success = '';
            $error = '';
            if (Session::has('msg') && Session::has('code')) {
                if (Session::get('code') == 1) {
                    $success = Session::get('msg');
                } else {
                    $error = Session::get('msg');
                }
            }
            $myga=anyFiled("User","ga",Auth::user()->id);
        @endphp
        <div class="row">
            <div class="col-lg-12">
                <div class="card">
                    <div class="card-body">
                        <div style="color:red; font-weight:bold;">{{ isset($msg) ? $msg : '' }}</div>
                        <form name="registration" action="{{ route('postdprUnAccountedKnownGasLoss') }}" method="POST"
                            class="needs-validation" novalidate>
                            {{ csrf_field() }}
                            <div class="form-body">
                                <h3 class="card-title">Un Accounted Known Gas Loss</h3>
                                <hr>
                                <input type="hidden" name="device" value="web">
                                <input type="hidden" name="user_id" value="{{ Auth::user()->userId }}">
                                <div class="row">
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Date</label>
                                            <input type="date" name="date" id="date"
                                                required="true" class="form-control">
                                        </div>
                                    </div>
                                <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">GA</label>
                                            <select name="ga_code" id="ga_code"  class="form-control form-select" data-placeholder="Choose a GA">
                                                <option>Please Select GA</option>
                                                @foreach($ga as $k=>$v)
                                                @if($myga==$k)
                                                    <option value="{{$k}}">{{$v}} ({{$k}})</option>
                                                    @elseif($myga=="All")
                                                     <option value="{{$k}}">{{$v}} ({{$k}})</option>
                                                    @endif
                                                @endforeach
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-md-3">
                                        <label for="text-input" class=" form-control-label">District
                                        </label>
                                       <select name="district" id="district" class="form-control form-select">
                                        <option value="">Please select</option>

                                       </select>
                                    </div>
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Financial Year</label>
                                            <select name="financial_year" class="form-control form-select" required>
                                                <option value="">--Please select financial year--</option>
                                                <?php
// Assuming current year as the end year
$end_year = date("Y");

// Assuming financial years start from April
$start_year = 2020;

// Loop through the financial years
for ($year = $end_year; $year >= $start_year; $year--) {
    $year_str = $year . '-' . ($year + 1);
    $selected = ''; // Default option is not selected
    if (isset($_POST['financial_year']) && $_POST['financial_year'] == $year_str) {
        $selected = 'selected'; // Set 'selected' if option is selected
    }
    echo '<option value="' . $year_str . '" ' . $selected . '>' . $year_str . '</option>';
}
?>
                                            </select>
                                        </div>
                                    </div>
                                    <!--/span-->
                                </div>
                                <div class="row">
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Month</label>
                                            <select name="month" id="month" class="form-control form-select" required>
                                            <option value="">--Please select month--</option>
    <?php
// Array of month names
$months = [
    1 => 'January', 2 => 'February', 3 => 'March', 4 => 'April',
    5 => 'May', 6 => 'June', 7 => 'July', 8 => 'August',
    9 => 'September', 10 => 'October', 11 => 'November', 12 => 'December',
];

// Loop through the months
foreach ($months as $month_num => $month_name) {
    $selected = ''; // Default option is not selected
    if (isset($_POST['month']) && $_POST['month'] == $month_num) {
        $selected = 'selected'; // Set 'selected' if option is selected
    }
    echo '<option value="' . $month_num . '" ' . $selected . '>' . $month_name . '</option>';
}
?>
</select>
                                        </div>
                                    </div>

                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Known Gas losses during Unloading</label>
                                            <input type="text" name="loss_during_unloading" id="loss_during_unloading"
                                                required="text" class="form-control calculation" value="">
                                        </div>
                                    </div>

                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Approximate Losses during System Commissioning and Venting in SCM</label>
                                            <input type="text" name="approx_loss" id="approx_loss"
                                                required="text" class="form-control calculation" value="">
                                        </div>
                                    </div>
                                     <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">CNG Side Known Losses in SCM</label>
                                            <input type="text" name="cng_side_loss" id="cng_side_loss" class="form-control calculation" value="" required="true" />
                                        </div>
                                    </div>
                                    <!--/span-->
                                </div>
                                <div class="row">
                                    <!--/span-->
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Line Damage (SCM)</label>
                                            <input type="text" name="line_damage" id="line_damage"
                                                required="text" class="form-control calculation" value="">
                                        </div>
                                    </div>
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Venting/Purging Vol(SCM)</label>
                                            <input type="text" name="venting_purging_vol" id="venting_purging_vol" class="form-control calculation" value="" required="true" />
                                        </div>
                                    </div>
                                     <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Line Pack PE (SCM)</label>
                                            <input type="text" name="line_pack" id="line_pack" class="form-control calculation" value="" required="true" />
                                        </div>
                                    </div>
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Identifed Theft Vol(SCM)</label>
                                            <input type="text" name="identified_theft" id="identified_theft"
                                                required="true" placeholder="" class="form-control invoice_data calculation" value="" />
                                        </div>
                                    </div>
                                    <!--/span-->
                                </div>
                                <div class="row">
                                    <!--/span-->
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">AMC</label>
                                            <input type="text" name="amc" id="amc" class="form-control calculation" value="" required="true" />
                                        </div>
                                    </div>
                                     <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Others (SCM) (GG-SUG)</label>
                                            <input type="text" name="others" id="others" class="form-control calculation" value="" required="true" />
                                        </div>
                                    </div>
                                    <div class="col-md-3">
                                        <div class="form-group">
                                            <label class="form-label">Total Un- Accounted (SCM)</label>
                                            <input type="text" name="total_unaccounted" id="total_unaccounted"
                                                required="true" placeholder="" class="form-control calculation"
                                                value="">
                                        </div>
                                    </div>
                                    <div class="col-md-3 p-t-30">
                                <button type="submit" name="submit" id="submit" value="Submit"
                                    class="btn btn-primary text-white"> <i class="fa fa-check"></i> Save</button>
                                <button type="reset" class="btn btn-secondary">Reset</button>
                                    </div>
                                </div>
                        </form>
                        <!--Table Data-->
                            <div class="fixed-table-body"
                                style="overflow-x: scroll; overflow-y: auto; padding-bottom:20px; padding-right:10px;">
                                <table id="ga_log_entry" class="table table-bordered table-striped nowrap"
                                    data-show-columns="true" data-height="300">
                                    <thead>
                                        <tr>
                                            <th>SL#</th>
                                            <th>User</th>
                                            <th>Date</th>
                                            <th>Known Gas losses during Unloading</th>
                                           <th>Aprox. Loss</th>
                                            <th>CNG Side Known Losses in SCM</th>
                                            <th>Line Damage(SCM)</th>
                                            <th>Venting/Purging Vol(SCM)</th>
                                            <th>Line Pack PE(SCM)</th>
                                            <th>Identifed Theft Vol(SCM)</th>
                                            <th>AMC</th>
                                            <th>Others(SCM) (GG-SUG)</th>
                                            <th>Total Un- Accounted (SCM)</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @if (!empty($allUnAccountedKnownGasLossData))
                                            @foreach ($allUnAccountedKnownGasLossData as $key => $value)
                                                <tr>
                                                    <td>{{ $loop->iteration }}</td>
                                                    <td>{{ $value['user_id'] }}</td>
                                                    <td>{{ $value['date'] }}</td>
                                                    <td>{{ $value['loss_during_unloading'] }}</td>
                                                    <td>{{ $value['approx_loss'] }}</td>
                                                    <td>{{ $value['cng_side_loss'] }}</td>
                                                    <td>{{ $value['line_damage'] }}</td>
                                                    <td>{{ $value['venting_purging_vol'] }}</td>
                                                    <td>{{ $value['line_pack'] }}</td>
                                                    <td>{{ $value['identified_theft'] }}</td>
                                                    <td>{{ $value['amc'] }}</td>
                                                    <td>{{ $value['others'] }}</td>
                                                    <td>{{ $value['total_unaccounted'] }}</td>
                                                </tr>
                                            @endforeach
                                        @endif
                                    </tbody>
                                </table>
                            </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- Row -->
    </div>
@endsection
@push('custom-scripts')
@endpush
<!-- Include jQuery -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<!-- Include Select2 JavaScript -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/js/select2.min.js"></script>
<script>
    $(document).ready(function() {
        $('.select2').select2({
            placeholder: "Select an option",
            allowClear: true // Add this if you want the "x" button to clear the selected option
        });
        $("#date").change(function(){
        const date = $(this).val();
        lossDuringUnloading(date);
        });
        $(".calculation").keyup(function(){
            var loss_during_unloading = $("#loss_during_unloading").val();
            var approx_loss = $("#approx_loss").val();
            var cng_side_loss = $("#cng_side_loss").val();
            var line_damage = $("#line_damage").val();
            var venting_purging_vol = $("#venting_purging_vol").val();
            var line_pack = $("#line_pack").val();
            var identified_theft = $("#identified_theft").val();
            var amc = $("#amc").val();
            var others = $("#others").val();
            totalUnAccounted(loss_during_unloading, approx_loss, cng_side_loss, line_damage, venting_purging_vol, line_pack, identified_theft, others);
        });
        $(document).on("change","#ga_code",function()
{
    var ga_code=$(this).val();
    $.ajax({
            url: "{{url('api/getDistrict')}}",
            type: "POST",
            data: {
              ga_code:ga_code,"device":"web",
                _token: '{{csrf_token()}}'
            },
            dataType: 'json',
            success: function (result) {
            $("#district").html('<option value="">Please Select</option>');
               $.each(result, function (key, value) {
                 $("#district").append('<option value="' + key + '">' + value + '</option>');
                });
            }
        });
})
$(document).on("change","#district",function()
{
    var ga_code=$("#ga_code").val();
    var district=$(this).val();

    $("#dcuname").html("DCU "+district);
    $("#customers").show();
     $.ajax({
            url: "{{url('api/getDcu')}}",
            type: "POST",
            data: {
              district:district,ga_code:ga_code,"device":"web",
                _token: '{{csrf_token()}}'
            },
            dataType: 'json',
            success: function (result) {
                console.log(result);
             $("#new_data").html(result);
            }
        });

})
    });
</script>
