@extends('layout')
    @section('content')
    <style>
        .dropdown
        {
            display:none;
        }
    </style>
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">GCV Report</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">GCV Report Sheet</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
           
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
             $myga=anyFiled("User","ga",Auth::user()->id);
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 mt-2 text-white pull-left" id="gaDistrictInputname">GCV Report Sheet</h4>
                </div>
                <form id="form-filter" class="form-horizontal" action="{{ route('gaDistrictInput.post') }}" method="POST">
                     {{ csrf_field() }}
                    <input type="hidden" name="device" value="web">
                    <input type="hidden" name="user_id" value="{{Auth::user()->userId}}">
                    <div class="card-body">
                        <div class="form-body">
                                <div class="row">
                                    <div class="col-md-12 m-b-10">
                                            <div class="custom-control custom-radio  pull-left m-r-10 m-l-40	">
                                                <input type="radio" id="customRadio1" name="customRadio" class="form-check-input ">
                                                <label class="form-check-label h4 font-bold" for="customRadio1">GA</label>
                                            </div>
                                            <div class="custom-control custom-radio pull-left">
                                                <input type="radio" id="customRadio2" name="customRadio" class="form-check-input">
                                                <label class="form-check-label h4 font-bold" for="customRadio2">Storage Tank</label>
                                            </div>
                                    </div>
                                    
                                    <div class="col-md-6 dropdown ga_code">
                                        <div class="form-group">
                                            <label class="form-label">GA</label>
                                            <select name="ga_code" id="ga_code"  class="form-control form-select" data-placeholder="Choose a GA">
                                                <option  value="">Please Select GA</option>
                                                @foreach($ga as $k=>$v)
                                                     @if($myga==$k)
                                                    <option value="{{$k}}">{{$v}} ({{$k}})</option>
                                                    @elseif($myga=="All")
                                                     <option value="{{$k}}">{{$v}} ({{$k}})</option>
                                                    @endif
                                                @endforeach
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-md-6 dropdown storage_tank">
                                        <div class="form-group">
                                            <label class="form-label">Storage Tank</label>
                                            <select name="storage_tank" id="storage_tank"  class="form-control form-select" data-placeholder="Choose a GA">
                                            <option  value="">Please Select Storage Tank</option>
                                            <option value="Storage Tank 1">Storage Tank 1</option>
                                            <option value="Storage Tank 2">Storage Tank 2</option>
                                            <option value="Storage Tank 3">Storage Tank 3</option>
                                            <option value="Storage Tank 4">Storage Tank 4</option>
                                            </select>
                                        </div>
                                    </div>
                                   
                                </div>
                            
                            <div> &nbsp;</div>
                        </div>
                        <table id="customers" class="table table-bordered table-striped"  style="display:none;">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Conversion Factor (Weightage Average)<br>SCM / kg</th>
                                    <th>Conversion Factor (Weightage Average)<br>KL / MT</th>
                                    <th>Conversion Factor (Weightage Average)<br>SCM / KL</th>
                                    <th>Conversion Factor (Weightage Average)<br>kcal / scm</th>
                                    <th>Total Volume in scm <br> SCM</th>
                                    <th>Total Calorifc Value <br> MMBTU</th>
                                    <th>Total Volume in kg <br> kg</th>
                                    <th>Total Volume in KL <br> KL</th>
                                </tr>
                            </thead>
                            <tbody id="new_data">
                            </tbody>
                        </table>     
                    </div>
                </form>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>
$(document).ready(function()
{
    $("#customRadio1").on("click",function()
    {
        $(".dropdown").hide();
        $(".ga_code").show();
    })
    $("#customRadio2").on("click",function()
    {
        $(".dropdown").hide();
        $(".storage_tank").show();
    })
    
       table =  new DataTable('#customers', {  
        dom: 'rti',
        order:[1,"asc"],
        scrollX:true,
        scrollCollapse: true,
        scrollY: '65vh',
        autoWidth: true,
     });
     
})
function load_table(ga_code,getGCV)
{
    $("#customers").show();
    $.ajax({
            url: getGCV,
            type: "POST",
            data: {
                ga_code:ga_code,"device":"web",
                _token: '{{csrf_token()}}'
            },
            dataType: 'json',
            success: function (result) {
                console.log(result);
                $("#customers").dataTable().fnDestroy();
                $("#new_data").html(result);
                var table =  new DataTable('#customers', {  
                    dom: 'rti',
                    order:[0,"asc"],
                    scrollX:true,
                    scrollCollapse: true,
                    scrollY: '65vh',
                    autoWidth: true,
                 });
                }
    });
}
$(document).on("change","#ga_code",function()
{
    var ga_code=$("#ga_code").val();
    var getGCV="{{route('getGCV')}}";
    load_table(ga_code,getGCV);
})
$(document).on("change","#storage_tank",function()
{
    var ga_code=$("#storage_tank").val();
   var getGCV="{{route('getGCVStorage')}}";
    load_table(ga_code,getGCV);
})
</script>
@endpush