@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">Customer List</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">Customer List</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
           <!-- <form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">Customer List</h4>
                </div>
                <div class="card-body">
                    <div class="form-body">
                        <table id="customers" class="table table-bordered table-striped nowrap">
                            <thead>
                                <tr>
                                    <th>SL#</th>
                                    <th>GA</th>
                                    <th>Charge Area code</th>
                                    <th>BP Grouping</th>
                                    <th>MRU</th>
                                    <th>CA</th>
                                    <th>Application Number</th>
                                    <th>Customer Name</th>
                                    <th>Meter Number</th>
                                    <th>PNGRB District</th>
                                    <th>Address District</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                        </table>     
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>

$(document).ready(function()
{
   var table =  new DataTable('#customers', {  
        dom: 'Blfrtip',
        processing: true,
        serverSide: true,
        lengthMenu: [ [100, 250, -1], [100, 250, 'All'] ],
        order:[1,"asc"],
        scrollX:true,
        scrollCollapse: true,
        scrollY: '65vh',
        autoWidth: true,
        "buttons": ["csv", "excel", "pdf", "print", "colvis"],
        "ajax":{
                     "url": "{{ url('api/getCustomer') }}",
                     "dataType": "json",
                     "type": "POST",
                     
                     "data":
                     function(data)
                     {  
                        data.device= "web",
                        data.userId="{{Auth::user()->userId}}",
                        data._token= "{{csrf_token()}}",
                        data.formdata = $('#form-filter').serialize();
                     }
                   },
                    "columns": [
		        { "data": "slno" },
		        { "data": "GA" },
				{ "data": "Charge_Area_Code" },
				{ "data": "BP_Grouping" },
				{ "data": "MRU" },
				{ "data": "CA" },
				{ "data": "Application_Number" },
                { "data": "Name_of_the_Customer" },
                { "data": "Meter_Serial_No" },
                { "data": "PNGRB_District_t" },
                { "data": "Address_District" },
               { "data": "options" },
            ],
            
			"columnDefs": [ 
        {
"targets": [0],
"orderable": false
} 
    ],
});
$('#submit').on("click",function(){ //button filter event click
        table.ajax.reload();  //just reload table
    });
$('#btn-reset').click(function(){ //button reset event click
        $('#form-filter')[0].reset();
        table.ajax.reload();  //just reload table
    }); 
$('#all').click(function (e) {
    $('#customers tbody :checkbox').prop('checked', $(this).is(':checked'));
    if($( ".chk:checked" ).length >= 1)
  {
    $('#assign').prop('disabled', false);
  }
  else
  {
    $('#assign').prop('disabled', true);
  }  
    e.stopImmediatePropagation();
});
});
    $(document).on( "click", ".chk", function() {
  if($( ".chk:checked" ).length >= 1)
  {
    $('#assign').prop('disabled', false);
  }
  else
  {
    $('#assign').prop('disabled', true);
  }  
});
$(document).on("click","#assign",function()
{
    var va=[];
            $("#customers tbody :checkbox:checked").each(function() { 
                va.push($(this).val()); 
            });  
            $.ajax({
                    url: "{{url('api/getSurveyor')}}",
                    type: "POST",
                    data: {
                      "customer": va,"device":"web",
                        _token: '{{csrf_token()}}'
                    },
                    dataType: 'json',
                    success: function (result) {
                       //console.log(res);
                       var tr="<option>Please Select</option>";
                        $.each(result,function(key,value){
                            tr+="<option value='"+key+"'>"+value+"("+key+")</option>";
                        });
                            $("#agp_user").html(tr);
                            $("#ca").val(va);
                    }
                });
})
</script>
@endpush