<!DOCTYPE html>
<html>
<head>
    <title>AG&P Survey</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css">
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
        <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.4.1/jquery.easing.min.js"></script>

    <script type="text/javascript" src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js"></script>
    <link rel="stylesheet" href="{{asset('css/survey.css') }}">
    <script src="{{asset('js/survey.js') }}"></script>
</head>

<body>
<!-- MultiStep Form -->
  <div class="row">
    <div class="col-md-12 col-md-offset-6">
        <form id="msform" class="needs-validation" method="post" action="/index" enctype="multipart/form-data">
        {{ csrf_field() }}
            <!-- fieldsets -->
            <fieldset class="step">
                <h2 class="fs-title"><img src="{{asset('images/AG&P-Logo.png') }}" /></h2>
                <h3 class="fs-subtitle"></h3>
                <input type="text" name="surveyor_name" placeholder="Surveyor Name" class="required" required="true"/>
                <input type="text" name="application_no" placeholder="Application No." class="required" required="true"/>
                <input type="text" name="customer_name" placeholder="Customer Name" required="true"/>
                <input type="tel" name="customer_mobile" placeholder="Customer Mobile No." required="true"/>
                <input type="email" name="customer_email" placeholder="Customer Email id" />
                <div class="radio_block">
                <label for="rentRadio1">
                <input type="radio"  name="rent_paid" id="rentRadio1" value="option1" required="true"><span>On Rent</span></label>
                <label for="rentRadio2" >
                <input type="radio" name="rent_paid" id="rentRadio2" value="option2" required="true"><span>Self Occupied</span></label>
                </div>
                <textarea rows=5 cols=5 name="address" placeholder="Provide complete address" required="true"></textarea>
                <select name="connection_status" class="custom-select connection_status" required="true">
                     <option selected>Connection Status Menu</option>
                     <option value="Plumbing Done with meter">Plumbing Done with meter</option>
                     <option value="Plumbing Done without meter">Plumbing Done without meter</option>
                     <option value="House Locked">House Locked</option>
                     <option value="Address Not Found">Address Not Found</option>
                     <option value="No Connection">No Connection</option>
                     <option value="GC Done">GC Done</option>
                     <option value="Only Conversion Pending">Only Conversion Pending</option>
                     <option value="Customer using Gas">Customer using Gas</option>
                     <option value="Customer using Gas but Bill not received">Customer using Gas but Bill not received</option>
                     <option value="TD">TD</option>
                     <option value="PD">PD</option>
                     <option value="FD">FD</option>    
               </select>
            <input type="button" name="next" class="next action-button" value="Next"/>
            </fieldset>
            <fieldset class="step step2">
                <h2 class="fs-title"><img src="{{asset('images/AG&P-Logo.png') }}" /></h2>
                <h3 class="fs-subtitle step-title">Meter Details</h3>
                <div class="meter-block">
                <input type="text" name="meter_no" placeholder="Meter No."/>
                <input type="text" name="meter_reading" placeholder="Meter Reading"/>
                <div class="custom-file">
                   <input type="file" name="meter_photo" class="custom-file-input" id="meterPhoto">
                   <label class="custom-file-label" for="meterPhoto">Meter Photo</label>
                </div>
                </div>
                <div class="custom-file site-photo-block">
                   <input type="file" name="site_photo" class="custom-file-input" id="sitePhoto">
                   <label class="custom-file-label" for="sitePhoto">Provide Site Photo</label>
                </div>
                <div class="custom-file house-photo-block">
                   <input type="file" name="house_photo" class="custom-file-input" id="housePhoto">
                   <label class="custom-file-label" for="housePhoto">Provide House Locked Photo</label>
                </div>
                <div class="custom-file gc-photo-block">
                   <input type="file" name="gc_photo" class="custom-file-input" id="gcPhoto">
                   <label class="custom-file-label" for="gcPhoto">Photo of TF/RCC Guard</label>
                </div>
                <div>&nbsp;</div>
                <div class="geyser-block">
                <div class="radio_block">
                Customer Interested for Geyser Connection
                <br />
                <label for="geyserRadio1">
                <input type="radio"  name="geyser_conn" id="geyserRadio1" value="option1"><span>Yes</span></label>
                <label for="geyserRadio2" >
                <input type="radio" name="geyser_conn" id="geyserRadio2" value="option2"><span>No</span></label>
                </div>
                <select name="tube_status" class="custom-select tube_status">
                  <option selected>Rubber tube Status Menu</option>
                  <option value="Standardized">Standardized</option>
                  <option value="Non - Standardized">Non - Standardized</option>  
                </select>
                </div>
                <input type="button" name="previous" class="previous action-button-previous" value="Back"/>
                <input type="submit" name="submit" class="submit action-button submit1" value="Submit"/>
                <input type="button" name="next" class="next action-button next2" value="Next"/>
            </fieldset>
            <fieldset class="step tube-block">
               <h2 class="fs-title"><img src="{{asset('images/AG&P-Logo.png') }}" /></h2>
               <h3 class="fs-subtitle">Standardized</h3>
                <div class="visibility-block">
                Date visibility
                <br />
                <label for="visibilityRadio1">
                <input type="radio"  name="visibility" id="visibilityRadio1" value="option1"><span>Yes</span></label>
                <label for="visibilityRadio2" >
                <input type="radio" name="visibility" id="visibilityRadio2" value="option2"><span>No</span></label>
                </div>
                <input type="button" name="previous" class="previous action-button-previous" value="Back"/>
                <input type="submit" name="submit" class="submit action-button tube-submit" value="Submit"/>
                <input type="button" name="next" class="next action-button tube-next" value="Next"/>
            </fieldset>
            <fieldset class="step submit-step">
                <h2 class="fs-title"><img src="{{asset('images/AG&P-Logo.png') }}" /></h2>
                <h3 class="fs-subtitle">Click submit to finish</h3>
                <input type="button" name="previous" class="previous action-button-previous" value="Back"/>
                <input type="submit" name="submit" class="submit action-button" value="Submit"/>
            </fieldset>
        </form>
    </div>
</div>
<!-- /.MultiStep Form -->

</body>

</html>
