@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">Completed Survey.</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">Completed Survey.</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
            <!--<form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 mt-2 text-white pull-left">List of Applications completed survey.</h4>
                </div>
                <div class="card-body">
                     <table id="customers" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>SL#</th>
                            <th>Assignment Id</th>
                            <th>Surveyor</th>
                            <th>CA</th>
                            <th>Customer Name</th>
                            <th>Mobile</th>
                            <th>Email</th>
                            <th>Customer address</th>
                            <th>Connection Status</th>
                            <th>Meter No</th>
                            <th>Meter Reading</th>
                            <th>Meter Photo</th>
                            <th>Site Photo</th>
                            <th>House Photo</th>
                            <th>GC Photo</th>
                            <th>Geyser Connection</th>
                            <th>Tube Status</th>
                            <th>Date Visibility</th>
                            <th>Created Dt</th>
                            <th>Kitchen photo</th>
                            <!--<th>Action</th>-->
                        </tr>
                    </thead>
                </table> 
                </div>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>

$(document).ready(function()
{
   var table =  new DataTable('#customers', {  
       dom: 'Blfrtip',
        processing: true,
        serverSide: true,
        scrollX:true,
        lengthMenu: [ [100, 250, -1], [100, 250, 'All'] ],
        order:[1,"asc"],
        "buttons": ["csv", "excel", "pdf", "print", "colvis"],
        "ajax":{
                     "url": "{{ url('api/getCompletedSurvey') }}",
                     "dataType": "json",
                     "type": "POST",
                     "data":
                     function(data)
                     {  
                        data.device= "web",
                        data.userId='{{Auth::user()->userId}}',
                        data._token= "{{csrf_token()}}",
                        data.formdata = $('#form-filter').serialize();
                     }
                   },
                    "columns": [
		        { "data": "slno" },
				{ "data": "assignment_id" },
				{ "data": "surveyor" },
				{ "data": "ca" },
				{ "data": "customer_name" },
				{ "data": "customer_mobile" },
				{ "data": "customer_email" },
                { "data": "customer_address" },
                { "data": "connection_status" },
                { "data": "meter_no" },
                { "data": "meter_reading" },
                { "data": "meter_photo" },
                { "data": "site_photo" },
                { "data": "house_photo" },
                { "data": "gc_photo" },
                { "data": "geyser_connection" },
                { "data": "tube_status" },
                { "data": "date_visibility" },
                { "data": "created_at" },
                { "data": "kitchen_photo" },
               //{ "data": "options" },
            ],
            
			"columnDefs": [ 
        {
"targets": [],
"orderable": false
} 
    ],
});
$('#submit').on("click",function(){ //button filter event click
        table.ajax.reload();  //just reload table
    });
$('#btn-reset').click(function(){ //button reset event click
        $('#form-filter')[0].reset();
        table.ajax.reload();  //just reload table
    }); 

});

</script>
@endpush