@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">User Registration</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">User Registration</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
            <!--<form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">AGP User Registration Form</h4>
                </div>
                <div class="card-body">
                    <form name="registration" action="{{ route('userRegistration.post') }}" method="POST" class="needs-validation" novalidate >
                        {{ csrf_field() }}
                        <div class="form-body">
                            <h3 class="card-title">User Info</h3>
                            <hr>
                            <input type="hidden" name="device" value="web">
                            <div class="row p-t-20">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">User Id</label>
                                        <input type="text" name="userId" id="userId" required="true" placeholder="Enter Login Id" class="form-control">
                                        <small class="form-control-feedback"> This Id will be use for login to the web application. </small>
                                        <div class="invalid-feedback">
                                            Please enter userid.
                                        </div>
                                        
                                        </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">User Name</label>
                                        <input type="text" name="userName" id="userName" class="form-control " placeholder="Enter the user name">
                                        <small class="form-control-feedback"> This is the full name of the user. </small> </div>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group ">
                                        <label class="form-label">Password</label>
                                        <input type="password" name="password" id="password1" class="form-control " placeholder="Enter Password" minlength=6 required>
                                        <small class="form-control-feedback"> Minimum length for password is 6 </small> </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Email Id</label>
                                        <input type="text" name="email" id="email" placeholder="Enter Email Id" class="form-control">
                                    </div>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Phone Number</label>
                                        <input type="text" name="phone" id="phone" placeholder="Enter Phone" class="form-control">
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">GA</label>
                                        <select name="GA" id="ga"  class="form-control form-select" data-placeholder="Choose a GA">
                                            <option>Please Select GA</option>
                                            @foreach($ga as $v)
                                                <option value="{{$v}}">{{$v}}</option>
                                            @endforeach
                                            <option value="All">All</option>
                                        </select>
                                    </div>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">User Role</label>
                                        <select  name="role" id="role" required="true" class="form-control form-select" data-placeholder="Choose a Role">
                                            <option >Please Select Role</option>
                                            <option value="Admin">Admin</option>
                                            <option value="Business User">Business User</option>
                                            <option value="Surveyor">Surveyor</option>
                                            <option value="CCC/HO Head">CCC/HO Head</option>
                                            <option value="GA Heads">GA Heads</option>
                                            <option value="GA Engineers">GA Engineers</option>
                                            <option value="GA Executives">GA Executives</option>
                                        </select>
                                    </div>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                        </div>
                        <div class="form-actions">
                            <button type="submit" name="submit" id="submit" value="Submit" class="btn btn-primary text-white"> <i class="fa fa-check"></i> Save</button>
                            <button type="reset" class="btn btn-secondary">Cancel</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')

@endpush