@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">Create User </h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">Create User </li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
            <!--<form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">Upload Office User Data</h4>
                </div>
                <div class="card-body">
                    <form name="importuser" class="needs-validation" action="{{ route('importOfficeUser.post') }}" method="POST" enctype="multipart/form-data">
                    {{ csrf_field() }}
                        <div class="form-body">
                            <input type="hidden" name="device" value="web">
                            <div class="row p-t-20">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Upload</label>
                                        <input type="file" name="file" id="user"  required placeholder="upload csv file" class="form-control">
                                        <small class="form-control-feedback"> Please upload csv file only</small>
                                        <div class="invalid-feedback">
                                            Please upload csv file.
                                        </div>
                                        
                                        </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <div class="download float-right mt-3"><a href="public/sample/user.csv" >Download Sample csv</a></div></div>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                        </div>
                        <div class="form-actions">
                            <button type="submit" name="submit_import" id="submit_import" value="Import" class="btn btn-primary text-white"> <i class="fa fa-check"></i> Import</button>
                            <button type="reset" class="btn btn-secondary">Cancel</button>
                        </div>
                    </form>
                </div>
            </div>
			
			
			<div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">Update User Data</h4>
                </div>
                <div class="card-body">
                    <form name="importuser" class="needs-validation" action="{{ route('importUserData.post') }}" method="POST" enctype="multipart/form-data">
                    {{ csrf_field() }}
                        <div class="form-body">
                            <input type="hidden" name="device" value="web">
                            <div class="row p-t-20">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Upload</label>
                                        <input type="file" name="file" id="user"  required placeholder="upload csv file" class="form-control">
                                        <small class="form-control-feedback"> Please upload csv file only</small>
                                        <div class="invalid-feedback">
                                            Please upload csv file.
                                        </div>
                                        
                                        </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <div class="download float-right mt-3"><a href="public/sample/users.csv" >Download Sample csv</a></div></div>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                        </div>
                        <div class="form-actions">
                            <button type="submit" name="submit_import" id="submit_import" value="Import" class="btn btn-primary text-white"> <i class="fa fa-check"></i> Import</button>
                            <button type="reset" class="btn btn-secondary">Cancel</button>
                        </div>
                    </form>
                </div>
            </div>
			
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">AGP User Registration Form</h4>
                </div>
                <div class="card-body">
                    <form name="registration" action="{{ route('createUser.post') }}" method="POST" class="needs-validation" novalidate enctype="multipart/form-data">
                        {{ csrf_field() }}
                        <div class="form-body">
                            <h3 class="card-title">User Info</h3>
                            <hr>
                            <input type="hidden" name="device" value="web">
                            <!--/row--> 
                            @if(!isset($userdetail))
                            <div class="row p-t-20">
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">User Id</label>
                                        <input type="text" name="userId" id="userId" required="true" placeholder="Enter Login Id" class="form-control" value="{{@$userdetail['userId']}}">
                                        <small class="form-control-feedback"> This Id will be use for login to the web application. </small>
                                        <div class="invalid-feedback">
                                            Please enter userid.
                                        </div>
                                        
                                        </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">User Name</label>
                                        <input type="text" name="userName" id="userName" class="form-control " placeholder="Enter the user name" value="{{@$userdetail['userName']}}">
                                        <small class="form-control-feedback"> This is the full name of the user. </small> </div>
                                </div>  
                                <div class="col-md-4">
                                    <div class="form-group ">
                                        <label class="form-label">Password</label>
                                        <input type="password" name="password" id="password1" class="form-control " placeholder="Enter Password" minlength=6 >
                                        <small class="form-control-feedback"> Minimum length for password is 6 </small> </div>
                                </div>
                                <!--/span-->
                            </div>
                            @else
                            <div class="row p-t-20">
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">User Id</label>
                                        <input type="text" name="userId" id="userId" required="true" placeholder="Enter Login Id" class="form-control" value="{{@$userdetail['userId']}}" disabled>
                                        <small class="form-control-feedback"> This Id will be use for login to the web application. </small>
                                        <div class="invalid-feedback">
                                            Please enter userid.
                                        </div>
                                        
                                        </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">User Name</label>
                                        <input type="text" name="userName" id="userName" class="form-control " placeholder="Enter the user name" value="{{@$userdetail['userName']}}" disabled>
                                        <small class="form-control-feedback"> This is the full name of the user. </small> </div>
                                </div>
                                <!--/span-->
                            </div>
                            <input type="hidden" name="zid" value="{{@$userdetail['userId']}}">
                            @endif
                            <!--/row-->
                            
                            <div class="row">
                            <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">User Designation</label>
                                        <input type="text"  name="designation" id="designation" required="true"  class="form-control " placeholder="Please enter Designation" value="{{@$userdetail['role']}}">
                                        <!-- <select  name="designation" id="designation" required="true" class="form-control form-select" data-placeholder="Choose a Deignation" required>
                                            <option >Please Select Designation</option>
                                            @if(isset($designation))
                                            @foreach($designation as $key=>$val)
                                          <option value="{{$val}}"  {{ (@$moduleDetail['role'] == $val ? "selected":"") }}>{{$val}}</option>
                                          @endforeach
                                          @endif
                                        </select> -->
                                    </div>
                                </div>
                                <!--/span-->
                            
                               
                                <!--/span-->
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Email Id</label>
                                        <input type="text" name="email" id="email" placeholder="Enter Email Id" class="form-control" value="{{@$userdetail['email']}}">
                                    </div>
                                </div>
                                <!--/span-->
                            
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Phone Number</label>
                                        <input type="text" name="phone" id="phone" placeholder="Enter Phone" class="form-control" value="{{@$userdetail['phone']}}">
                                    </div>
                                </div>
                            <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Date Of Birth</label>
                                        <input type="date" name="dob" id="dob" placeholder="Enter DOB" class="form-control" value="{{@$userdetail['dob']}}">
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Profile Picture</label>
                                        <input type="file" name="profile_picture" id="profile_picture" placeholder="Select profile Picture" class="form-control" value="{{@$userdetail['profile_picture']}}">
                                    </div>
                                </div>
                            <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">GA</label>
                                        <select name="GA" id="ga"  class="form-control form-select" data-placeholder="Choose a GA">
                                            <option>Please Select GA</option>
                                            @foreach($ga as $k=>$v)
                                                <option value="{{$k}}" {{ (@$userdetail['ga'] == $k ? "selected":"") }}>{{$v}}({{$k}})</option>
                                            @endforeach
                                            <option value="All"  {{ (@$userdetail['ga'] == "All" ? "selected":"") }}>All</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    @php
                                    $collection=json_decode(@$userdetail['user_role'], TRUE);
                                    if(!isset($collection))
                                    $collection=array();
                                    @endphp
                                    <div class="form-group">
                                        <label class="form-label">User Role</label>
                                        <select  name="roles[]" id="roles"  class="form-control form-select select2 select2-multiple"  multiple="multiple" data-placeholder="Choose a Role"  multiple>
                                            <option >Please Select Role</option>
                                            @if(isset($roles))
                                            @foreach($roles as $key=>$val)
                                          <option value="{{$key}}"   {{ (in_array($key, $collection)? "selected":"") }}>{{$val}}</option>
                                          @endforeach
                                          @endif
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Remarks</label>
                                        <textarea name="remarks" id="remarks" class="form-control " placeholder="Enter remarks">{{@$userdetail['remarks']}}</textarea>
                                        <small class="form-control-feedback"> This is the Remarks for user Roles. </small> </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">O365 Authentication Required</label>
                                       <div class="custom-control custom-radio">
                                        <input type="radio" value="Yes" name="o_auth" id="styled_radio_inline1" class="form-check-input" {{ (@$userdetail['o_auth'] == "Yes" ? "checked":"") }}>
                                        <label class="form-check-label" for="styled_radio_inline1">Yes</label>
                                        </div>
                                        <div class="custom-control custom-radio">
                                        <input type="radio" value="No" name="o_auth" id="styled_radio_inline2" class="form-check-input" {{ (@$userdetail['o_auth'] == "No" ? "checked":"") }}>
                                        <label class="form-check-label" for="styled_radio_inline2">No</label>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            
                            <!--/row-->
                        </div>
						
						
						
						<div class="row">
						
						<div class="col-md-4">
                                    <div class="form-group ">
                                        <label class="form-label">Employee Id</label>
                                        <input type="text" name="emp_id" id="empId" value="{{@$userdetail['employee_id']}}" class="form-control " placeholder="Enter employee Id"  required>
                                        </div>
                                </div>
								
                                <!--/span-->
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Designation</label>
                                        <input type="text" name="user_designation" value="{{@$userdetail['designation']}}" id="designation" placeholder="Enter designation" class="form-control" required>
                                    </div>
                                </div>
								
								<div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Employee Type</label>
                                        <select  name="employee_type" id="employeeType" class="form-control form-select" data-placeholder="Choose employee type" required>
                                            <option value="">Select Employee Type</option>
											
                                            <option value="AGP Pratham" {{ (@$userdetail['employee_type'] == "AGP Pratham" ? "selected":"") }}>AGP Pratham</option>
                                            <option value="contractors" {{ (@$userdetail['employee_type'] == "contractors" ? "selected":"") }}>Contractors</option>
                                            <option value="contractual" {{ (@$userdetail['employee_type'] == "contractual" ? "selected":"") }}>Contractual</option>
											

                                        </select>
                                    </div>
                                </div>
                                
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Employee Status</label>
                                        <select  name="status" id="status" class="form-control form-select" data-placeholder="Choose employee status" required>
                                            <option value="1" {{ (@$userdetail['status'] == 1 ? "selected":"") }}>Active</option>
                                            <option value="2" {{ (@$userdetail['status'] == 2 ? "selected":"") }}>Blocked</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-4 reason" style="display:none;" >
                                    <div class="form-group">
                                        <label class="form-label">Reason</label>
                                        <textarea class="form-control " placeholder="Enter Reasons" id="reason" name="reason"></textarea>
                                    </div>
                                </div>
                                <!--/span-->
                            </div>
						
						
						
						
                        <div class="form-actions">
                            <button type="submit" name="submit" id="submit" value="Submit" class="btn btn-primary text-white"> <i class="fa fa-check"></i> Save</button>
                            <button type="reset" class="btn btn-secondary">Cancel</button>
                        </div>
                    </form>
                </div>
            </div>
            
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>
    $(document).on("change","#status",function()
    {
        if($(this).val()==1)
        {
            $(".reason").hide();
            $("#reason").removeAttr("required");
        }
        else
        {
            $(".reason").show();
            $("#reason").attr("required",true);
        }
    })
</script>
@endpush