@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">Function</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">Function</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
            <!--<form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">Function Master Form</h4>
                </div>
                <div class="card-body">
                    <form name="function" action="{{ route('functionMasterPost') }}" method="POST" class="needs-validation" novalidate >
                        {{ csrf_field() }}
                        <div class="form-body">
                            <input type="hidden" name="device" value="web">
                            @if(isset($functionDetail))
                             <input type='hidden' name='zid'  value='{{$functionDetail["id"]}}'>
                             @endif
                            <div class="row p-t-20">
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label class="form-label">Function Name</label>
                                        <input type="text" name="function_name" id="function_name" required="true" placeholder="Enter Function Name" class="form-control" value="{{@$functionDetail['function_name']}}">
                                        <small class="form-control-feedback text-primary"> Name of the function</small>
                                    </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label class="form-label">Function Code</label>
                                        <input type="text" name="function_code" id="function_code" class="form-control " placeholder="Enter Function Code" value="{{@$functionDetail['function_code']}}">
                                        <small class="form-control-feedback text-primary"> This is code or short form(if any)of the function. Or add data same as function name </small> </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label class="form-label">Status</label>
                                        <select  name="status" id="status" required="true" class="form-control form-select">
                                            <option value="Active"  {{ (@$functionDetail['status'] == 'Active' ? "selected":"") }}>Active</option>
                                            <option value="Inactive" {{ (@$functionDetail['status'] == 'Inactive' ? "selected":"") }}>Inactive</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="form-actions col-md-3 mt-4">
                                    <button type="submit" name="submit" id="submit" value="Submit" class="btn btn-primary text-white "> <i class="fa fa-check"></i> Save</button>
                                    <a href="{{route('functionMaster')}}"><button type="button" class="btn btn-secondary">Cancel</button></a>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                        </div>
                    </form>
                    <!--Table Data-->
                    <table id="function" class="table table-bordered table-striped ">
                        <thead>
                            <tr>
                                <th>SL#</th>
                                <th>Function Name</th>
                                <th>Function Code</th>
                                <th>Status</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                            @if(!empty($function))
                            @foreach($function as $k=>$cc)
                            <tr>
                                <td>{{$loop->iteration}}</td>
                                <td>{{$cc['function_name']}}</td>
                                <td>{{$cc['function_code']}}</td>
                                @if($cc['status']=="Active")
                                <td><span class="label label-success">{{$cc['status']}}</span></td>
                                @else
                                <td><span class="label label-danger">{{$cc['status']}}</span></td>
                                @endif
                                <td><a style="float:left; margin-right:10px;" href="{{route('functionMaster', ['zid'=>$cc['id']])}}"><button type="button" class="btn btn-info btn-sm"><i class="ti-pencil"></i></button></a>
                                 <form method="post" action="{{route('functionMasterDelete',$cc['id'])}}">
                            @csrf
                                <button type="submit" onclick="return confirm('Are you sure?')"  class="btn btn-warning btn-sm"><i class="ti-trash"></i></button>
                                </form></td>
                            </tr>
                            @endforeach
                            @endif
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>
    $(function()
    {
        $('#function').DataTable();
    })
</script>
@endpush