@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">Module</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">Module</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
            <!--<form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">Module Master Form</h4>
                </div>
                <div class="card-body">
                    <form name="module" action="{{ route('moduleMasterPost') }}" method="POST" class="needs-validation" novalidate >
                        {{ csrf_field() }}
                        <div class="form-body">
                            <input type="hidden" name="device" value="web">
                            @if(isset($moduledetail))
                             <input type='hidden' name='zid'  value='{{$moduledetail["id"]}}'>
                             @endif
                            <div class="row p-t-20">
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Parent Module</label>
                                        <select class="form-control form-select" name="parent_module" id="parent_module">
                                            <option value="" >No Parent Module</option>
                                            @if(isset($parent_modules))
                                            @foreach($parent_modules as $key=>$val)
                                          <option value="{{$key}}"  {{ (@$moduledetail['parent_module'] == $key ? "selected":"") }}>{{$val}}</option>
                                          @endforeach
                                          @endif
                                        </select>
                                        <small class="form-control-feedback text-primary">Parent module </small> </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Module Name</label>
                                        <input type="text" name="module_name" id="module_name" required="true" placeholder="Enter Module Name" class="form-control" value="{{@$moduledetail['module_name']}}">
                                        <small class="form-control-feedback text-primary"> Name of the control center</small>
                                    </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Module Link</label>
                                        <input type="text" name="module_link" id="module_link" class="form-control " placeholder="Enter Module Link" value="{{@$moduledetail['module_link']}}">
                                        <small class="form-control-feedback text-primary">Link of the module </small> </div>
                                </div>
                                 <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Module Icon</label>
                                        <input type="text" name="module_icon" id="module_icon" class="form-control " placeholder="Enter Module Icon" value="{{@$moduledetail['module_icon']}}">
                                        <small class="form-control-feedback text-primary">Icon of the module </small> </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label class="form-label">Status</label>
                                        <select  name="status" id="status" required="true" class="form-control form-select">
                                            <option value="Active"  {{ (@$moduledetail['status'] == 'Active' ? "selected":"") }}>Active</option>
                                            <option value="Inactive" {{ (@$moduledetail['status'] == 'Inactive' ? "selected":"") }}>Inactive</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="form-actions col-md-4 mt-4">
                                    <button type="submit" name="submit" id="submit" value="Submit" class="btn btn-primary text-white "> <i class="fa fa-check"></i> Save</button>
                                    <a href="{{route('moduleMaster')}}"><button type="button" class="btn btn-secondary">Cancel</button></a>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                        </div>
                    </form>
                    <!--Table Data-->
                    <table id="module" class="table table-bordered table-striped ">
                        <thead>
                            <tr>
                                <th>SL#</th>
                                <th>Parent Module</th>
                                <th>Module Name</th>
                                <th>Module Link</th>
                                <th>Module Icon</th>
                               <th>Status</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                            @if(!empty($modules))
                            @foreach($modules as $k=>$cc)
                            <tr>
                                <td>{{$loop->iteration}}</td>
                                <td>{{ anyFiled("MasterModule","module_name",$cc->parent_module) }}</td>
                                <td>{{$cc['module_name']}}</td>
                                <td>{{$cc['module_link']}}</td>
                                <td><i class="{{$cc['module_icon']}}"></i></td>
                                @if($cc['status']=="Active")
                                <td><span class="label label-success">{{$cc['status']}}</span></td>
                                @else
                                <td><span class="label label-danger">{{$cc['status']}}</span></td>
                                @endif
                                <td><a style="float:left; margin-right:10px;" href="{{route('moduleMaster', ['zid'=>$cc['id']])}}"><button type="button" class="btn btn-info btn-sm"><i class="ti-pencil"></i></button></a>
                                 <form method="post" action="{{route('moduleMasterDelete',$cc['id'])}}">
                            @csrf
                                <button type="submit" onclick="return confirm('Are you sure?')"  class="btn btn-warning btn-sm"><i class="ti-trash"></i></button>
                                </form></td>
                            </tr>
                            @endforeach
                            @endif
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>
    $(function()
    {
        $('#module').DataTable();
    })
</script>
@endpush