@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">User List</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">User List</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
           <!-- <form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">User List</h4>
                </div>
                <div class="card-body">
                    <div class="form-body">
                        <table id="customers" class="table table-bordered table-striped nowrap">
                            <thead>
                                <tr>
                                    <th>SL#</th>
                                    <th>User Id</th>
                                    <th>User Name</th>
                                    <th>Role</th>
                                    <th>GA</th>
                                    <th>Email</th>
                                    <th>Phone Number</th>
									<th>DOB</th>
									 <th>Emp Id</th>
									 <th>Designation</th>
									 <th>Emp Type</th>
									   
                                    <th>Action</th>
                                </tr>
                            </thead>
                        </table>     
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>

$(document).ready(function()
{
   var table =  new DataTable('#customers', {  
        dom: 'Blfrtip',
        processing: true,
        serverSide: true,
        'lengthMenu': [ [100, 250, -1], [100, 250, 'All'] ],
        order:[1,"asc"],
        scrollX:true,
        scrollCollapse: true,
        scrollY: '65vh',
        autoWidth: true,
        "buttons": ["csv", "excel", "pdf", "print", "colvis"],
        "ajax":{
                     "url": "{{ url('api/getAllUser') }}",
                     "dataType": "json",
                     "type": "POST",
                     "data":
                     function(data)
                     {  
                        data.device= "web",
                        data.userId="{{Auth::user()->userId}}",
                        data._token= "{{csrf_token()}}",
                        data.formdata = $('#form-filter').serialize();
                     }
                   },
                    "columns": [
		        { "data": "slno" },
		        { "data": "userId" },
				{ "data": "userName" },
				{ "data": "role" },
				{ "data": "ga" },
				{ "data": "email" },
				{ "data": "phone" },
				{
				"data": "dob",
				"render": function(data, type, row) {
					// Check if dob data exists
					if (data) {
						// Parse the date string
						var dob = new Date(data);
						// Format the date as d-m-Y
						var formattedDob = ('0' + dob.getDate()).slice(-2) + '-' + ('0' + (dob.getMonth() + 1)).slice(-2) + '-' + dob.getFullYear();
						// Return the formatted date
						return formattedDob;
					} else {
						// Return blank if dob data is empty
						return '';
					}
				}
			},
				{ "data": "employee_id" },
				{ "data": "designation" },
				{ "data": "employee_type" },
				
				
				{ "data": "option" },
            ],
            
			"columnDefs": [ 
        {
"targets": [0],
"orderable": false
} 
    ],
});
$('#submit').on("click",function(){ //button filter event click
        table.ajax.reload();  //just reload table
    });
$('#btn-reset').click(function(){ //button reset event click
        $('#form-filter')[0].reset();
        table.ajax.reload();  //just reload table
    }); 
});
</script>
@endpush