@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">GA Log Entry</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">GA Log Entry</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
            <!--<form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
            //print_r($editValues); exit;
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">AG&P GA Log Entry Form</h4>
                </div>
                <div class="card-body">
                    <form name="registration" action="{{ route('EnterWebGALog') }}" method="POST" class="needs-validation" novalidate >
                        {{ csrf_field() }}
                        <div class="form-body">
                            <h3 class="card-title">GA Log Entry</h3>
                            <hr>
                            <input type="hidden" name="device" value="web">
                            <input type="hidden" name="user_id" value="{{Auth::user()->userId}}">
                            <div class="row p-t-20">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Date</label>
                                        <input type="date" name="attendance_date" id="attendance_date" required="true" placeholder="Enter Date" class="form-control" value="{{$userAttendanceDetails[0]['attendance_date']}}" readonly>
                                        <small class="form-control-feedback"> Please select date</small>
                                        <!--<div class="invalid-feedback">
                                            Please enter userid.
                                        </div>
                                        -->
                                        </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Shift</label>
                                        <select name="shift_code" id="shift_code"  class="form-control form-select" data-placeholder="Choose a Shift" readonly>
                                            <option>Please Select Shift</option>
                                            @foreach($shift as $v)
                                                <option value="{{$v}}" {{ $v == $userAttendanceDetails[0]['shift_code'] ? 'selected' : '' }}>{{$v}}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Timing</label>
                                        <input type="text" name="start_end_time" id="start_end_time"  class="form-control" value="{{$startEndTime}}" readonly>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Function</label>
                                        <select name="function_code" id="function_code"  class="form-control form-select" data-placeholder="Choose a function" readonly>
                                            <option>Please Select function</option>
                                            @foreach($function as $v)
                                                <option value="{{$v}}" {{ $v == $userAttendanceDetails[0]['function_code'] ? 'selected' : '' }}>{{$v}}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                                </div>
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">User</label>
                                        <select name="user_id" id="user_id"  class="form-control form-select" data-placeholder="Choose User" required>
                                            <option>Please Select User</option>
                                            <?php if(!$editValues) $editValues[0]['userId']=""; ?>
                                            @foreach($user as $v)
                                                <option value="{{$v['userName']}}" <?php if($editValues[0]['userId']) ?>{{ $v['userName'] == $editValues[0]['userId'] ? 'selected' : '' }}>{{$v['userName']}}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Equipment</label>
                                        <select name="equipment" id="equipment" class="form-control form-select" data-placeholder="Choose Equipment"
                                            required>
                                            <option>Please Select Equipment</option>
                                            @php
                                            $equipmentValue = !empty($editValues[0]['equipment']) ? $editValues[0]['equipment'] : null;
                                            @endphp
                                            @foreach($equipments as $v)
                                            <option value="{{ $v['equipment_name'] }}" {{ $equipmentValue==$v['equipment_name'] ? 'selected' : '' }}>
                                                {{ $v['equipment_name'] }}
                                            </option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Station</label>
                                        <select name="station" id="station" class="form-control form-select" data-placeholder="Choose Station" required>
                                            <option>Please Select Station</option>
                                            <?php if(!$editValues) $editValues[0]['station']=""; ?>
                                            @php
                                            $stationValue = !empty($editValues[0]['station']) ? $editValues[0]['station'] : null;
                                            @endphp
                                            @foreach($stations as $v)
                                            <option value="{{$v['station_name']}}" {{ $v['station_name'] == $stationValue ? 'selected' : '' }}>{{$v['station_name']}}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Sub Equipment</label>
                <input type="text" name="sub_equipment" id="sub_equipment" class="form-control"
                    value="{{ isset($editValues[0]['sub_equipment']) ? $editValues[0]['sub_equipment'] : '' }}" required />
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Standing Instructions</label>
                                        <textarea name="standing_instrctions"></textarea>
                                    </div>
                                </div>
                            </div>
                            <!--/row-->
                        </div>
                        <div class="form-actions">
                            <button type="submit" name="action_generated" id="add" value="Add" class="btn btn-primary text-white"> <i class="fa fa-check"></i> ADD</button>
                            <button type="submit" name="action_generated" id="submit" value="Submit" class="btn btn-primary text-white" onclick="return confirm('Once Submitted data Can not be changed')"> <i class="fa fa-check"></i> SAVE</button>
                            <button type="reset" class="btn btn-secondary">Reset</button>
                            <input type="hidden" name="source" value="web" />
                            <?php if($editValues[0]['userId']){ ?>
                            <input type="hidden" name="operationId" value=<?php print $editValues[0]['id']; ?> />
                            <?php } ?>
                        </div>
                    </form>
                    <!--Table Data-->
                    <table id="function" class="table table-bordered table-striped ">
                        <thead>
                            <tr>
                                <th>SL#</th>
                                <th>Date</th>
                                <th>Shift</th>
                                <th>Timing</th>
                                <th>Function</th>
                                <th>User</th>
                                <th>Equipment</th>
                                <th>Sub Equipment</th>
                                <th>Station</th>
                                <th>Status</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            @if(!empty($allLogsEntry))
                            @foreach($allLogsEntry as $key=>$value)
                            <tr>
                                <td>{{$loop->iteration}}</td>
                                <td>{{$value['ga_day']}}</td>
                                <td>{{$value['shift']}}</td>
                                <td>{{$value['start_time'] .'-'. $value['end_time']}}</td>
                                <td>{{$value['function']}}</td>
                                <td>{{$value['userId']}}</td>
                                <td>{{$value['equipment']}}</td>
                                <td>{{$value['sub_equipment']}}</td>
                                <td>{{$value['station']}}</td>
                                @if($value['status']=="0")
                                <td><span class="label label-danger">Temporary</span></td>
                                @else
                                <td><span class="label label-success">Saved</span></td>
                                @endif
                                <td>
                                    <?php $date = date("Y-m-d"); ?>
                                @if($value['status']==1 && $date <= $value['ga_day'] )
<a style="float:left; margin-right:10px;" href="{{ route('GALog', ['id' => $value['id'], 'action' => 'edit']) }}"><button type="button" class="btn btn-info btn-sm"><i class="ti-pencil"></i></button></a>
                                @endif
                                @if($value['status']==0) <a style="float:left; margin-right:10px;"
                                    href="{{ route('GALog', ['id' => $value['id'], 'action' => 'edit']) }}"><button type="button"
                                        class="btn btn-info btn-sm"><i class="ti-pencil"></i></button></a>
                                    @endif
                                 <form method="post" action="{{route('GALog',$value['id'])}}">
                            @csrf
                                <button type="submit" onclick="return confirm('Are you sure?')"  class="btn btn-warning btn-sm"><i class="ti-trash"></i></button>
                                </form></td>
                            </tr>
                            @endforeach
                            @endif
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script type="text/javascript">
$(document).ready(function(){
$("#shift_code").change(function(){
var selectedValue = $(this).val();
$.ajax({url: "/api/getShift", method: "post", data: { shift : selectedValue },
success: function(result){
const myArr = JSON.parse(result);
const newTimeValue = myArr.start_time + "-" + myArr.end_time;
    $("#start_end_time").val(newTimeValue);
  }});
});
});
</script>
@endpush