<?php
use App\Http\Controllers\Login\LoginController;//by purnima on 9-1-2024
use App\Http\Controllers\Admin\AdminController;//by purnima on 10-1-2024
use App\Http\Controllers\Shiftlog\ShiftlogController;//by purnima on 1-2-2024
use App\Http\Controllers\Master\MasterController;//by purnima on 8-2-24
use App\Http\Controllers\DPR\DcuController;//by purnima on 13-2-24
use App\Http\Controllers\WhatsApp\WhatsAppController;//by purnima on 28-3-24
use App\Http\Controllers\DPR\DPRController;

use App\Http\Controllers\Joinees\JoineesRegistrationController;//by dambaru on 22-2-24

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('phpmyinfo', function () {
    phpinfo(); 
})->name('phpmyinfo');

/*-------------login page by Purnima-------------*/
Route::get('redirectToProvider', [LoginController::class, 'redirectToProvider'])->name('redirectToProvider');
Route::any('handleProviderCallback', [LoginController::class, 'handleProviderCallback'])->name('handleProviderCallback');

Route::get('icons', [MasterController::class, 'icons'])->name('icons');
Route::get('logout', [LoginController::class, 'logout'])->name('logout');
Route::get('/', [LoginController::class, 'index'])->name('login');
Route::post('post-login', [LoginController::class, 'postLogin'])->name('login.post');

Route::get('dashboard', [AdminController::class, 'dashboard'])->name('dashboard');
Route::get('userRegistration', [AdminController::class, 'userRegistration'])->name('userRegistration');
Route::post('userRegistrationPost', [AdminController::class, 'userRegistrationPost'])->name('userRegistration.post');
Route::get('surveyAssignment', [AdminController::class, 'surveyAssignment'])->name('surveyAssignment');
Route::post('surveyAssignmentPost', [AdminController::class, 'surveyAssignmentPost'])->name('surveyAssignment.post');
Route::get('listSurveyDone', [AdminController::class, 'listSurveyDone'])->name('listSurveyDone');
Route::get('listSurveyAssigned', [AdminController::class, 'listSurveyAssigned'])->name('listSurveyAssigned');

Route::get('importUser', [AdminController::class, 'importUser'])->name('importUser');
Route::post('importUserPost', [AdminController::class, 'importUserPost'])->name('importUser.post');
Route::get('listCustomer', [AdminController::class, 'listCustomer'])->name('listCustomer');
Route::get('deleteCustomer/{zid}', [AdminController::class, 'deleteCustomer'])->name('deleteCustomer');

Route::get('listUser', [AdminController::class, 'listUser'])->name('listUser');

Route::get('importUserData', [AdminController::class, 'importUserData'])->name('importUserData');
Route::post('importUserPostData', [AdminController::class, 'importUserPostData'])->name('importUserData.post');


/*Shiftlog Routes started*/
Route::get('attendance', [ShiftlogController::class, 'attendance'])->name('attendance');
Route::post('attendancePost', [ShiftlogController::class, 'attendancePost'])->name('attendance.post');
Route::get('standingInstruction', [ShiftlogController::class, 'standingInstruction'])->name('standingInstruction');
Route::post('standingInstructionPost', [ShiftlogController::class, 'standingInstructionPost'])->name('standingInstruction.post');
/*Master routes*/
//ControlCenter
Route::get('controlCenterMaster', [MasterController::class, 'controlCenterMaster'])->name('controlCenterMaster');
Route::post('controlCenterMasterPost', [MasterController::class, 'controlCenterMasterPost'])->name('controlCenterMasterPost');
Route::post('controlCenterMasterDelete/{zid}', [MasterController::class, 'controlCenterMasterDelete'])->name('controlCenterMasterDelete');
//Function
Route::get('functionMaster', [MasterController::class, 'functionMaster'])->name('functionMaster');
Route::post('functionMasterPost', [MasterController::class, 'functionMasterPost'])->name('functionMasterPost');
Route::post('functionMasterDelete/{zid}', [MasterController::class, 'functionMasterDelete'])->name('functionMasterDelete');
//Shift
Route::get('shiftMaster', [MasterController::class, 'shiftMaster'])->name('shiftMaster');
Route::post('shiftMasterPost', [MasterController::class, 'shiftMasterPost'])->name('shiftMasterPost');
Route::post('shiftMasterDelete/{zid}', [MasterController::class, 'shiftMasterDelete'])->name('shiftMasterDelete');
//GA
Route::get('gaMaster', [MasterController::class, 'gaMaster'])->name('gaMaster');
Route::post('gaMasterPost', [MasterController::class, 'gaMasterPost'])->name('gaMasterPost');
Route::post('gaMasterDelete/{zid}', [MasterController::class, 'gaMasterDelete'])->name('gaMasterDelete');
//District
Route::get('districtMaster', [MasterController::class, 'districtMaster'])->name('districtMaster');
Route::post('districtMasterPost', [MasterController::class, 'districtMasterPost'])->name('districtMasterPost');
Route::post('districtMasterDelete/{zid}', [MasterController::class, 'districtMasterDelete'])->name('districtMasterDelete');
//Shift Check List
Route::get('shiftChecklistMaster', [MasterController::class, 'shiftChecklistMaster'])->name('shiftChecklistMaster');
Route::post('shiftChecklistMasterPost', [MasterController::class, 'shiftChecklistMasterPost'])->name('shiftChecklistMasterPost');
Route::post('shiftChecklistMasterDelete/{zid}', [MasterController::class, 'shiftChecklistMasterDelete'])->name('shiftChecklistMasterDelete');
//Equipment Master List
Route::get('equipmentMaster', [MasterController::class, 'equipmentMaster'])->name('equipmentMaster');
Route::post('equipmentMasterPost', [MasterController::class, 'equipmentMasterPost'])->name('equipmentMasterPost');
Route::post('equipmentMasterDelete/{zid}', [MasterController::class, 'equipmentMasterDelete'])->name('equipmentMasterDelete');
//Station Master List
Route::get('stationMaster', [MasterController::class, 'stationMaster'])->name('stationMaster');
Route::post('stationMasterPost', [MasterController::class, 'stationMasterPost'])->name('stationMasterPost');
Route::post('stationMasterDelete/{zid}', [MasterController::class, 'stationMasterDelete'])->name('stationMasterDelete');


/*Routes for DPR by purnima*/
Route::get('createUser', [MasterController::class, 'createUser'])->name('createUser');
Route::get('listAllUser', [MasterController::class, 'listAllUser'])->name('listAllUser');
Route::post('createUserPost', [MasterController::class, 'createUserPost'])->name('createUser.post');
Route::post('importOfficeUserPost', [MasterController::class, 'importOfficeUserPost'])->name('importOfficeUser.post');

Route::get('moduleMaster', [MasterController::class, 'moduleMaster'])->name('moduleMaster');
Route::post('moduleMasterPost', [MasterController::class, 'moduleMasterPost'])->name('moduleMasterPost');
Route::post('moduleMasterDelete/{zid}', [MasterController::class, 'moduleMasterDelete'])->name('moduleMasterDelete');
Route::get('roleMaster', [MasterController::class, 'roleMaster'])->name('roleMaster');
Route::post('roleMasterPost', [MasterController::class, 'roleMasterPost'])->name('roleMasterPost');
Route::post('roleMasterDelete/{zid}', [MasterController::class, 'roleMasterDelete'])->name('roleMasterDelete');

Route::get('dcuInput', [DcuController::class, 'dcuInput'])->name('dcuInput');
Route::post('dcuPost', [DcuController::class, 'dcuPost'])->name('dcu.post');
Route::get('gaInputSheet', [DcuController::class, 'gaInputSheet'])->name('gaInputSheet');
Route::get('districtInputSheet', [DcuController::class, 'districtInputSheet'])->name('districtInputSheet');
Route::post('gaDistrictInputPost', [DcuController::class, 'gaDistrictInputPost'])->name('gaDistrictInput.post');
Route::get('storageTank', [DcuController::class, 'storageTank'])->name('storageTank');
Route::post('storageTankPost', [DcuController::class, 'storageTankPost'])->name('storageTank.post');
Route::get('industryInputSheet', [DcuController::class, 'industryInputSheet'])->name('industryInputSheet');
Route::post('industryInputPost', [DcuController::class, 'industryInputPost'])->name('industryInput.post');

Route::get('gcvReportSheet', [DcuController::class, 'gcvReportSheet'])->name('gcvReportSheet');
Route::post('getGCV', [DcuController::class, 'getGCV'])->name('getGCV');
Route::post('getGCVStorage', [DcuController::class, 'getGCVStorage'])->name('getGCVStorage');


Route::get('cngPurchaseInputSheet', [DcuController::class, 'cngPurchaseInputSheet'])->name('cngPurchaseInputSheet');
Route::post('cngPurchaseInputPost', [DcuController::class, 'cngPurchaseInputPost'])->name('cngPurchaseInput.post');
Route::get('districtCNGReport', [DcuController::class, 'districtCNGReport'])->name('districtCNGReport');
Route::get('distCgdRecoReport', [DcuController::class, 'distCgdRecoReport'])->name('distCgdRecoReport');
Route::get('dailyMisReport', [DcuController::class, 'dailyMisReport'])->name('dailyMisReport');
Route::get('districtDashboard', [DcuController::class, 'districtDashboard'])->name('districtDashboard');
Route::get('dashboardHighlights', [DcuController::class, 'dashboardHighlights'])->name('dashboardHighlights');
Route::post('dashboardHighlightsPost', [DcuController::class, 'dashboardHighlightsPost'])->name('dashboardHighlightsPost');
Route::post('dashboardHighlightsDelete/{zid}', [DcuController::class, 'dashboardHighlightsDelete'])->name('dashboardHighlightsDelete');

//tankerno
Route::get('tankernoMaster', [MasterController::class, 'tankernoMaster'])->name('tankernoMaster');
Route::post('tankernoMasterPost', [MasterController::class, 'tankernoMasterPost'])->name('tankernoMasterPost');
Route::post('tankernoMasterDelete/{zid}', [MasterController::class, 'tankernoMasterDelete'])->name('tankernoMasterDelete');
//gastype
Route::get('gastypeMaster', [MasterController::class, 'gastypeMaster'])->name('gastypeMaster');
Route::post('gastypeMasterPost', [MasterController::class, 'gastypeMasterPost'])->name('gastypeMasterPost');
Route::post('gastypeMasterDelete/{zid}', [MasterController::class, 'gastypeMasterDelete'])->name('gastypeMasterDelete');

/*Routes for Whatsapp*/
Route::get('whatsAppTemplate', [WhatsAppController::class, 'whatsAppTemplate'])->name('whatsAppTemplate');
Route::post('whatsAppTemplatePost', [WhatsAppController::class, 'whatsAppTemplatePost'])->name('whatsAppTemplatePost');
Route::post('whatsAppTemplateDelete/{zid}', [WhatsAppController::class, 'whatsAppTemplateDelete'])->name('whatsAppTemplateDelete');
/*whatsapp image upload*/
Route::get('whatsAppUploadImage', [WhatsAppController::class, 'whatsAppUploadImage'])->name('whatsAppUploadImage');
Route::post('whatsAppUploadImagePost', [WhatsAppController::class, 'whatsAppUploadImagePost'])->name('whatsAppUploadImagePost');
Route::post('whatsAppUploadImageDelete/{zid}', [WhatsAppController::class, 'whatsAppUploadImageDelete'])->name('whatsAppUploadImageDelete');
Route::get('whatsAppImageApproval', [WhatsAppController::class, 'whatsAppImageApproval'])->name('whatsAppImageApproval');
Route::post('whatsAppImageAction', [WhatsAppController::class, 'whatsAppImageAction'])->name('whatsAppImageAction');
Route::get('sendWhatsAppMessage', [WhatsAppController::class, 'sendWhatsAppMessage'])->name('sendWhatsAppMessage');
Route::post('sendWhatsAppMessagePost', [WhatsAppController::class, 'sendWhatsAppMessagePost'])->name('sendWhatsAppMessagePost');
Route::any('getWhatsAppTemplateDetails', [WhatsAppController::class, 'getWhatsAppTemplateDetails'])->name('getWhatsAppTemplateDetails');
Route::any('whatsAppReport', [WhatsAppController::class, 'whatsAppReport'])->name('whatsAppReport');
Route::any('getWhatsAppReport', [WhatsAppController::class, 'getWhatsAppReport'])->name('getWhatsAppReport');
Route::any('getWhatsAppReportDetails', [WhatsAppController::class, 'getWhatsAppReportDetails'])->name('getWhatsAppReportDetails');

/*-------------Purnima's code end-------------*/


//Debakant's Code
Route::any('densityData', [DPRController::class, 'densityData'])->name('densityData');
Route::any('postDensityData', [DPRController::class, 'postDensityData'])->name('postDensityData');
Route::any('dprDom', [DPRController::class, 'dprDom'])->name('dprDom');
Route::any('postDomData', [DPRController::class, 'postDomData'])->name('postDomData');
Route::any('dprCom', [DPRController::class, 'dprCom'])->name('dprCom');
Route::any('postComData', [DPRController::class, 'postComData'])->name('postComData');
Route::any('dprSug', [DPRController::class, 'dprSug'])->name('dprSug');
Route::any('postSugData', [DPRController::class, 'postSugData'])->name('postSugData');
Route::any('dprTankerUnloading', [DPRController::class, 'dprTankerUnloading'])->name('dprTankerUnloading');
Route::any('postTankerUnloadingData', [DPRController::class, 'postTankerUnloadingData'])->name('postTankerUnloadingData');
Route::any('dprUnAccountedKnownGasLoss', [DPRController::class, 'dprUnAccountedKnownGasLoss'])->name('dprUnAccountedKnownGasLoss');
Route::any('postdprUnAccountedKnownGasLoss', [DPRController::class, 'postdprUnAccountedKnownGasLoss'])->name('postdprUnAccountedKnownGasLoss');
Route::any('dprJambusarBarmerLoading', [DPRController::class, 'dprJambusarBarmerLoading'])->name('dprJambusarBarmerLoading');
Route::any('postDprJambusarBarmerLoading', [DPRController::class, 'postDprJambusarBarmerLoading'])->name('postDprJambusarBarmerLoading');
Route::any('districtWiseSalesReport', [DPRController::class, 'districtWiseSalesReport'])->name('districtWiseSalesReport');
Route::any('generateSalesReport', [DPRController::class, 'generateSalesReport'])->name('generateSalesReport');
Route::any('masterSource', [MasterController::class, 'masterSource'])->name('masterSource');
Route::any('masterSourcePost', [MasterController::class, 'masterSourcePost'])->name('masterSourcePost');
Route::any('masterSourceDelete/{zid}', [MasterController::class, 'masterSourceDelete'])->name('masterSourceDelete');
Route::any('dprPELinePack', [DPRController::class, 'dprPELinePack'])->name('dprPELinePack');
Route::any('postdprPELinePack', [DPRController::class, 'postdprPELinePack'])->name('postdprPELinePack');
Route::any('dprSteelLinePack', [DPRController::class, 'dprSteelLinePack'])->name('dprSteelLinePack');
Route::any('postDprSteelLinePack', [DPRController::class, 'postDprSteelLinePack'])->name('postDprSteelLinePack');
Route::any('overAllGasRecoReport', [DPRController::class, 'overAllGasRecoReport'])->name('overAllGasRecoReport');
Route::any('generateOverAllGasRecoReport', [DPRController::class, 'generateOverAllGasRecoReport'])->name('generateOverAllGasRecoReport');
Route::any('masterNetwork', [MasterController::class, 'masterNetwork'])->name('masterNetwork');
Route::any('masterNetworkPost', [MasterController::class, 'masterNetworkPost'])->name('masterNetworkPost');
Route::any('masterNetworkDelete/{zid}', [MasterController::class, 'masterNetworkDelete'])->name('masterNetworkDelete');
Route::any('edCompressor', [DPRController::class, 'edCompressor'])->name('edCompressor');
Route::any('postEdCompressor', [DPRController::class, 'postEdCompressor'])->name('postEdCompressor');
//Debakant's Code


/* Dambaru's Code */
Route::get('joineesRegistration', [JoineesRegistrationController::class, 'joineesRegistration'])->name('joineesRegistration');
Route::post('joineesRegistrationPost', [JoineesRegistrationController::class, 'joineesRegistrationPost'])->name('joineesRegistration.post');

/* Dambaru's Code */