<?php
namespace App\Http\Controllers\Admin;
  
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Session;
use App\Models\Logs;
use App\Models\User;
use App\Models\Customer;
use App\Models\SurveyAssignment;
use App\Models\SurveyDone;

use Illuminate\Support\Facades\Validator;
use Exception;
use Log;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Password;
use Illuminate\Support\Facades\Schema;
use Storage;
use DB;
  
class AdminController extends Controller
{
    /**
     * Write code on Method
     *
     * @return response()
     */
    public function dashboard()
    {
        $user=auth()->user();
        if(Auth::check()){
          $ga=Customer::pluck("GA")->toArray();
          $ga=array_unique($ga);
          $bg=Customer::pluck("BP_Grouping")->toArray();
          $bg=array_unique($bg);
          
            return view('main.dashboard',['ga'=>$ga,'bg'=>$bg]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function userRegistration()
    {
        $user=auth()->user();
        if(Auth::check()){
          $ga=Customer::pluck("GA")->toArray();
          $ga=array_unique($ga);
          $bg=Customer::pluck("BP_Grouping")->toArray();
          $bg=array_unique($bg);
          
            return view('main.user_registration',['ga'=>$ga,'bg'=>$bg]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    } 
    public function listUser()
    {
        
        $user=auth()->user();
        if(Auth::check()){
            return view('main.user_list',[]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function getUser(Request $request)
    {
        $alldata=$request->all();
        $form=$request->input('formdata');
        $params = array();
        if(isset($request->device))
        {
            $device=$request->device;
        }
        else
        {
            $device="";
        } 
        $uid=$alldata['userId'];
        $desig=User::where("userId",$uid)->value("role");
        $ga=User::where("userId",$uid)->value("ga");
        parse_str($form, $params);
        $query = User::query();
        $query=$query->where("id","!=","1");
        if($desig=="Super Admin" || $desig=="Admin")
        {
            $query = $query;
        }
        else
        {
            $query=$query->where("ga",$ga);
        }
        //echo $query->toSql();
        if(!empty($params))
        {
            foreach($params as $kk=>$vall)
            {
                if($vall!="")
                {
                    $query=$query->where($kk,$vall);
                }
            }
        }
        if($device=="web") 
        {
            $columns = ['id','userId','userName','email','phone','role','ga'];
            $totalData = User::count();
            $totalFiltered = $totalData;
            $limit = $request->input('length');
            $start = $request->input('start');
            $order = $columns[$request->input('order.0.column')];
            $dir = $request->input('order.0.dir');
             if(!empty($request->input('search.value')))
             {
                $search = $request->input('search.value'); 
                 $query = $query->where(function ($query) use ($search) {
              $query-> where('userId', 'LIKE',"%{$search}%")
                    ->orWhere('userName', 'LIKE',"%{$search}%") 
                    ->orWhere('ga', 'LIKE',"%{$search}%") 
                    ->orWhere('role', 'LIKE',"%{$search}%") 
                    ->orWhere('email', 'LIKE',"%{$search}%")
                    ->orWhere('phone', 'LIKE',"%{$search}%");
                 });
             }
            $totalFiltered= $query->count();
            if ($limit== -1){
                    $posts = $query->orderBy($order,$dir)
                    ->get();   
                }
                else{
                   $posts = $query->offset($start)
                            ->limit($limit)
                            ->orderBy($order,$dir)
                            ->get(); 
                }
            
        }
        else
        { 
            $posts = $query->get()->toArray();
        }
        $data = array();
        if (!empty($posts)) {
            if($device=="")
            {
                $data=$posts;
            }
            else
            {
                $i=0;
                foreach ($posts as $post) {
                    $i++;
              
                $nestedData["slno"]=$i;  
				$nestedData["userId"]=$post->userId;  
                $nestedData['userName']=$post->userName;
                $nestedData['ga'] = $post->ga;
                $nestedData['role'] = $post->role;
                $nestedData['email'] = $post->email;
                $nestedData['phone'] = $post->phone;
                $data[] = $nestedData;
                }
            }
        }

        if($device=="web")
        {
            $json_data = array(
            "draw" => intval($request->input('draw')),
            "recordsTotal" => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data" => $data,);
            echo json_encode($json_data);
        }
        else
        {
            $logs = array(
                        'module' => "Survey",
                        'user' => $alldata['userId'],
                        'access_device' => $device,
                        'called_api' => route('listUser'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => json_encode($data1),
                        'method_name' => "POST",
        
                    );
            $log = manageLogs($logs);
            return response()->json(["status" => config("constants.OK"),"code" => 1, "msg" => "User Fetched!", "data"=>$data]);
        }

    }
    public function userRegistrationPost(Request $request)
    {
        $alldata=$request->all();
        $password=$alldata['password'];
        if(isset($alldata['device']))
        {
            $device=$alldata['device'];
        }
        else
        {
            $device="Mobile";
        }
        $validator=  Validator::make($alldata, [
            'userId' => ['required'],
            'userName' => ['required'],
            'role' => ['required'],
            'password' => [
            'required',
            'string',
            'min:6',             // must be at least 10 characters in length
            'regex:/[a-z]/',      // must contain at least one lowercase letter
            'regex:/[A-Z]/',      // must contain at least one uppercase letter
            'regex:/[0-9]/',      // must contain at least one digit
            'regex:/[@$!%*#?&]/', // must contain a special character
        ],
        ], ['password.min' => 'The password field must be atleast 6 characters in length and contain at least one lowercase letter,one uppercase letter,one digit and a special character!']
        , ['password.regex' => 'The password field must be atleast 6 characters in length and contain at least one lowercase letter,one uppercase letter,one digit and a special character!']);

        if($validator->fails()) 
        {
            if($device=="web")
            {
                return back()->with(["status" => "failed", "code"=>config("constants.CODE_FAILURE"),"msg" => $validator->errors()->first(), "errors" => $validator->errors()]);
            }
            else
            {
                $logs = array(
                        'module' => "User",
                        'user' => $alldata['userId'],
                        'access_device' => $device,
                        'called_api' => route('userRegistration'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => $validator->errors()->first(),
                        'method_name' => "POST",
        
                    );
                $log = manageLogs($logs);
                return response()->json(["status" => "failed", "code"=>config("constants.CODE_FAILURE"),"msg" => $validator->errors()->first()]);
            }
        }
		else
		{
		    $data['userId']=$alldata['userId'];
		    $data['userName']=$alldata['userName'];
		    $data['email']=$alldata['email'];
		    $data['phone']=$alldata['phone'];
		    $data['role']=$alldata['role'];
		    $data['password']=hashIt($password);
		    $data['ga']=$alldata['GA'];
            $create = User::insertGetId($data); 
            if($create)
            {
                if($device=="web")
                {
                    return back()->with(["status" => 200, "msg" => "User Created successfully.","code" => config("constants.CODE_SUCCESS")]);
                }
                else
                {
                    $logs = array(
                            'module' => "User",
                            'user' => $alldata['userId'],
                            'access_device' => $device,
                            'called_api' => route('userRegistration'),
                            'called_to' => "web",
                            'request_data' => json_encode($alldata),
                            'response_data' => "Password set successfully!",
                            'method_name' => "POST",
            
                        );
                    $log = manageLogs($logs);
                    return response()->json(["status" => 200, "msg" => "User Created successfully.","code" => config("constants.CODE_SUCCESS")]);
                } 
            }
            else
            {
                if($device=="web")
                {
                    return back()->with(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
                }
                else
                {
                    $logs = array(
                        'module' => "User",
                        'user' => $alldata['userId'],
                        'access_device' => $device,
                        'called_api' => route('userRegistration'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => "Failed! Please try again.",
                        'method_name' => "POST",
        
                    );
                $log = manageLogs($logs);
                    return response()->json(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
                }
            }

       
    	}   
    }
    public function surveyAssignment()
    {
        $user=auth()->user();
        if(Auth::check()){
          $cac=Customer::pluck("Charge_Area_Code")->toArray();
          $cac=array_unique($cac);
          sort($cac);
          $bg=Customer::pluck("BP_Grouping")->toArray();
          $bg=array_unique($bg);
          sort($bg);
          $mru=Customer::pluck("MRU")->toArray();
          $mru=array_values(array_unique($mru));
          sort($mru);
          $surveyor=User::where("role","Surveyor")->pluck("userName","userId");
            return view('main.survey_assignment',['cac'=>$cac,'bg'=>$bg,'mru'=>$mru,'surveyor'=>$surveyor]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    } 
    public function listCustomer()
    {
        $user=auth()->user();
        if(Auth::check()){
            return view('main.customer_list',[]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    } 
    public function getCustomer(Request $request)
    {
        $alldata=$request->all();
        $form=$request->input('formdata');
        $params = array();
        if(isset($request->device))
        {
            $device=$request->device;
        }
        else
        {
            $device="";
        } 
        $uid=$alldata['userId'];
        $desig=User::where("userId",$uid)->value("role");
        $ga=User::where("userId",$uid)->value("ga");
        parse_str($form, $params);
        $query = Customer::query();
        $status=SurveyAssignment::whereIn("status",array("Pending","House Locked"))->orderBy("id","desc")->get()->toArray();
        if(!empty($status))
        {
            foreach($status as $k=>$st)
            {
                $cas[]=$st['ca'];
            }
        }
        if(!empty($cas))
        {
            $query=$query->whereNotIn("CA",$cas);
        }
           
        if($desig=="Super Admin" || $desig=="Admin")
        {
            $query = $query;
        }
        else
        {
            $query=$query->where("GA",$ga);
        }
        //echo $query->toSql();
        if(!empty($params))
        {
            foreach($params as $kk=>$vall)
            {
                if($vall!="")
                {
                    $query=$query->where($kk,$vall);
                }
            }
        }
        if($device=="web") 
        {
            $columns = [ 'CA','id','GA','Charge_Area_Code', 'BP_Grouping', 'CA',  'Application_Number', 'Name_of_the_Customer','Meter_Serial_No', 'MRU'];
            $totalData = Customer::count();
            $totalFiltered = $totalData;
            $limit = $request->input('length');
            $start = $request->input('start');
            $order = $columns[$request->input('order.0.column')];
            $dir = $request->input('order.0.dir');
             if(!empty($request->input('search.value')))
             {
                $search = $request->input('search.value'); 
                 $query = $query->where(function ($query) use ($search) {
              $query-> where('Name_of_the_Customer', 'LIKE',"%{$search}%")
                    ->orWhere('Application_Number', 'LIKE',"%{$search}%") 
                    ->orWhere('GA', 'LIKE',"%{$search}%") 
                    ->orWhere('CA', 'LIKE',"%{$search}%") 
                    ->orWhere('Charge_Area_Code', 'LIKE',"%{$search}%")
                    ->orWhere('MRU', 'LIKE',"%{$search}%")
                    ->orWhere('Meter_Serial_No', 'LIKE',"%{$search}%")
                    ->orWhere('BP_Grouping', 'LIKE',"%{$search}%");
                 });
             }
            $totalFiltered= $query->count();
            if ($limit== -1){
                
                    $posts = $query->orderBy($order,$dir)
                    ->get();  
                   
                }
                else{
                   $posts = $query->offset($start)
                            ->limit($limit)
                            ->orderBy($order,$dir)
                            ->get(); 
                            
                }
            
        }
        else
        { 
            $posts = $query->get()->toArray();
        }
        
        $data = array();
        if (!empty($posts)) {
            
            if($device=="")
            {
                $data=$posts;
            }
            else
            {
                $i=0;
                foreach ($posts as $post) {
                    $i++;
                //$show = route('retailer.delete', $post->id);
                $status=SurveyAssignment::where("ca",$post->CA)->orderBy("id","desc")->value("status");
                 $show=route('deleteCustomer', $post->id);
                        $con="confirm('Are you sure?')";
                $option='<a href="' . $show . '" onclick="return '.$con.'" title="DELETE" ><button type="button" class="btn btn-danger btn-sm" title="Delete"><i class="ti-trash"></i></button></a>';
                
                if($status=="Pending" || $status=="House Locked")
                {
                    $nestedData["chk"]="";
                }
                else
                $nestedData["chk"]="<input type='checkbox' class='chk' name='ca[".$post->CA."]' value='".$post->CA."'>"; 
                $nestedData["slno"]=$i;  
				$nestedData["Charge_Area_Code"]=$post->Charge_Area_Code;  
                $nestedData['BP_Grouping']=$post->BP_Grouping;
                $nestedData['GA'] = $post->GA;
                $nestedData['CA'] = $post->CA;
                $nestedData['Application_Number'] = $post->Application_Number;
                $nestedData['Name_of_the_Customer'] = $post->Name_of_the_Customer;
                $nestedData['Meter_Serial_No'] = $post->Meter_Serial_No;
                $nestedData['PNGRB_District_t'] = $post->PNGRB_District_t;
                $nestedData['Address_District'] = $post->Address_District;
                $nestedData['MRU'] = $post->MRU;
                $nestedData['options'] =$option;
                $data[] = $nestedData;
                }
            }
        }

        if($device=="web")
        {
            $json_data = array(
            "draw" => intval($request->input('draw')),
            "recordsTotal" => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data" => $data,);
            echo json_encode($json_data);
        }
        else
        {
            $logs = array(
                        'module' => "Survey",
                        'user' => $alldata['userId'],
                        'access_device' => $device,
                        'called_api' => route('surveyAssignment'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => json_encode($data1),
                        'method_name' => "POST",
        
                    );
            $log = manageLogs($logs);
            return response()->json(["status" => config("constants.OK"),"code" => 1, "msg" => "Customer Fetched!", "data"=>$data]);
        }

    }
    public function deleteCustomer($zid)
    {
        $delete  = Customer::where("id",$zid)->delete();
        if($delete)
        {
             return back()->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Customer deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Customer deletion failed!"]);
        }
    }
    public function getSurveyor(Request $request)
    {
        $alldata=$request->all();
        $ga=Customer::where("CA",$alldata['customer'][0])->value("GA");
        $surveyor=User::where("ga",$ga)->pluck("userName","userId");
        echo $surveyor;
    }
    public function surveyAssignmentPost(Request $request)
    {
        $alldata=$request->all();
        $ca=explode(",",$alldata['ca']);
        
        $assignment_id=assignmentId();
        if(!empty($ca))
        {
            foreach($ca as $k=>$v)
            {
                $customer=Customer::where("CA",$v)->first();
                $data['ca']=$v;
                $data['agp_user']=$alldata['agp_user'];
                $data['customer_type']=$customer['Customer_Type'];
                $data['installation_no']=$customer['Installation_No'];
                $data['application_no']=$customer['Application_Number'];
                $data['name_of_the_customer']=$customer['Name_of_the_Customer'];
                $data['full_address_of_the_customer']=$customer['Full_Address_of_the_Customer'];
                $data['contact_no']=$customer['Contact_No'];
                $data['mobile_number']=$customer['Mobile_Number'];
                $data['email_address']=$customer['Email_Address'];
                $data['dma_scheme']=$customer['DMA_SCHEME'];
                $data['scheme_description']=$customer['Scheme_Description'];
                $data['meter_serial_no']=$customer['Meter_Serial_No'];
                $data['meter_installation_date']=$customer['Meter_Installation_date'];
                $data['meter_manufacturer_name']=$customer['Meter_Manufacturer_name'];
                $data['assignment_id']=$assignment_id;
                $data['status']="Pending";
                $create = SurveyAssignment::insertGetId($data); 
            }
            if($create)
            {
                return back()->with(["status" => 200, "msg" => "User Assigned successfully.","code" => config("constants.CODE_SUCCESS")]);
            }
        }
    }
    public function listSurveyDone()
    {
        $user=auth()->user();
        if(Auth::check()){
            return view('main.survey_done',[]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    } 
    public function listSurveyAssigned()
    {
        $user=auth()->user();
        if(Auth::check()){
            return view('main.survey_assigned',[]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    } 
    public function importUser()
    {
        $user=auth()->user();
        if(Auth::check()){
          
            return view('main.import_user',[]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    } 
    public function importUserPost(Request $request)
    {
        $requiredHeaders = array('id',	'Company',	'GA',	'PNGRB_District_t',	'Address_District',	'Charge_Area_Code',	'BP_Grouping',	'Application_Number',	'BP_Creation_Date',	'Business_Partner',	'CA',	'CA_Creation_date',	'Interest_Lock_Reason',	'Posting_Lock_Reason',	'BP_Lock_Status',	'Installation_Blocking_Reason',	'Customer_Type',	'Installation_No',	'Name_of_the_Customer',	'Full_Address_of_the_Customer',	'Contact_No',	'Mobile_Number',	'Email_Address',	'DMA_SCHEME',	'Scheme_Description',	'Portion',	'MRU',	'MRU_Description',	'Material_No',	'Meter_Serial_No',	'Meter_Manufacturer_name',	'Meter_Installation_date',	'Volume_Correction_Factor',	'Move_in_date_from_legacy_system',	'Move_out_date',	'Move_in_date_created_in_SAP',	'Actual_Move_in_date',	'Move_in_Read',	'Registration_Amount_Requested',	'Registration_Amount_Received',	'Conn_Security_dep_amount_requested',	'Consum_Security_dep_amount_requested',	'Conn_Security_dep_amount_received',	'Consum_Security_dep_amount_received',	'BP_creation_to_Move_in_aging_days',	'SRM_Number',	'Functional_Location',	'SRM_Description'
    );
        $aa="Customer";
        $path = $request->file('file')->getRealPath();
        // print_r($path);exit;
        $records = array_map('str_getcsv', file($path));
       
        if (! count($records) > 0) {
            return back()->with(["status" =>200,"code" => 1, "success" => false, "msg" => "No Records Found!"]);
        }
        // Get field names from header column
       // $fields = array_map('strtolower', $records[0]);
       $fields =$records[0];
        //echo count($fields); exit;
        if ($fields !== $requiredHeaders) {
             return back()->with(["status" =>200,"code" => 0, "success" => false, "msg" => "Please upload data in correct format!"]);
             exit;
         }
        
        // Remove the header column
        array_shift($records);
        foreach ($records as $record) {
            if (count($fields) != count($record)) {
                return back()->with(["status" => 200,"code" => 1, "success" => false, "msg" => "Invalid data!"]);
            }
            // Decode unwanted html entities
            $record =  array_map("html_entity_decode", $record);

            // Set the field name as key
            $record = array_combine($fields, $record);
            // Get the clean data
            $this->rows[] = $this->clear_encoding_str($record);
        }
        foreach ($this->rows as $data) {
           // print_r($data); exit;
            Customer::create($data);
        }
        return back()->with(["status" => 200,"code" => 1, "success" => true, "msg" => "$aa list uploaded successfully!"]);
    }
    private function clear_encoding_str($value)
    {
        if (is_array($value)) {
            $clean = [];
            foreach ($value as $key => $val) {
                if(!in_array($key,array('id', 'Company', 'GA', 'PNGRB_District_t', 'Address_District', 'Charge_Area_Code', 'BP_Grouping', 'Application_Number', 'BP_Creation_Date', 'Business_Partner', 'CA', 'CA_Creation_date', 'Interest_Lock_Reason', 'Posting_Lock_Reason', 'BP_Lock_Status', 'Installation_Blocking_Reason', 'Customer_Type', 'Installation_No', 'Name_of_the_Customer',  'DMA_SCHEME', 'Scheme_Description', 'Portion', 'MRU', 'MRU_Description', 'Material_No', 'Meter_Serial_No', 'Meter_Manufacturer_name', 'Meter_Installation_date', 'Volume_Correction_Factor', 'Move_in_date_from_legacy_system', 'Move_out_date', 'Move_in_date_created_in_SAP', 'Actual_Move_in_date', 'Move_in_Read', 'Registration_Amount_Requested', 'Registration_Amount_Received', 'Conn_Security_dep_amount_requested', 'Consum_Security_dep_amount_requested', 'Conn_Security_dep_amount_received', 'Consum_Security_dep_amount_received', 'BP_creation_to_Move_in_aging_days', 'SRM_Number', 'Functional_Location', 'SRM_Description', 'updated_at', 'created_at','userId','employee_id','designation','employee_type')))
                $clean[$key] = mb_convert_encoding(encryptIt($val), 'UTF-8', 'UTF-8');
                else
                $clean[$key] = mb_convert_encoding($val, 'UTF-8', 'UTF-8');
              //  $clean[$key] = mb_convert_encoding($val, 'UTF-8', 'UTF-8');
            }
            return $clean;
        }
        return mb_convert_encoding($value, 'UTF-8', 'UTF-8');
    }
	
	 //import user designation,emp-id & emp-type
		public function importUserData()
		{
			$user=auth()->user();
			if(Auth::check()){
			  
				return view('main.import_user_data',[]);
			}
			else
			{
				return redirect("/")->withSuccess('Opps! You do not have access');
				 
			}
		} 
		
	 public function importUserPostData(Request $request)
		{
		$requiredHeaders = array('userId','employee_id','designation','employee_type');
        $aa="Customer";
        $path = $request->file('file')->getRealPath();
        // print_r($path);exit;
        $records = array_map('str_getcsv', file($path));
       
        if (! count($records) > 0) {
            return back()->with(["status" =>200,"code" => 1, "success" => false, "msg" => "No Records Found!"]);
        }
        // Get field names from header column
       // $fields = array_map('strtolower', $records[0]);
       $fields =$records[0];
        //echo count($fields); exit;
        if ($fields !== $requiredHeaders) {
             return back()->with(["status" =>200,"code" => 0, "success" => false, "msg" => "Please upload data in correct format!"]);
             exit;
         }
        // Remove the header column
        array_shift($records);
        foreach ($records as $record) {
            if (count($fields) != count($record)) {
                return back()->with(["status" => 200,"code" => 1, "success" => false, "msg" => "Invalid data!"]);
            }
            // Decode unwanted html entities
            $record =  array_map("html_entity_decode", $record);

            // Set the field name as key
            $record = array_combine($fields, $record);
            // Get the clean data
            $this->rows[] = $this->clear_encoding_str($record);
        }
        foreach ($this->rows as $data) {
            //print_r($data); exit;
		   User::where("userId",$data['userId'])->update(array("employee_id"=>$data['employee_id'],"designation"=>$data['designation'],"employee_type"=>$data['employee_type']));
        }
        return back()->with(["status" => 200,"code" => 1, "success" => true, "msg" => "User Data uploaded successfully!"]);
		}
	
	
	
	
}