<?php
namespace App\Http\Controllers\DPR;
  
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Session;
use App\Models\Logs;
use App\Models\User;
use App\Models\Customer;
use App\Models\DprDcu;
use App\Models\DprInputs;
use App\Models\DprInputsGA;

use App\Models\DprIndustry;
/*For storagetanks*/
use App\Models\MasterStations;
use App\Models\DprStorageTank1;
use App\Models\DprStorageTank1ComponentMi;
use App\Models\DprStorageTank1ComponentZi;
/*storage tanks end*/
/*GCV*/
use App\Models\DprGCVReport;
use App\Models\DprDistrictCNGReport;
use App\Models\DprCngPurchaseInputSheet;
use App\Models\DprDistrictCGDRecoReport;
use App\Models\DPRDailyMisReport;
use App\Models\DprHighlights;
use App\Models\DprGaSalesReport;


use Illuminate\Support\Facades\Validator;
use Exception;
use Log;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Password;
use Illuminate\Support\Facades\Schema;
use Storage;
use DB;
  
class DcuController extends Controller
{
    /**
     * Write code on Method
     *
     * @return response()
     */
    public function dcuInput(Request $request)
    {
        $user=auth()->user();
        if(Auth::check()){
          $ga=dd_masters("ga","ga_code");
          $district=dd_masters("district","address_district");
           $input_details=array();
            if($request->id)
            {
                 $input_details=  DprDcu::where("id", $request->id)->first();// check for the unique date
            }
            return view('dpr.dcuInput',['ga'=>$ga,'district'=>$district,'input_details'=>$input_details]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function dcuPost(Request $request)
    {
        $alldata=$request->all();
        //print_r($alldata);exit;
        if(isset($alldata['device']))
        {
            $device=$alldata['device'];
        }
        else
        {
            $device="";
        }
        $validator=  Validator::make($alldata, [
            "ga_code"=>"required",
            "district"=>"required",
            "dcu_date"=>"required",
            "cumulative_corrected"=>"required",
            "cumulative_uncorrected"=>"required"
        ]
        );

        if($validator->fails()) {
            if($device=="web")
            {
               // return "Failed";
               return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
            }
            else
            {
                $logs = array(
                        'module' => "DPR",
                        'user' => $alldata['user_id'],
                        'access_device' => $device,
                        'called_api' => route('dcuInput'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => $validator->errors()->first(),
                        'method_name' => "POST",
        
                    );
                $log = manageLogs($logs);
                return response()->json(["status" => "failed", "code"=>config("constants.CODE_FAILURE"),"msg" => $validator->errors()->first()]);
            }
        }
        $dcudate=date("Y-m-d",strtotime($request->dcu_date));
        $data =array(
            "user_id"=>$request->user_id,
            "cumulative_corrected"=>$request->cumulative_corrected,
            "corrected_volume"=>$request->corrected_volume,
            "cumulative_uncorrected"=>$request->cumulative_uncorrected,
            "uncorrected_volume"=>$request->uncorrected_volume,
            "cf"=>$request->cf,
            "ga_code"=>$request->ga_code,
            "district"=>$request->district,
             "dcu_date"=>$dcudate,
            "status"=>"Active",
            "created_at"=>date("Y-m-d H:i:s"),
            "updated_at"=>date("Y-m-d H:i:s")
        );
        
        $row_status=  DprDcu::where("ga_code",$request->ga_code)->where("district", $request->district)->where("dcu_date", $dcudate)->first();// check for the unique date
        if(!is_null($row_status)) {
           // return "Failed";
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Date value is already exists!"]);
        }
        $create  = DprDcu::insert($data); // add new row in table
        if($create)
        {
            if($device=="web")
            {
                //return "Success";
               return back()->with(["status" => 200, "msg" => "Data inserted successfully.","code" => config("constants.CODE_SUCCESS")]);
            }
            else
            {
                $logs = array(
                        'module' => "DPR",
                        'user' => $alldata['user_id'],
                        'access_device' => $device,
                        'called_api' => route('dcuInput'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => "Success!",
                        'method_name' => "POST",
        
                    );
                $log = manageLogs($logs);
                return response()->json(["status" => 200, "msg" => "Data inserted successfully.","code" => config("constants.CODE_SUCCESS")]);
            } 
        }
        else
        {
            if($device=="web")
            {
               // echo "Failed";
                return back()->with(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
            }
            else
            {
                $logs = array(
                    'module' => "DPR",
                    'user' => $alldata['user_id'],
                    'access_device' => $device,
                    'called_api' => route('dcuInput'),
                    'called_to' => "web",
                    'request_data' => json_encode($alldata),
                    'response_data' => "Failed! Please try again.",
                    'method_name' => "POST",
    
                );
            $log = manageLogs($logs);
                return response()->json(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
            }
        }
    }
    public function getDcu(Request $request)
    {
        $cumulative_corrected1=$cumulative_uncorrected1=0;
        $alldata=$request->all();
        $data=DprDcu::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district'])->orderBy("dcu_date","desc")->get()->toArray();
        $cumulative_corrected1=DprDcu::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district'])->orderBy("dcu_date","desc")->value("cumulative_corrected");
        $cumulative_uncorrected1=DprDcu::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district'])->orderBy("dcu_date","desc")->value("cumulative_uncorrected");
        if($cumulative_corrected1)$cumulative_corrected1=$cumulative_corrected1;
        else $cumulative_corrected1=0;
        if($cumulative_uncorrected1)$cumulative_uncorrected1=$cumulative_uncorrected1;
        else $cumulative_uncorrected1=0;
        $tr="<input type='hidden' id='cumulative_corrected1' value='".$cumulative_corrected1."'><input type='hidden' id='cumulative_uncorrected1' value='".$cumulative_uncorrected1."'>";
         $tr.='<tr><td><input type="date" class="form-control" name="dcu_date"></td><td><input type="number" class="form-control" placeholder="Cumulative Corrected" step="0.001" name="cumulative_corrected" id="cumulative_corrected"></td><td><input type="number" class="form-control" placeholder="Corrected Volume" step="0.001" id="corrected_volume"><input type="hidden" class="form-control" id="hid_corrected_volume" name="corrected_volume"></td><td><input type="number" class="form-control" placeholder="Cumulative Uncorrected" step="0.001" name="cumulative_uncorrected" id="cumulative_uncorrected"></td><td><input type="number" class="form-control" placeholder="Uncorrected Volume" step="0.001" id="uncorrected_volume"><input type="hidden" class="form-control" id="hid_uncorrected_volume" name="uncorrected_volume"></td><td><input type="number" step="0.001" class="form-control" id="cf"><input type="hidden" class="form-control" id="hid_cf" name="cf"></td> <td><button type="submit" class="btn btn-primary text-white" id="submit" value="Submit">Submit</button></td></tr>';
        if(!empty($data))
        {
            foreach($data as $val)
            {
                $dcu_date=date("d/m/Y",strtotime($val['dcu_date']));
               // $dcu_date=$val['dcu_date'];
                $edit="";
                if($dcu_date==date('d/m/Y'))$edit='<a href="'.route("dcuInput",["id"=>$val["id"]]).'"><button type="button" class="btn btn-info text-white" id="submit" value="Edit">Edit</button></a>';
                $tr.="<tr>";
                $tr.="<td>".$dcu_date."</td>";
                $tr.="<td>".$val['cumulative_corrected']."</td>";
                $tr.="<td>".$val['corrected_volume']."</td>";
                $tr.="<td>".$val['cumulative_uncorrected']."</td>";
                $tr.="<td>".$val['uncorrected_volume']."</td>";
                $tr.="<td>".$val['cf']."</td>";
                $tr.="<td>".$edit."</td>";
                $tr.="</tr>";
            }
        }
       
        echo json_encode($tr);
    }
    /*gaDistrictInput*/
    public function districtInputSheet(Request $request)
    {
        $user=auth()->user();
        if(Auth::check()){
            $input_details=array();
            if($request->id)
            {
                 $input_details=  DprInputs::where("id", $request->id)->first();// check for the unique date
            }
          $ga=dd_masters("ga","ga_code");
          $district=dd_masters("district","address_district");
            return view('dpr.districtInputSheet',['ga'=>$ga,'district'=>$district,"input_details"=>$input_details]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function gaInputSheet()
    {
        $user=auth()->user();
        if(Auth::check()){
          $ga=dd_masters("ga","ga_code");
          $district=dd_masters("district","address_district");
            return view('dpr.gaInputSheet',['ga'=>$ga,'district'=>$district]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function gaDistrictInputPost(Request $request)
    {
        $device="";
        $alldata=$request->all();
        $alldata['created_at']=date("Y-m-d H:i:s");
        $alldata['updated_at']=date("Y-m-d H:i:s");
        $alldata['status']="Active";
        unset($alldata['_token']);
        if(isset($alldata['device']))$device=$alldata['device'];
        unset($alldata['device']);
        unset($alldata['customRadio']);
        
        /*$validator=  Validator::make($alldata, [
            "ga_code"=>"required",
            "district"=>"required",
            "dcu_date"=>"required",
            "cumulative_corrected"=>"required",
            "cumulative_uncorrected"=>"required"
        ]
        );

        if($validator->fails()) {
            if($device=="web")
            {
                return "Failed";
              // return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
            }
            else
            {
                $logs = array(
                        'module' => "DPR",
                        'user' => $alldata['user_id'],
                        'access_device' => $device,
                        'called_api' => route('dcuInput'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => $validator->errors()->first(),
                        'method_name' => "POST",
        
                    );
                $log = manageLogs($logs);
                return response()->json(["status" => "failed", "code"=>config("constants.CODE_FAILURE"),"msg" => $validator->errors()->first()]);
            }
        }*/
        $dcudate=date("Y-m-d",strtotime($request->input_date));
        $data =$alldata;
        if($request->input_id)
        {
            $row_status=  DprInputs::where("id", "!= ",$request->input_id)->where("input_date", $dcudate)->where("ga_code",$request->ga_code)->where("district",$request->district)->first();// check for the unique date
        }
        else
        $row_status=  DprInputs::where("input_date", $dcudate)->where("ga_code",$request->ga_code)->where("district",$request->district)->first();// check for the unique date
        if(!is_null($row_status)) {
           // return "Failed";
           return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Date value is already exists!"]);
        }
         if($request->input_id)
        {
            unset($data['input_id']);
            $create  = DprInputs::where("id", $request->input_id)->update($data);
        }
        else
        $create  = DprInputs::insert($data); // add new row in table
        if($create)
        {
            if($device=="web")
            {
               // return "Success";
              // return to_route('districtInputSheet')->with(["status" => 200, "msg" => "Data inserted successfully.","code" => config("constants.CODE_SUCCESS")]);
               return back()->with(["status" => 200, "msg" => "Data inserted successfully.","code" => config("constants.CODE_SUCCESS")]);
            }
            else
            {
                $logs = array(
                        'module' => "DPR",
                        'user' => $alldata['user_id'],
                        'access_device' => $device,
                        'called_api' => route('gaDistInput'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => "Success!",
                        'method_name' => "POST",
        
                    );
                $log = manageLogs($logs);
                return response()->json(["status" => 200, "msg" => "Data inserted successfully.","code" => config("constants.CODE_SUCCESS")]);
            } 
        }
        else
        {
            if($device=="web")
            {
                //echo "Failed";
                return back()->with(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
            }
            else
            {
                $logs = array(
                    'module' => "DPR",
                    'user' => $alldata['user_id'],
                    'access_device' => $device,
                    'called_api' => route('gaInputInput'),
                    'called_to' => "web",
                    'request_data' => json_encode($alldata),
                    'response_data' => "Failed! Please try again.",
                    'method_name' => "POST",
    
                );
            $log = manageLogs($logs);
                return response()->json(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
            }
        }
    }
    public function getInputs(Request $request)
    {
        $cumulative_corrected1=$cumulative_uncorrected1=0;
        $alldata=$request->all();
        $data=DprInputs::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district'])->orderBy("input_date","desc")->get()->toArray();
        $tr="";
        $tr.='<tr>
        <td><input type="date" name="input_date"></td>
        <td><input type="text" name="quantity_of_LNG_invoiced_at_the_LNG_terminal" id="quantity_of_LNG_invoiced_at_the_LNG_terminal"></td>
        <td><input type="text" name="quantity_of_LNG_unloaded_at_the_LNG_terminal_as_per_MFM" id="quantity_of_LNG_unloaded_at_the_LNG_terminal_as_per_MFM"></td>
        <td><input type="text" name="quantity_of_LNG_unloaded_at_the_LCNG_station_as_per_weighment" id="quantity_of_LNG_unloaded_at_the_LCNG_station_as_per_weighment"></td>
        <td><input type="text" name="tank_1" id="tank_1"></td>
        <td><input type="text" name="tank_2" id="tank_2"></td>
        <td><input type="text" name="tank_3" id="tank_3"></td>
        <td><input type="text" name="tank_4" id="tank_4"></td>
        <td><input type="text" name="volume_Available_in_Stationary_Cascade" id="volume_Available_in_Stationary_Cascade"></td>
        <td><input type="text" name="HP_Vap_MFM_1" id="HP_Vap_MFM_1"></td>
        <td><input type="text" name="HP_Vap_MFM_2" id="HP_Vap_MFM_2"></td>
        <td><input type="text" name="LCV_Fill_Post-1_MFM" id="LCV_Fill_Post-1_MFM"></td>
        <td><input type="text" name="LCV_Fill_Post-2_MFM" id="LCV_Fill_Post-2_MFM"></td>
        <td><input type="text" name="LCV_Fill_Post-3_MFM" id="LCV_Fill_Post-3_MFM"></td>
        <td><input type="text" name="LCV_Fill_Post-4_MFM" id="LCV_Fill_Post-4_MFM"></td>
        <td><input type="text" name="PRS_Skid-1_RPD_Meter_in_SCM_2000_SCMH" id="PRS_Skid-1_RPD_Meter_in_SCM_2000_SCMH"></td>
        <td><input type="text" name="PRS_Skid-2_RPD_Meter_in_SCM_5000_SCMH" id="PRS_Skid-2_RPD_Meter_in_SCM_5000_SCMH"></td>
        <td><input type="text" name="MP_Metering_Skid_USM_Meter_in_SCM_10000_SCMH" id="MP_Metering_Skid_USM_Meter_in_SCM_10000_SCMH"></td>
        <td><input type="text" name="total_Dispenser_Sales" id="total_Dispenser_Sales"></td>
        <td><input type="text" name="total_MCV_Sales" id="total_MCV_Sales"></td>
        <td><input type="text" name="total_CNG_Sales" id="total_CNG_Sales"></td>
        <td><input type="text" name="CNG_Sales_at_DBS" id="CNG_Sales_at_DBS" readonly></td>
        <td><input type="text" name="PE_Commissioned_in_Mtr" id="PE_Commissioned_in_Mtr"></td>
        <td><input type="text" name="PE_Laying_in_Mtr" id="PE_Laying_in_Mtr"></td>
        <td><input type="text" name="steel_Commissioned" id="steel_Commissioned"></td>
        <td><input type="text" name="steel_Stringing" id="steel_Stringing"></td>
        <td><input type="text" name="steel_Commissioned_in_Mtr" id="steel_Commissioned_in_Mtr"></td>
        <td><input type="text" name="steel_Stringing_in_Mtr" id="steel_Stringing_in_Mtr"></td>
        <td><input type="text" name="domestic_Connections_registration" id="domestic_Connections_registration"></td>
        <td><input type="text" name="domestic_Connections_advanced_plumbing" id="domestic_Connections_advanced_plumbing"></td>
        <td><input type="text" name="domestic_Connections_Commissioned" id="domestic_Connections_Commissioned"></td>
        <td><input type="text" name="commercial_NDEC_Connections_Registration" id="commercial_NDEC_Connections_Registration"></td>
        <td><input type="text" name="commercial_NDEC_Connections_Commissioned" id="commercial_NDEC_Connections_Commissioned"></td>
        <td><input type="text" name="industrial_Connections_Registration" id="industrial_Connections_Registration"></td>
        <td><input type="text" name="industrial_Connections_Commissioned" id="industrial_Connections_Commissioned"></td>
        <td><input type="text" name="OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr" id="OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr"></td>
        <td><input type="text" name="OFC_Duct_Laying_with_MDPE_in_Mtr" id="OFC_Duct_Laying_with_MDPE_in_Mtr"></td>
        <td><input type="text" name="CNG_Vehicles_OEM" id="CNG_Vehicles_OEM"></td>
        <td><input type="text" name="CNG_Vehicles_Conversion" id="CNG_Vehicles_Conversion"></td>
        <td><input type="text" name="OMC_Final_PESO_Applied" id="OMC_Final_PESO_Applied"></td>
        <td><input type="text" name="OMC_No_of_CNG_Stations_Commissioned" id="OMC_No_of_CNG_Stations_Commissioned"></td>
        <td><input type="text" name="COCO_CODO_DODO_Final_PESO_Applied" id="COCO_CODO_DODO_Final_PESO_Applied"></td>
        <td><input type="text" name="COCO_CODO_DODO_No_of_CNG_Stations_Commissioned" id="COCO_CODO_DODO_No_of_CNG_Stations_Commissioned"></td>
        <td><input type="text" name="MDPE_Laid_20_mm" id="MDPE_Laid_20_mm"></td>
        <td><input type="text" name="MDPE_Commissioned_20_mm" id="MDPE_Commissioned_20_mm"></td>
         <td><button type="submit" class="btn btn-primary text-white" id="submit" value="Submit">Submit</button></td>
        </tr>';
        if(!empty($data))
        {
            foreach($data as $val)
            {
               $input_date=date("d/m/Y",strtotime($val['input_date']));
                //$input_date=$val['input_date'];
                $edit="";
                if($input_date==date('d/m/Y'))$edit='<a href="'.route("districtInputSheet",["id"=>$val["id"]]).'"><button type="button" class="btn btn-info text-white" id="submit" value="Edit">Edit</button></a>';
                $tr.="<tr>";  
                //$tr.="<td>".$val['input_month']."</td>";
                $tr.="<td>".$input_date."</td>";
                $tr.="<td>".$val['quantity_of_LNG_invoiced_at_the_LNG_terminal']."</td>";
                $tr.="<td>".$val['quantity_of_LNG_unloaded_at_the_LNG_terminal_as_per_MFM']."</td>";
                $tr.="<td>".$val['quantity_of_LNG_unloaded_at_the_LCNG_station_as_per_weighment']."</td>";
                $tr.="<td>".$val['tank_1']."</td>";
                $tr.="<td>".$val['tank_2']."</td>";
                $tr.="<td>".$val['tank_3']."</td>";
                $tr.="<td>".$val['tank_4']."</td>";
                $tr.="<td>".$val['volume_Available_in_Stationary_Cascade']."</td>";
                $tr.="<td>".$val['HP_Vap_MFM_1']."</td>";
                $tr.="<td>".$val['HP_Vap_MFM_2']."</td>";
                $tr.="<td>".$val['LCV_Fill_Post-1_MFM']."</td>";
                $tr.="<td>".$val['LCV_Fill_Post-2_MFM']."</td>";
                $tr.="<td>".$val['LCV_Fill_Post-3_MFM']."</td>";
                $tr.="<td>".$val['LCV_Fill_Post-4_MFM']."</td>";
                $tr.="<td>".$val['PRS_Skid-1_RPD_Meter_in_SCM_2000_SCMH']."</td>";
                $tr.="<td>".$val['PRS_Skid-2_RPD_Meter_in_SCM_5000_SCMH']."</td>";
                $tr.="<td>".$val['MP_Metering_Skid_USM_Meter_in_SCM_10000_SCMH']."</td>";
                $tr.="<td>".$val['total_Dispenser_Sales']."</td>";
                $tr.="<td>".$val['total_MCV_Sales']."</td>";
                $tr.="<td>".$val['total_CNG_Sales']."</td>";
                $tr.="<td>".$val['CNG_Sales_at_DBS']."</td>";
                $tr.="<td>".$val['PE_Commissioned_in_Mtr']."</td>";
                $tr.="<td>".$val['PE_Laying_in_Mtr']."</td>";
                $tr.="<td>".$val['steel_Commissioned']."</td>";
                $tr.="<td>".$val['steel_Stringing']."</td>";
                $tr.="<td>".$val['steel_Commissioned_in_Mtr']."</td>";
                $tr.="<td>".$val['steel_Stringing_in_Mtr']."</td>";
                $tr.="<td>".$val['domestic_Connections_registration']."</td>";
                $tr.="<td>".$val['domestic_Connections_advanced_plumbing']."</td>";
                $tr.="<td>".$val['domestic_Connections_Commissioned']."</td>";
                $tr.="<td>".$val['commercial_NDEC_Connections_Registration']."</td>";
                $tr.="<td>".$val['commercial_NDEC_Connections_Commissioned']."</td>";
                $tr.="<td>".$val['industrial_Connections_Registration']."</td>";
                $tr.="<td>".$val['industrial_Connections_Commissioned']."</td>";
                $tr.="<td>".$val['OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr']."</td>";
                $tr.="<td>".$val['OFC_Duct_Laying_with_MDPE_in_Mtr']."</td>";
                $tr.="<td>".$val['CNG_Vehicles_OEM']."</td>";
                $tr.="<td>".$val['CNG_Vehicles_Conversion']."</td>";
                $tr.="<td>".$val['OMC_Final_PESO_Applied']."</td>";
                $tr.="<td>".$val['OMC_No_of_CNG_Stations_Commissioned']."</td>";
                $tr.="<td>".$val['COCO_CODO_DODO_Final_PESO_Applied']."</td>";
                $tr.="<td>".$val['COCO_CODO_DODO_No_of_CNG_Stations_Commissioned']."</td>";
                $tr.="<td>".$val['MDPE_Laid_20_mm']."</td>";
                $tr.="<td>".$val['MDPE_Commissioned_20_mm']."</td>";
                $tr.="<td>".$edit."</td>";
                $tr.="</tr>";
            }
        }
       // <td><input type="text" name="input_month"></td>
        
        echo json_encode($tr);
    }
    public function getInputsGA(Request $request)
    {
        $cumulative_corrected1=$cumulative_uncorrected1=0;
        $alldata=$request->all();
        $data=DprInputsGA::where("ga_code",$alldata['ga_code'])->orderBy("input_date","desc")->get()->toArray();
        $tr="";
        if(!empty($data))
        {
            foreach($data as $val)
            {
                $input_date=date("d/m/Y",strtotime($val['input_date']));
                //$input_date=($val['input_date']);
                $tr.="<tr>";  
               // $tr.="<td>".$val['input_month']."</td>";
                $tr.="<td>".$input_date."</td>";
                $tr.="<td>".$val['quantity_of_LNG_invoiced_at_the_LNG_terminal']."</td>";
                $tr.="<td>".$val['quantity_of_LNG_unloaded_at_the_LNG_terminal_as_per_MFM']."</td>";
                $tr.="<td>".$val['quantity_of_LNG_unloaded_at_the_LCNG_station_as_per_weighment']."</td>";
                $tr.="<td>".$val['tank_1']."</td>";
                $tr.="<td>".$val['tank_2']."</td>";
                $tr.="<td>".$val['tank_3']."</td>";
                $tr.="<td>".$val['tank_4']."</td>";
                $tr.="<td>".$val['volume_Available_in_Stationary_Cascade']."</td>";
                $tr.="<td>".$val['HP_Vap_MFM_1']."</td>";
                $tr.="<td>".$val['HP_Vap_MFM_2']."</td>";
                $tr.="<td>".$val['LCV_Fill_Post-1_MFM']."</td>";
                $tr.="<td>".$val['LCV_Fill_Post-2_MFM']."</td>";
                $tr.="<td>".$val['LCV_Fill_Post-3_MFM']."</td>";
                $tr.="<td>".$val['LCV_Fill_Post-4_MFM']."</td>";
                $tr.="<td>".$val['PRS_Skid-1_RPD_Meter_in_SCM_2000_SCMH']."</td>";
                $tr.="<td>".$val['PRS_Skid-2_RPD_Meter_in_SCM_5000_SCMH']."</td>";
                $tr.="<td>".$val['MP_Metering_Skid_USM_Meter_in_SCM_10000_SCMH']."</td>";
                $tr.="<td>".$val['total_Dispenser_Sales']."</td>";
                $tr.="<td>".$val['total_MCV_Sales']."</td>";
                $tr.="<td>".$val['total_CNG_Sales']."</td>";
                $tr.="<td>".$val['CNG_Sales_at_DBS']."</td>";
                $tr.="<td>".$val['PE_Commissioned_in_Mtr']."</td>";
                $tr.="<td>".$val['PE_Laying_in_Mtr']."</td>";
                $tr.="<td>".$val['steel_Commissioned']."</td>";
                $tr.="<td>".$val['steel_Stringing']."</td>";
                $tr.="<td>".$val['steel_Commissioned_in_Mtr']."</td>";
                $tr.="<td>".$val['steel_Stringing_in_Mtr']."</td>";
                $tr.="<td>".$val['domestic_Connections_registration']."</td>";
                $tr.="<td>".$val['domestic_Connections_advanced_plumbing']."</td>";
                $tr.="<td>".$val['domestic_Connections_Commissioned']."</td>";
                $tr.="<td>".$val['commercial_NDEC_Connections_Registration']."</td>";
                $tr.="<td>".$val['commercial_NDEC_Connections_Commissioned']."</td>";
                $tr.="<td>".$val['industrial_Connections_Registration']."</td>";
                $tr.="<td>".$val['industrial_Connections_Commissioned']."</td>";
                $tr.="<td>".$val['OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr']."</td>";
                $tr.="<td>".$val['OFC_Duct_Laying_with_MDPE_in_Mtr']."</td>";
                $tr.="<td>".$val['CNG_Vehicles_OEM']."</td>";
                $tr.="<td>".$val['CNG_Vehicles_Conversion']."</td>";
                $tr.="<td>".$val['OMC_Final_PESO_Applied']."</td>";
                $tr.="<td>".$val['OMC_No_of_CNG_Stations_Commissioned']."</td>";
                $tr.="<td>".$val['COCO_CODO_DODO_Final_PESO_Applied']."</td>";
                $tr.="<td>".$val['COCO_CODO_DODO_No_of_CNG_Stations_Commissioned']."</td>";
                $tr.="<td>".$val['MDPE_Laid_20_mm']."</td>";
                $tr.="<td>".$val['MDPE_Commissioned_20_mm']."</td>";
                //$tr.="<td></td>";
                $tr.="</tr>";
            }
        }
        /*$tr.='<tr>
        <td><input type="text" name="input_month"></td>
        <td><input type="date" name="input_date"></td>
        <td><input type="text" name="quantity_of_LNG_invoiced_at_the_LNG_terminal" id="quantity_of_LNG_invoiced_at_the_LNG_terminal"></td>
        <td><input type="text" name="quantity_of_LNG_unloaded_at_the_LNG_terminal_as_per_MFM" id="quantity_of_LNG_unloaded_at_the_LNG_terminal_as_per_MFM"></td>
        <td><input type="text" name="quantity_of_LNG_unloaded_at_the_LCNG_station_as_per_weighment" id="quantity_of_LNG_unloaded_at_the_LCNG_station_as_per_weighment"></td>
        <td><input type="text" name="tank_1" id="tank_1"></td>
        <td><input type="text" name="tank_2" id="tank_2"></td>
        <td><input type="text" name="tank_3" id="tank_3"></td>
        <td><input type="text" name="tank_4" id="tank_4"></td>
        <td><input type="text" name="volume_Available_in_Stationary_Cascade" id="volume_Available_in_Stationary_Cascade"></td>
        <td><input type="text" name="HP_Vap_MFM_1" id="HP_Vap_MFM_1"></td>
        <td><input type="text" name="HP_Vap_MFM_2" id="HP_Vap_MFM_2"></td>
        <td><input type="text" name="LCV_Fill_Post-1_MFM" id="LCV_Fill_Post-1_MFM"></td>
        <td><input type="text" name="LCV_Fill_Post-2_MFM" id="LCV_Fill_Post-2_MFM"></td>
        <td><input type="text" name="LCV_Fill_Post-3_MFM" id="LCV_Fill_Post-3_MFM"></td>
        <td><input type="text" name="LCV_Fill_Post-4_MFM" id="LCV_Fill_Post-4_MFM"></td>
        <td><input type="text" name="PRS_Skid-1_RPD_Meter_in_SCM_2000_SCMH" id="PRS_Skid-1_RPD_Meter_in_SCM_2000_SCMH"></td>
        <td><input type="text" name="PRS_Skid-2_RPD_Meter_in_SCM_5000_SCMH" id="PRS_Skid-2_RPD_Meter_in_SCM_5000_SCMH"></td>
        <td><input type="text" name="MP_Metering_Skid_USM_Meter_in_SCM_10000_SCMH" id="MP_Metering_Skid_USM_Meter_in_SCM_10000_SCMH"></td>
        <td><input type="text" name="total_Dispenser_Sales" id="total_Dispenser_Sales"></td>
        <td><input type="text" name="total_MCV_Sales" id="total_MCV_Sales"></td>
        <td><input type="text" name="total_CNG_Sales" id="total_CNG_Sales"></td>
        <td><input type="text" name="CNG_Sales_at_DBS" id="CNG_Sales_at_DBS" readonly></td>
        <td><input type="text" name="PE_Commissioned_in_Mtr" id="PE_Commissioned_in_Mtr"></td>
        <td><input type="text" name="PE_Laying_in_Mtr" id="PE_Laying_in_Mtr"></td>
        <td><input type="text" name="steel_Commissioned" id="steel_Commissioned"></td>
        <td><input type="text" name="steel_Stringing" id="steel_Stringing" readonly></td>
        <td><input type="text" name="steel_Commissioned_in_Mtr" id="steel_Commissioned_in_Mtr"></td>
        <td><input type="text" name="steel_Stringing_in_Mtr" id="steel_Stringing_in_Mtr"></td>
        <td><input type="text" name="domestic_Connections_registration" id="domestic_Connections_registration"></td>
        <td><input type="text" name="domestic_Connections_advanced_plumbing" id="domestic_Connections_advanced_plumbing"></td>
        <td><input type="text" name="domestic_Connections_Commissioned" id="domestic_Connections_Commissioned"></td>
        <td><input type="text" name="commercial_NDEC_Connections_Registration" id="commercial_NDEC_Connections_Registration"></td>
        <td><input type="text" name="commercial_NDEC_Connections_Commissioned" id="commercial_NDEC_Connections_Commissioned"></td>
        <td><input type="text" name="industrial_Connections_Registration" id="industrial_Connections_Registration"></td>
        <td><input type="text" name="industrial_Connections_Commissioned" id="industrial_Connections_Commissioned"></td>
        <td><input type="text" name="OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr" id="OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr"></td>
        <td><input type="text" name="OFC_Duct_Laying_with_MDPE_in_Mtr" id="OFC_Duct_Laying_with_MDPE_in_Mtr"></td>
        <td><input type="text" name="CNG_Vehicles_OEM" id="CNG_Vehicles_OEM"></td>
        <td><input type="text" name="CNG_Vehicles_Conversion" id="CNG_Vehicles_Conversion"></td>
        <td><input type="text" name="OMC_Final_PESO_Applied" id="OMC_Final_PESO_Applied"></td>
        <td><input type="text" name="OMC_No_of_CNG_Stations_Commissioned" id="OMC_No_of_CNG_Stations_Commissioned"></td>
        <td><input type="text" name="COCO_CODO_DODO_Final_PESO_Applied" id="COCO_CODO_DODO_Final_PESO_Applied"></td>
        <td><input type="text" name="COCO_CODO_DODO_No_of_CNG_Stations_Commissioned" id="COCO_CODO_DODO_No_of_CNG_Stations_Commissioned"></td>
        <td><input type="text" name="MDPE_Laid_20_mm" id="MDPE_Laid_20_mm"></td>
        <td><input type="text" name="MDPE_Commissioned_20_mm" id="MDPE_Commissioned_20_mm"></td>
         <td><button type="submit" class="btn btn-primary text-white" id="submit" value="Submit">Submit</button></td>
        </tr>';*/
        echo json_encode($tr);
    }
    /*Storage Tanks*/
    public function storageTank(Request $request)
    {
        $user=auth()->user();
        $station=MasterStations::where("status",'Active')->pluck("station_name","station_code");
        if(Auth::check()){
            return view('dpr.storageTank1',['station'=>$station]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function getStorageTank(Request $request)
    {
        $arr=[];
        $myga=User::where("userId",$request->userId)->value("ga");
        if($myga=="All")
        $station=MasterStations::where("status",'Active')->orderBy("station_name","asc")->pluck("station_name","station_code");
        else
        $station=MasterStations::where("status",'Active')->where("ga_name",$myga)->pluck("station_name","station_code");
       $stations='<select name="station" id="station"  class="form-control form-select" data-placeholder="Choose a Station"><option>Please Select Station</option>';
        foreach($station as $k=>$v)
        {
        $stations.='<option value="'.$k.'">'.$v.'</option>';
        }
        $stations.='</select>';
        
         $source=dd_masters("source","source_code");
        $sources='<select name="supplier" id="supplier"  class="form-control form-select" data-placeholder="Choose a Supplier"><option>Please Select Supplier</option>';
        foreach($source as $k=>$v)
        {
        $sources.='<option value="'.$k.'">'.$v.' ('.$k.')</option>';
        }
        $sources.='</select>';
        
        
         $tankerno=dd_masters("tankerno","tankerno_code");
        $tankernos='<select name="tanker_no" id="tanker_no"  class="form-control form-select" ><option>Please Select Tanker No</option>';
        foreach($tankerno as $k=>$v)
        {
        $tankernos.='<option value="'.$k.'">'.$v.' ('.$k.')</option>';
        }
        $tankernos.='</select>';
        
        
        
        $storage_tank='<select name="storage_tank" id="storage_tank"  class="form-control form-select" data-placeholder="Choose a Storage Tank"><option>Please Select Storage Tank</option><option value="Storage Tank 1">Storage Tank 1</option><option value="Storage Tank 2">Storage Tank 2</option><option value="Storage Tank 3">Storage Tank 3</option><option value="Storage Tank 4">Storage Tank 4</option></select>';
        $col1=array('station','storage_tank',  'date_of_unloading', 'tanker_no', 'supplier', 'before_unloading_tank_volume', 'after_onloading_tank_volume', 'total_volumn_in_kl', 'conversion','', 'conversion_factor', 'calorific_value', 'total_volume_in_scm');
        $arr1=array("Station","Storage Tank","Date of Unloading","Tanker No.","Supplier","Before Unloading Tank Volume (KL)","After Unloading Tank Volume (KL)","Total Volume (KL)","Conversion (SCM / KL)","Conversion (Kcal-KL/SCM2)","Conversion Factor (Weightage Average)","Calorific Value (Weightage Average)","Total Volume in SCM");
            foreach($arr1 as $k1=>$v1)
            {
                if($k1==0) 
                $arr["storage"][$v1][]=$stations;
                elseif($k1==1)
                $arr["storage"][$v1][]=$storage_tank;
                elseif( $k1==3)
                 $arr["storage"][$v1][]= $tankernos;
               // $arr["storage"][$v1][]='<input type="text" name="'.$col1[$k1].'" id="'.$col1[$k1].'" class="input form-control" required>';
                elseif($k1==4)
                $arr["storage"][$v1][]= $sources;
                elseif($k1==2)
                $arr["storage"][$v1][]='<input type="date" name="'.$col1[$k1].'" id="'.$col1[$k1].'" class="input form-control" required>';
                elseif($k1==9)
                $arr["storage"][$v1][]='<input type="text" class="input form-control" id="after_conversion"></input>';
                else
                $arr["storage"][$v1][]='<input type="number" name="'.$col1[$k1].'" id="'.$col1[$k1].'" step="0.100" class="input form-control">';
            }
        $col2=array( 'nitrogen', 'Methane', 'Ethane', 'Propane', 'Iso_butane', 'N_butane', 'Iso_pentane', 'N_pentane', 'N_Hexane', 'total', 'mliq', 'GHV', 'Vm', 'Mmix', 'Zmix', 'Vvaps', 'GHV_kcal', 'Density', 'Conversion_factor_m',);
        $co2=array( 'nitrogen', 'Methane', 'Ethane', 'Propane', 'Iso-butane', 'N-butane', 'Iso-pentane', 'N-pentane', 'N-Hexane', 'total', 'mliq', 'GHV', 'Vm', 'Mmix', 'Zmix', 'Vvaps', 'GHV_kcal', 'Density', 'Conversion_factor');
        $arr2=array("Nitrogen","Methane","Ethane","Propane","Iso-butane","N-butane","Iso-pentane","N-pentane","N-Hexane","Σ","Unloading MFM (MT)","GHV (MMBTU / MT)","Vm (SCM/kmol)","Mmix","Zmix","Vvap,s (SCM)","GHV (kcal / scm)","Density (kg / scm)","Conversion Factor (scm / kg)");
            foreach($arr2 as $k2=>$v2)
            {
                $arr["componentM"][$v2][]='<input type="number" name="'.$col2[$k2].'"  id="'.$col2[$k2].'" step="0.100" class="input form-control">';
            }
        $col3=array( 'nitrogen_z', 'Methane_z', 'Ethane_z', 'Propane_z', 'Iso_butane_z', 'N_butane_z', 'Iso_pentane_z', 'N_pentane_z', 'N_Hexane_z', 'total_z');
        $co3=array( 'nitrogen', 'Methane', 'Ethane', 'Propane', 'Iso-butane', 'N-butane', 'Iso-pentane', 'N-pentane', 'N-Hexane', 'total');
        $arr3=array("Nitrogen","Methane","Ethane","Propane","Iso-butane","N-butane","Iso-pentane","N-pentane","N-Hexane","Σ");
            foreach($arr3 as $k3=>$v3)
            {
                $arr["componentZ"][$v3][]='<input type="number" name="'.$col3[$k3].'" id="'.$col3[$k3].'" step="0.100" class="input form-control">';
            }
            $columns=DprStorageTank1::get()->toArray();
        //print_r($columns);exit;
        if(!empty($columns))
        {
            foreach($columns as $k=>$val)
            {
               
                $val1=DprStorageTank1ComponentMi::where("storage_tank_id",$val['id'])->get()->toArray();
                $val2=DprStorageTank1ComponentZi::where("storage_tank_id",$val['id'])->get()->toArray();
                               // print_r($val1);exit;
                 foreach($arr1 as $k1=>$v1)
                {
                    if($v1=="Conversion (Kcal-KL/SCM2)")
                    {
                       // $v1="Conversion (Kcal-KL/SCM2)";
                         $ghv=$val1[0]['GHV'];
                      //echo $ghv;exit;
                      $arr["storage"][$v1][]=number_format($ghv/$val['conversion'], 3, '.', "");
                     
                    }
                    else
                    {
                        /* if($v1=="Date of Unloading" && $val[$col1[$k1]]==date("Y-m-d"))
                        {
                             $arr["storage"][$v1][]=$val[$col1[$k1]]."<a href='".route('storageTank',['id'=>$val['id']])."'><button type='button' class='btn btn-info text-white' id='edit' value='Edit'>Edit</button></a>";
                        }
                        else*/
                        //{
                            $arr["storage"][$v1][]=$val[$col1[$k1]];
                        //}
                    }
                     
                }
                foreach($arr2 as $k2=>$v2)
                {
                    
                    $arr["componentM"][$v2][]=$val1[0][$co2[$k2]];
                      
                    
                }
                  foreach($arr3 as $k3=>$v3)
                {
                    $arr["componentZ"][$v3][]=$val2[0][$co3[$k3]];
                }
                
            }
            
        }
           // print_r($arr);exit;
        return $arr;
    }
    public function storageTankPost(Request $request)
    {
        $alldata=$request->all();
        //print_r($alldata);exit;
        if(isset($alldata['device']))
        {
            $device=$alldata['device'];
        }
        else
        {
            $device="";
        }
        $validator=  Validator::make($alldata, [
            "total_z"=>"required",
            "total_volumn_in_kl"=>"required",
            "station"=>"required",
            "storage_tank"=>"required",
            "total_volume_in_scm"=>"required"
        ]
        );

        if($validator->fails()) {
            if($device=="web")
            {
                //return $validator->errors()->first();
               return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
            }
            else
            {
                $logs = array(
                        'module' => "DPR",
                        'user' => $alldata['user_id'],
                        'access_device' => $device,
                        'called_api' => route('storageTank'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => $validator->errors()->first(),
                        'method_name' => "POST",
        
                    );
                $log = manageLogs($logs);
                return response()->json(["status" => "failed", "code"=>config("constants.CODE_FAILURE"),"msg" => $validator->errors()->first()]);
            }
        }
        $data =array(
            "user_id"=>$request->user_id,
            "station"=>$request->station,
            "storage_tank"=>$request->storage_tank,
           // "lcng_station_name"=>$request->lcng_station_name,
            //"tanker_identification"=>$request->tanker_identification,
            "date_of_unloading"=>$request->date_of_unloading,
            "tanker_no"=>$request->tanker_no,
            "supplier"=>$request->supplier,
            "before_unloading_tank_volume"=>$request->before_unloading_tank_volume,
            "after_onloading_tank_volume"=>$request->after_onloading_tank_volume,
            "total_volumn_in_kl"=>$request->total_volumn_in_kl,
            "conversion"=>$request->conversion,
            "conversion_factor"=>$request->conversion_factor,
            "calorific_value"=>$request->calorific_value,
            "total_volume_in_scm"=>$request->total_volume_in_scm,
            "status"=>"Active",
            "created_at"=>date("Y-m-d H:i:s"),
            "updated_at"=>date("Y-m-d H:i:s")
        );
        
        $row_status=  DprStorageTank1::where("date_of_unloading", $request->date_of_unloading)->where("storage_tank", $request->storage_tank)->first();// check for the unique date
        if(!is_null($row_status)) {
            //return "Date value is already exists!";
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Date value is already exists!"]);
        }
        $create  = DprStorageTank1::insertGetId($data); // add new row in table
        if($create)
        {
            $data1=array(
                            "nitrogen"=>$request->nitrogen,
            "Methane"=>$request->Methane,
            "Ethane"=>$request->Ethane,
            "Propane"=>$request->Propane,
            "Iso-butane"=>$request->Iso_butane,
            "N-butane"=>$request->N_butane,
            "Iso-pentane"=>$request->Iso_pentane,
            "N-pentane"=>$request->N_pentane,
            "N-Hexane"=>$request->N_Hexane,
            "total"=>$request->total,
            "mliq"=>$request->mliq,
            "GHV"=>$request->GHV,
            "Vm"=>$request->Vm,
            "Mmix"=>$request->Mmix,
            "Zmix"=>$request->Zmix,
            "Vvaps"=>$request->Vvaps,
            "GHV_kcal"=>$request->GHV_kcal,
            "Density"=>$request->Density,
            "Conversion_factor"=>$request->Conversion_factor_m,
            "storage_tank_id"=>$create,
            "status"=>"Active",
            "created_at"=>date("Y-m-d H:i:s"),
            "updated_at"=>date("Y-m-d H:i:s")
            );
             $create1  = DprStorageTank1ComponentMi::insert($data1);
            $data2=array("nitrogen"=>$request->nitrogen_z,
            "Methane"=>$request->Methane_z,
            "Ethane"=>$request->Ethane_z,
            "Propane"=>$request->Propane_z,
            "Iso-butane"=>$request->Iso_butane_z,
            "N-butane"=>$request->N_butane_z,
            "Iso-pentane"=>$request->Iso_pentane_z,
            "N-pentane"=>$request->N_pentane_z,
            "N-Hexane"=>$request->N_Hexane_z,
            "total"=>$request->total_z,
            "storage_tank_id"=>$create,
            "status"=>"Active",
            "created_at"=>date("Y-m-d H:i:s"),
            "updated_at"=>date("Y-m-d H:i:s"));
             $create1  = DprStorageTank1ComponentZi::insert($data2);
            if($device=="web")
            {
               // return "Success";
                return back()->with(["status" => 200, "msg" => "Data inserted successfully.","code" => config("constants.CODE_SUCCESS")]);
            }
            else
            {
                $logs = array(
                        'module' => "DPR",
                        'user' => $alldata['user_id'],
                        'access_device' => $device,
                        'called_api' => route('dcuInput'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => "Success!",
                        'method_name' => "POST",
        
                    );
                $log = manageLogs($logs);
                return response()->json(["status" => 200, "msg" => "Data inserted successfully.","code" => config("constants.CODE_SUCCESS")]);
            } 
        }
        else
        {
            if($device=="web")
            {
                //echo "Failed! Please try again.";
                return back()->with(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
            }
            else
            {
                $logs = array(
                    'module' => "DPR",
                    'user' => $alldata['user_id'],
                    'access_device' => $device,
                    'called_api' => route('dcuInput'),
                    'called_to' => "web",
                    'request_data' => json_encode($alldata),
                    'response_data' => "Failed! Please try again.",
                    'method_name' => "POST",
    
                );
            $log = manageLogs($logs);
                return response()->json(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
            }
        }
    }
    
    /*Industry Input Sheet*/
    public function industryInputSheet()
    {
        $user=auth()->user();
        if(Auth::check()){
          $ga=dd_masters("ga","ga_code");
          $district=dd_masters("district","address_district");
            return view('dpr.industryInputSheet',['ga'=>$ga]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function getIndustryInputs(Request $request)
    {
        $cumulative_corrected1=$cumulative_uncorrected1=0;
        $alldata=$request->all();
        $data=DprIndustry::orderBy("input_date","desc")->get()->toArray();
        $tr="";
        if(!empty($data))
        {
            foreach($data as $val)
            {
                $input_date=date("d/m/Y",strtotime($val['input_date']));
               // $input_date=$val['input_date'];

                $tr.="<tr>";  
               
                $tr.="<td>".$input_date."</td>";
                $tr.="<td>".$val['industrial_volume']."</td>";
               // $tr.="<td>".$val['volume_bar_with_evc']."</td>";
               // $tr.="<td>".$val['volume_bar_without_evc']."</td>";
                $tr.="<td>".$val['pd_meter_volume_110']."</td>";
                $tr.="<td>".$val['Volume_Correction_Factor_110']."</td>";
                $tr.="<td>".$val['pd_meter_volume_250']."</td>";
                $tr.="<td>".$val['Volume_Correction_Factor_250']."</td>";
                $tr.="<td>".$val['pd_meter_volume_300']."</td>";
                $tr.="<td>".$val['Volume_Correction_Factor_300']."</td>";
                $tr.="<td>".$val['pd_meter_volume_400']."</td>";
                $tr.="<td>".$val['Volume_Correction_Factor_400']."</td>";
                $tr.="<td>".$val['total_sales']."</td>";
                $tr.="<td></td>";
                $tr.="</tr>";
            }
        }
        $tr.='<tr>
        <td><input type="date" name="input_date" required></td>
        <td><input type="number" name="industrial_volume" step="0.001"  id="industrial_volume"></td> ';
        $tr.='<input type="hidden" name="volume_bar_with_evc" step="0.001" id="volume_bar_with_evc"><input type="hidden" name="volume_bar_without_evc" step="0.001" id="volume_bar_without_evc">';
      // $tr.=' <td><input type="number" name="volume_bar_with_evc" step="0.001" id="volume_bar_with_evc"></td>
       // <td><input type="number" name="volume_bar_without_evc" step="0.001" id="volume_bar_without_evc"></td>';
        $tr.='<td><input type="number" name="pd_meter_volume_110" step="0.001" id="pd_meter_volume_110"></td>
        <td><input type="number" name="Volume_Correction_Factor_110" step="0.001" id="Volume_Correction_Factor_110"></td>
        <td><input type="number" name="pd_meter_volume_250" step="0.001" id="pd_meter_volume_250"></td>
        <td><input type="number" name="Volume_Correction_Factor_250" step="0.001"  id="Volume_Correction_Factor_250"></td>
        <td><input type="number" name="pd_meter_volume_300" step="0.001"  id="pd_meter_volume_300"></td>
        <td><input type="number" name="Volume_Correction_Factor_300" step="0.001"  id="Volume_Correction_Factor_300"></td>
        <td><input type="number" name="pd_meter_volume_400" step="0.001"  id="pd_meter_volume_400"></td>
        <td><input type="number" name="Volume_Correction_Factor_400" step="0.001"  id="Volume_Correction_Factor_400"></td>
        <td><input type="number" name="total_sales" step="0.001"  id="total_sales"></td>
         <td><button type="submit" class="button-info" id="submit" value="Submit">Submit</button></td>
        </tr>';
        echo json_encode($tr);
    }
    public function industryInputPost(Request $request)
    {
        $device="";
        $alldata=$request->all();
        $alldata['created_at']=date("Y-m-d H:i:s");
        $alldata['updated_at']=date("Y-m-d H:i:s");
        $alldata['status']="Active";
        unset($alldata['_token']);
        if(isset($alldata['device']))$device=$alldata['device'];
        unset($alldata['device']);
        $dcudate=date("Y-m-d",strtotime($request->input_date));
        foreach($alldata as $k=>$aa)
        {
            if($aa=="")
            $alldata[$k]=0;
        }
        $data =$alldata;
        $row_status=  DprIndustry::where("input_date", $dcudate)->first();// check for the unique date
        if(!is_null($row_status)) {
            //return "Failed";
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Date value is already exists!"]);
        }
        $create  = DprIndustry::insert($data); // add new row in table
        if($create)
        {
            if($device=="web")
            {
                //return "Success";
                return back()->with(["status" => 200, "msg" => "Data inserted successfully.","code" => config("constants.CODE_SUCCESS")]);
            }
            else
            {
                $logs = array(
                        'module' => "DPR",
                        'user' => $alldata['user_id'],
                        'access_device' => $device,
                        'called_api' => route('industryInputSheet'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => "Success!",
                        'method_name' => "POST",
        
                    );
                $log = manageLogs($logs);
                return response()->json(["status" => 200, "msg" => "Data inserted successfully.","code" => config("constants.CODE_SUCCESS")]);
            } 
        }
        else
        {
            if($device=="web")
            {
                //echo "Failed";
                return back()->with(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
            }
            else
            {
                $logs = array(
                    'module' => "DPR",
                    'user' => $alldata['user_id'],
                    'access_device' => $device,
                    'called_api' => route('industryInputSheet'),
                    'called_to' => "web",
                    'request_data' => json_encode($alldata),
                    'response_data' => "Failed! Please try again.",
                    'method_name' => "POST",
    
                );
            $log = manageLogs($logs);
                return response()->json(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
            }
        }
    }
    
    /*GCV Report*/
    public function gcvReportSheet(Request $request)
    {
        $user=auth()->user();
        if(Auth::check()){
          $ga=dd_masters("ga","ga_code");
            return view('dpr.gcvReportSheet',['ga'=>$ga]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function getGCV(Request $request)
    {
        $alldata=$request->all();
        /*$data=DprStorageTank1::selectRaw("
        SUM(toal_volume_in_scm) as gcv_total_volume_in_scm,
        SUM(calorific_value) as gcv_calorific_value,
        SUM(total_volume_in_scm/conversion_factor) as gcv_total_volume_in_kg,
        SUM(after_onloading_tank_volume) as gcv_total_volume_in_kl,
        SUM(total_volume_in_scm)/SUM(total_volume_in_scm/conversion_factor) as gcv_conversion_factor_scm_kg,
        SUM(after_onloading_tank_volume)*1000/SUM(total_volume_in_scm/conversion_factor) as gcv_conversion_factor_kl_mt,
        SUM(total_volume_in_scm)/SUM(after_onloading_tank_volume)) as gcv_conversion_factor_scm_kl,
        SUM(calorific_value)*252000/SUM(total_volume_in_scm) as gcv_conversion_factor_kkal_scm,
        ANY_VALUE(date_of_unloading) as gcv_date_of_unloading
        ")->groupBy("date_of_unloading")->get()->toArray();*/
        $data=DprGCVReport::all();
        $tr="";
         if(!empty($data))
        {
            foreach($data as $val)
            {
                $tr.="<tr>";
                $dcu_date=date("d/m/Y",strtotime($val['gcv_date_of_unloading']));
                
                $tr.="<td>".$dcu_date."</td>";
                $tr.="<td>".round($val['gcv_conversion_factor_scm_kg'],3)."</td>";
                $tr.="<td>".round($val['gcv_conversion_factor_kl_mt'],3)."</td>";
                $tr.="<td>".round($val['gcv_conversion_factor_scm_kl'],3)."</td>";
                $tr.="<td>".round($val['gcv_conversion_factor_kkal_scm'],3)."</td>";
                $tr.="<td>".round($val['gcv_total_volume_in_scm'],3)."</td>";
                $tr.="<td>".round($val['gcv_calorific_value'],3)."</td>";
                $tr.="<td>".round($val['gcv_total_volume_in_kg'],3)."</td>";
                $tr.="<td>".round($val['gcv_total_volume_in_kl'],3)."</td>";
                $tr.="</tr>";
            }
        }
        echo json_encode($tr);
    }
     public function getGCVStorage(Request $request)
    {
    
        $alldata=$request->all();
        
        $data=DprStorageTank1::where("storage_tank",$alldata['ga_code'])->orderBy("date_of_unloading","asc")->get()->toArray();
        $tr="";
         if(!empty($data))
        {
            foreach($data as $val)
            {
                $tr.="<tr>";
                $dcu_date=date("d/m/Y",strtotime($val['date_of_unloading']));
                
                $tr.="<td>".$dcu_date."</td>";
                $tr.="<td>".round($val['conversion_factor'],3)."</td>";
                $tr.="<td>".round(($val['after_onloading_tank_volume']*1000)/($val['total_volume_in_scm']/$val['conversion_factor']),2)."</td>";
                $tr.="<td>".round($val['total_volume_in_scm']/$val['after_onloading_tank_volume'],3)."</td>";
                $tr.="<td>".round($val['calorific_value'],3)."</td>";
                $tr.="<td>".round($val['total_volume_in_scm'],3)."</td>";
                $tr.="<td>".round(($val['total_volume_in_scm']*$val['calorific_value'])/252000,2)."</td>";
                $tr.="<td>".round($val['total_volume_in_scm']/$val['conversion_factor'],3)."</td>";
                $tr.="<td>".round($val['after_onloading_tank_volume'],3)."</td>";

                $tr.="</tr>";
            }
        }
       
        echo json_encode($tr);

    }
    
    /*CNG/CBG Purchase Input Sheet*/
    public function cngPurchaseInputSheet(Request $request)
    {
        $user=auth()->user();
        if(Auth::check()){
            $input_details=array();
            if($request->id)
            {
                 $input_details=  DprCngPurchaseInputSheet::where("id", $request->id)->first();// check for the unique date
            }
            return view('dpr.cngPurchaseInputSheet',['input_details'=>$input_details]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function getCngPurchaseInputs(Request $request)
    {
        $cumulative_corrected1=$cumulative_uncorrected1=0;
        $alldata=$request->all();
        $data=DprCngPurchaseInputSheet::orderBy("created_at","asc")->get()->toArray();
        $tr="";
        if(!empty($data))
        {
            foreach($data as $val)
            {
                $input_date=date("d/m/Y",strtotime($val['MCV_Loading_Date']));
                $edit="";
                if($input_date==date('d/m/Y'))$edit='<a href="'.route("cngPurchaseInputSheet",["id"=>$val["id"]]).'"><button type="button" class="btn btn-info text-white" id="submit" value="Edit">Edit</button></a>';
                $tr.="<tr>";  
               
                $tr.="<td>".$input_date."</td>";
                $tr.="<td>".$val['Source']."</td>";
                $tr.="<td>".$val['Invoice_qty_in_kg']."</td>";
                $tr.="<td>".$val['Dispatch_qty_in_M3_at_15deg_Temp_as_per_Joint_ticket']."</td>";
                $tr.="<td>".$val['CF']."</td>";
                 $tr.="<td>".$edit."</td>";
                $tr.="</tr>";
            }
        }
         $sources=dd_masters("source","source_code");
        $source='<select name="Source" id="Source"  class="cng " data-placeholder="Choose a Sources"><option>Please Select Source</option>';
        foreach($sources as $k=>$v)
        {
        $source.='<option value="'.$k.'">'.$v.' ('.$k.')</option>';
        }
        $source.='</select>';
        $tr.='<tr>
        <td><input type="date" class="cng" name="MCV_Loading_Date"></td>
        <td>';
        $tr.=$source;
        $tr.='</td>
        <td><input type="number" step="0.001" class="cng" name="Invoice_qty_in_kg" id="qty_c"></td>
        <td><input type="number" step="0.001" class="cng" name="Dispatch_qty_in_M3_at_15deg_Temp_as_per_Joint_ticket" id="qty_d"></td>
        <td><input type="number" step="0.001" class="cng" name="CF" id="CF"></td>
         <td><button type="submit" class="button-info" id="submit" value="Submit">Submit</button></td>
        </tr>';
        echo json_encode($tr);
    }
    public function cngPurchaseInputPost(Request $request)
    {
        $device="";
        $alldata=$request->all();
        $alldata['created_at']=date("Y-m-d H:i:s");
        $alldata['updated_at']=date("Y-m-d H:i:s");
       // $alldata['status']="Active";
        unset($alldata['_token']);
        if(isset($alldata['device']))$device=$alldata['device'];
        unset($alldata['device']);
        $dcudate=date("Y-m-d",strtotime($request->MCV_Loading_Date));
        foreach($alldata as $k=>$aa)
        {
            if($aa=="")
            $alldata[$k]=0;
        }
        $data =$alldata;
        $row_status=  DprCngPurchaseInputSheet::where("MCV_Loading_Date", $dcudate)->first();// check for the unique date
        if(!is_null($row_status)) {
            //return "Failed";
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Date value is already exists!"]);
        }
        $create  = DprCngPurchaseInputSheet::insert($data); // add new row in table
        if($create)
        {
            if($device=="web")
            {
               // return "Success";
                return back()->with(["status" => 200, "msg" => "Data inserted successfully.","code" => config("constants.CODE_SUCCESS")]);
            }
            else
            {
                $logs = array(
                        'module' => "DPR",
                        'user' => $alldata['user_id'],
                        'access_device' => $device,
                        'called_api' => route('cngPurchaseInputPost'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => "Success!",
                        'method_name' => "POST",
        
                    );
                $log = manageLogs($logs);
                return response()->json(["status" => 200, "msg" => "Data inserted successfully.","code" => config("constants.CODE_SUCCESS")]);
            } 
        }
        else
        {
            if($device=="web")
            {
                echo "Failed";
                //return back()->with(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
            }
            else
            {
                $logs = array(
                    'module' => "DPR",
                    'user' => $alldata['user_id'],
                    'access_device' => $device,
                    'called_api' => route('cngPurchaseInputPost'),
                    'called_to' => "web",
                    'request_data' => json_encode($alldata),
                    'response_data' => "Failed! Please try again.",
                    'method_name' => "POST",
    
                );
            $log = manageLogs($logs);
                return response()->json(["status" => config("constants.OK"),"code"=>config("constants.CODE_FAILURE"),  'msg' => 'Failed! Please try again.']);
            }
        }
    }
    /*District Wise CNG Report*/
    /*CNG/CBG Purchase Input Sheet*/
    public function districtCNGReport()
    {
        $user=auth()->user();
        if(Auth::check()){
            $ga=dd_masters("ga","ga_code");
          $district=dd_masters("district","address_district");
             return view('dpr.districtCNGReport',['ga'=>$ga,'district'=>$district]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function getDistrictCNGReport(Request $request)
    {
        $cumulative_corrected1=$cumulative_uncorrected1=0;
        $alldata=$request->all();
        $alldata=$request->all();
       /* $data=DB::table('dpr_ga_district_input')
            ->join('dpr_gcv_ga_report', 'dpr_gcv_ga_report.gcv_date_of_unloading', '=', 'dpr_ga_district_input.input_date')
           ->selectRaw('dpr_ga_district_iput.CNG_Sales_at_DBS as gas_sales_to_daughter, 
                    dpr_ga_district_input.total_Dispenser_Sales as total_sales_from_dispenser, 
                    dpr_ga_district_input.CNG_Sales_at_DBS+dpr_ga_district_input.total_Dispenser_Sales as cng_gas_slaes_in_kg ,
                    (dpr_ga_district_input.CNG_Sales_at_DBS+dpr_ga_district_input.total_Dispenser_Sales)*dpr_gcv_ga_report.gcv_conversion_factor_scm_kg as cng_sales_in_scm , 
                    dpr_gcv_ga_report.gcv_date_of_unloading as date')
            ->get()->toArray();
       print_r($data);exit;*/
        $data=DprDistrictCNGReport::all();
        $tr="";
         if(!empty($data))
        {
            foreach($data as $val)
            {
                $tr.="<tr>";
                $dcu_date=date("d/m/Y",strtotime($val['date']));
                
                $tr.="<td>".$dcu_date."</td>";
                $tr.="<td>".round($val['gas_sales_to_daughter'],3)."</td>";
                $tr.="<td>".round($val['total_sales_from_dispenser'],3)."</td>";
                $tr.="<td>".round($val['cng_gas_slaes_in_kg'],3)."</td>";
                $tr.="<td>".round($val['cng_sales_in_scm'],3)."</td>";
                $tr.="</tr>";
            }
        }
        echo json_encode($tr);
    }
/* Dist CGD RECO Report */
    public function distCgdRecoReport()
    {
        $user=auth()->user();
        if(Auth::check()){
            $ga=dd_masters("ga","ga_code");
          $district=dd_masters("district","address_district");
             return view('dpr.distCgdRecoReport',['ga'=>$ga,'district'=>$district]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function getDistCgdRecoReport(Request $request)
    {
        $cumulative_corrected1=$cumulative_uncorrected1=0;
        $alldata=$request->all();        
        $data=DprDistrictCGDRecoReport::where("district",$alldata['district'])->orderBy("input_date","desc")->get()->toArray();
        $tr="";
         if(!empty($data))
        {
            foreach($data as $val)
            {
                $tr.="<tr>";
                $dcu_date=date("d/m/Y",strtotime($val['input_date']));
               // $dcu_date=$val['input_date'];
                $dcu_month=date("F",strtotime($val['input_date']));
               // $tr.="<td>".$dcu_month."</td>";
               if($val['Cummulative_Opening_Reading_MFM_HP_Vap_Out_in_KG']==0)
               {
                   $val['Cummulative_Opening_Reading_MFM_HP_Vap_Out_in_KG']=19625327.0;
               }
                $tr.="<td>".$dcu_date."</td>";
                $tr.="<td>".round($val['Cummulative_Opening_Reading_MFM_HP_Vap_Out_in_KG'],3)."</td>";
                $tr.="<td>".round($val['Cummulative_Closing_Reading_MFM_HP_Vap_Out_in_KG'],3)."</td>";
                $tr.="<td>".round($val['Total_Purchase_Difference_in_SCM_CNG'],3)."</td>";
                $tr.="<td>".round($val['Cummulative_Corrected_EVC_Opening_Reading_RPD_in_SCM'],3)."</td>";
                $tr.="<td>".round($val['Cummulative_Corrected_EVC_Closing_Reading_RPD_in_SCM'],3)."</td>";
                $tr.="<td>".round($val['Total_Purchase_Difference_in_SCM_PNG'],3)."</td>";
                $tr.="<td>".round($val['Cummulative_Corrected_USM_Opening_Reading_in_SCM'],3)."</td>";
                $tr.="<td>".round($val['Cummulative_Corrected_USM_Closing_Reading_in_SCM'],3)."</td>";
                $tr.="<td>".round($val['Total_Purchase_Difference_in_SCM_MP_Line'],3)."</td>";
                $tr.="<td>".round($val['Gross_Purchase_PNG_CNG'],3)."</td>";
                $tr.="<td>".round($val['industrial'],3)."</td>";
                $tr.="<td>".round($val['int_pd_cf_vol'],3)."</td>";
                $tr.="<td>".round($val['cng'],3)."</td>";
                $tr.="<td>".round($val['commercial'],3)."</td>";
                $tr.="<td>".round($val['com_pd_cf_vol'],3)."</td>";
                $tr.="<td>".round($val['domestic'],3)."</td>";
                $tr.="<td>".round($val['dom_pd_cf_vol'],3)."</td>";
                //$tr.="<td>".round($val['Un_Accounted_Gas_Volumes_SCM'],3)."</td>";
                $tr.="<td>".round($val['Total_Sales_in_SCM'],3)."</td>";
                /*$tr.="<td>".round($val['diff_in_scm'],3)."</td>";
                $tr.="<td>".round($val['percentage_loss_day'],3)."</td>";
                $tr.="<td>".round($val['Cumulative_monthly_Diff_in_SCM'],3)."</td>";
                $tr.="<td>".round($val['Cum_Monthly_Purchase_in_SCM'],3)."</td>";
                $tr.="<td>".round($val['percentage_loss_month'],3)."</td>";
                $tr.="<td>".round($val['Cumulative_yearly_Diff_in_SCM'],3)."</td>";
                $tr.="<td>".round($val['Cum_Yearly_Purchase_in_SCM'],3)."</td>";
                $tr.="<td>".round($val['percentage_loss_year'],3)."</td>";*/
               $tr.="</tr>";
            }
        }
        echo json_encode($tr);
    }
    /* Daily MIS Report */
    public function dailyMisReport()
    {
        $user=auth()->user();
        if(Auth::check()){
            $ga=dd_masters("ga","ga_code");
            return view('dpr.dailyMisReport',['ga'=>$ga]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
                
        }
    }
    public function getDailyMisReport(Request $request)
    {
        $cumulative_corrected1=$cumulative_uncorrected1=0;
        $alldata=$request->all();        
        $data=DPRDailyMisReport::where("district",$alldata['district'])->orderBy("input_date","desc")->get()->toArray();
        $tr="";
        if(!empty($data))
        {
            foreach($data as $val)
            {
                $tr.="<tr>";
                $dcu_date=date("d/m/Y",strtotime($val['input_date']));
                $tr.="<td>".$dcu_date."</td>";
                $tr.="<td>".round($val['SCM_Purchase'],3)."</td>";
                $tr.="<td>".round($val['SCM_PNG_Sales'],3)."</td>";
                $tr.="<td>".round($val['CNG_Sales_to_DBS'],3)."</td>";
                $tr.="<td>".round($val['Dispenser_Sales_MS'],3)."</td>";
                $tr.="<td>".round($val['CNG_Sales_MP_line'],3)."</td>";
                $tr.="<td>".round($val['Total_Sales_PNG_CNG'],3)."</td>";
                $tr.="<td>".round($val['MTD_Purchase'],3)."</td>";
                $tr.="<td>".round($val['MTD_Sales'],3)."</td>";
                $tr.="<td>".round($val['YTD_Purchase'],3)."</td>";
                $tr.="<td>".round($val['YTD_Sales'],3)."</td>";
                $tr.="</tr>";
            }
        }
        echo json_encode($tr);
    }/* GA AND DISTRICT WISE DASHBOARD */
    public function districtDashboard(Request $request)
    {
        $user=auth()->user();
        if(Auth::check()){
            $ga=dd_masters("ga","ga_code");
            return view('dpr.districtDashboard',['ga'=>$ga]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');    
        } 
    }
    public function dashboardCalculations(Request $request)
    {
        $alldata=$request->all();
        if($alldata['district'])
        {
            $query=DprInputs::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district']);
            $query1=DprInputs::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district']);
            $query2=DprInputs::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district']);
            $query3=DprInputs::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district']);
            $query4=DprInputs::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district']);
            $query5=DprGaSalesReport::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district']);
            $query6=DprGaSalesReport::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district']);
            $query7=DprGaSalesReport::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district']);
            $query8=DprGaSalesReport::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district']);
            $query9=DprGaSalesReport::where("ga_code",$alldata['ga_code'])->where("district",$alldata['district']);
            
            $gaonly=0;
        }
        else{
            $query=DprInputs::where("ga_code",$alldata['ga_code']);
            $query1=DprInputs::where("ga_code",$alldata['ga_code']);
            $query2=DprInputs::where("ga_code",$alldata['ga_code']);
            $query3=DprInputs::where("ga_code",$alldata['ga_code']);
            $query4=DprInputs::where("ga_code",$alldata['ga_code']);
            $query5=DprGaSalesReport::where("ga_code",$alldata['ga_code']);
            $query6=DprGaSalesReport::where("ga_code",$alldata['ga_code']);
            $query7=DprGaSalesReport::where("ga_code",$alldata['ga_code']);
            $query8=DprGaSalesReport::where("ga_code",$alldata['ga_code']);
            $query9=DprGaSalesReport::where("ga_code",$alldata['ga_code']);
            
            $gaonly=1;
        }

        $distinput=$query->where("input_date",$alldata['input_date'])->get()->toArray();
        $mon=date("Y-m",strtotime($alldata['input_date']));
        $year=date("Y",strtotime($alldata['input_date']));
        $pyear=$year-1;
        $distinputMonth=$query1->where("input_date","LIKE","$mon%")->selectRaw("SUM(domestic_Connections_registration) AS domestic_Connections_registration_m,
        SUM(domestic_Connections_advanced_plumbing) AS domestic_Connections_advanced_plumbing_m,
        SUM(domestic_Connections_Commissioned) AS domestic_Connections_Commissioned_m,
        SUM(commercial_NDEC_Connections_Registration) AS commercial_NDEC_Connections_Registration_m,
        SUM(commercial_NDEC_Connections_Commissioned) AS commercial_NDEC_Connections_Commissioned_m,
        SUM(industrial_Connections_Registration) AS industrial_Connections_Registration_m,
        SUM(industrial_Connections_Commissioned) AS industrial_Connections_Commissioned_m,
        SUM(OMC_Final_PESO_Applied) AS OMC_Final_PESO_Applied_m,
        SUM(OMC_No_of_CNG_Stations_Commissioned) AS OMC_No_of_CNG_Stations_Commissioned_m,
        SUM(COCO_CODO_DODO_Final_PESO_Applied) AS COCO_CODO_DODO_Final_PESO_Applied_m,
        SUM(COCO_CODO_DODO_No_of_CNG_Stations_Commissioned) AS COCO_CODO_DODO_No_of_CNG_Stations_Commissioned_m,
        SUM(CNG_Vehicles_OEM) AS CNG_Vehicles_OEM_m,
        SUM(CNG_Vehicles_Conversion) AS CNG_Vehicles_Conversion_m,
        SUM(PE_Laying_in_Mtr) AS PE_Laying_in_Mtr_m,
        SUM(PE_Commissioned_in_Mtr) AS PE_Commissioned_in_Mtr_m,
        SUM(MDPE_Laid_20_mm) AS MDPE_Laid_20_mm_m,
        SUM(MDPE_Commissioned_20_mm) AS MDPE_Commissioned_20_mm_m,
        SUM(steel_Stringing_in_Mtr) AS steel_Stringing_in_Mtr_m,
        SUM(steel_Commissioned_in_Mtr) AS steel_Commissioned_in_Mtr_m,
        SUM(steel_Commissioned) AS steel_Commissioned_m,
        SUM(steel_Stringing) AS steel_Stringing_m,
        SUM(OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr) AS OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_m,
        SUM(OFC_Duct_Laying_with_MDPE_in_Mtr) AS OFC_Duct_Laying_with_MDPE_in_Mtr_m")->get()->toArray();
        $distinputYear=$query2->where("input_date","LIKE","$year%")->selectRaw("SUM(domestic_Connections_registration) AS domestic_Connections_registration_y,
        SUM(domestic_Connections_advanced_plumbing) AS domestic_Connections_advanced_plumbing_y,
        SUM(domestic_Connections_Commissioned) AS domestic_Connections_Commissioned_y,
        SUM(commercial_NDEC_Connections_Registration) AS commercial_NDEC_Connections_Registration_y,
        SUM(commercial_NDEC_Connections_Commissioned) AS commercial_NDEC_Connections_Commissioned_y,
        SUM(industrial_Connections_Registration) AS industrial_Connections_Registration_y,
        SUM(industrial_Connections_Commissioned) AS industrial_Connections_Commissioned_y,
        SUM(OMC_Final_PESO_Applied) AS OMC_Final_PESO_Applied_y,
        SUM(OMC_No_of_CNG_Stations_Commissioned) AS OMC_No_of_CNG_Stations_Commissioned_y,
        SUM(COCO_CODO_DODO_Final_PESO_Applied) AS COCO_CODO_DODO_Final_PESO_Applied_y,
        SUM(COCO_CODO_DODO_No_of_CNG_Stations_Commissioned) AS COCO_CODO_DODO_No_of_CNG_Stations_Commissioned_y,
        SUM(CNG_Vehicles_OEM) AS CNG_Vehicles_OEM_y,
        SUM(CNG_Vehicles_Conversion) AS CNG_Vehicles_Conversion_y,
        SUM(PE_Laying_in_Mtr) AS PE_Laying_in_Mtr_y,
        SUM(PE_Commissioned_in_Mtr) AS PE_Commissioned_in_Mtr_y,
        SUM(MDPE_Laid_20_mm) AS MDPE_Laid_20_mm_y,
        SUM(MDPE_Commissioned_20_mm) AS MDPE_Commissioned_20_mm_y,
        SUM(steel_Stringing_in_Mtr) AS steel_Stringing_in_Mtr_y,
        SUM(steel_Commissioned_in_Mtr) AS steel_Commissioned_in_Mtr_y,
        SUM(steel_Commissioned) AS steel_Commissioned_y,
        SUM(steel_Stringing) AS steel_Stringing_y,
        SUM(OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr) AS OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_y,
        SUM(OFC_Duct_Laying_with_MDPE_in_Mtr) AS OFC_Duct_Laying_with_MDPE_in_Mtr_y")->get()->toArray();
        $distinputPYear=$query3->where("input_date","<=","$pyear-12-31")->selectRaw("SUM(domestic_Connections_registration) AS domestic_Connections_registration_p,
        SUM(domestic_Connections_advanced_plumbing) AS domestic_Connections_advanced_plumbing_p,
        SUM(domestic_Connections_Commissioned) AS domestic_Connections_Commissioned_p,
        SUM(commercial_NDEC_Connections_Registration) AS commercial_NDEC_Connections_Registration_p,
        SUM(commercial_NDEC_Connections_Commissioned) AS commercial_NDEC_Connections_Commissioned_p,
        SUM(industrial_Connections_Registration) AS industrial_Connections_Registration_p,
        SUM(industrial_Connections_Commissioned) AS industrial_Connections_Commissioned_p,
        SUM(OMC_Final_PESO_Applied) AS OMC_Final_PESO_Applied_p,
        SUM(OMC_No_of_CNG_Stations_Commissioned) AS OMC_No_of_CNG_Stations_Commissioned_p,
        SUM(COCO_CODO_DODO_Final_PESO_Applied) AS COCO_CODO_DODO_Final_PESO_Applied_p,
        SUM(COCO_CODO_DODO_No_of_CNG_Stations_Commissioned) AS COCO_CODO_DODO_No_of_CNG_Stations_Commissioned_p,
        SUM(CNG_Vehicles_OEM) AS CNG_Vehicles_OEM_p,
        SUM(CNG_Vehicles_Conversion) AS CNG_Vehicles_Conversion_p,
        SUM(PE_Laying_in_Mtr) AS PE_Laying_in_Mtr_p,
        SUM(PE_Commissioned_in_Mtr) AS PE_Commissioned_in_Mtr_p,
        SUM(MDPE_Laid_20_mm) AS MDPE_Laid_20_mm_p,
        SUM(MDPE_Commissioned_20_mm) AS MDPE_Commissioned_20_mm_p,
        SUM(steel_Stringing_in_Mtr) AS steel_Stringing_in_Mtr_p,
        SUM(steel_Commissioned_in_Mtr) AS steel_Commissioned_in_Mtr_p,
        SUM(steel_Commissioned) AS steel_Commissioned_p,
        SUM(steel_Stringing) AS steel_Stringing_p,
        SUM(OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr) AS OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_p,
        SUM(OFC_Duct_Laying_with_MDPE_in_Mtr) AS OFC_Duct_Laying_with_MDPE_in_Mtr_p")->get()->toArray();
        $distinputTill=$query4->selectRaw("SUM(domestic_Connections_registration) AS domestic_Connections_registration_t,
        SUM(domestic_Connections_advanced_plumbing) AS domestic_Connections_advanced_plumbing_t,
        SUM(domestic_Connections_Commissioned) AS domestic_Connections_Commissioned_t,
        SUM(commercial_NDEC_Connections_Registration) AS commercial_NDEC_Connections_Registration_t,
        SUM(commercial_NDEC_Connections_Commissioned) AS commercial_NDEC_Connections_Commissioned_t,
        SUM(industrial_Connections_Registration) AS industrial_Connections_Registration_t,
        SUM(industrial_Connections_Commissioned) AS industrial_Connections_Commissioned_t,
        SUM(OMC_Final_PESO_Applied) AS OMC_Final_PESO_Applied_t,
        SUM(OMC_No_of_CNG_Stations_Commissioned) AS OMC_No_of_CNG_Stations_Commissioned_t,
        SUM(COCO_CODO_DODO_Final_PESO_Applied) AS COCO_CODO_DODO_Final_PESO_Applied_t,
        SUM(COCO_CODO_DODO_No_of_CNG_Stations_Commissioned) AS COCO_CODO_DODO_No_of_CNG_Stations_Commissioned_t,
        SUM(CNG_Vehicles_OEM) AS CNG_Vehicles_OEM_t,
        SUM(CNG_Vehicles_Conversion) AS CNG_Vehicles_Conversion_t,
        SUM(PE_Laying_in_Mtr) AS PE_Laying_in_Mtr_t,
        SUM(PE_Commissioned_in_Mtr) AS PE_Commissioned_in_Mtr_t,
        SUM(MDPE_Laid_20_mm) AS MDPE_Laid_20_mm_t,
        SUM(MDPE_Commissioned_20_mm) AS MDPE_Commissioned_20_mm_t,
        SUM(steel_Stringing_in_Mtr) AS steel_Stringing_in_Mtr_t,
        SUM(steel_Commissioned_in_Mtr) AS steel_Commissioned_in_Mtr_t,
        SUM(steel_Commissioned) AS steel_Commissioned_t,
        SUM(steel_Stringing) AS steel_Stringing_t,
        SUM(OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr) AS OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_t,
        SUM(OFC_Duct_Laying_with_MDPE_in_Mtr) AS OFC_Duct_Laying_with_MDPE_in_Mtr_t")->get()->toArray();

        $tr="<tr>";
        $tr.="<td rowspan='3'>1</td><td rowspan='3'>Domestic Connections</td><td>Registration</td>";
        $tr.="<td>".$distinput[0]['domestic_Connections_registration']."</td><td>".$distinputMonth[0]['domestic_Connections_registration_m']."</td><td>".$distinputYear[0]['domestic_Connections_registration_y']."</td><td>".$distinputPYear[0]['domestic_Connections_registration_p']."</td><td>".$distinputTill[0]['domestic_Connections_registration_t']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>Last Mile Connectivity</td>";
        $tr.="<td>".$distinput[0]['domestic_Connections_advanced_plumbing']."</td><td>".$distinputMonth[0]['domestic_Connections_advanced_plumbing_m']."</td><td>".$distinputYear[0]['domestic_Connections_advanced_plumbing_y']."</td><td>".$distinputPYear[0]['domestic_Connections_advanced_plumbing_p']."</td><td>".$distinputTill[0]['domestic_Connections_advanced_plumbing_t']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>Commissioned</td>";
        $tr.="<td>".$distinput[0]['domestic_Connections_Commissioned']."</td><td>".$distinputMonth[0]['domestic_Connections_Commissioned_m']."</td><td>".$distinputYear[0]['domestic_Connections_Commissioned_y']."</td><td>".$distinputPYear[0]['domestic_Connections_Commissioned_p']."</td><td>".$distinputTill[0]['domestic_Connections_Commissioned_t']."</td>";
        $tr.="</tr>";

        $tr.="<tr>";
        $tr.="<td rowspan='2'>2</td><td rowspan='2'>Commercial / NDEC</td><td>Registration</td>";
        $tr.="<td>".$distinput[0]['commercial_NDEC_Connections_Registration']."</td><td>".$distinputMonth[0]['commercial_NDEC_Connections_Registration_m']."</td><td>".$distinputYear[0]['commercial_NDEC_Connections_Registration_y']."</td><td>".$distinputPYear[0]['commercial_NDEC_Connections_Registration_p']."</td><td>".$distinputTill[0]['commercial_NDEC_Connections_Registration_t']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>Commissioned</td>";
        $tr.="<td>".$distinput[0]['commercial_NDEC_Connections_Commissioned']."</td><td>".$distinputMonth[0]['commercial_NDEC_Connections_Commissioned_m']."</td><td>".$distinputYear[0]['commercial_NDEC_Connections_Commissioned_y']."</td><td>".$distinputPYear[0]['commercial_NDEC_Connections_Commissioned_p']."</td><td>".$distinputTill[0]['commercial_NDEC_Connections_Commissioned_t']."</td>";
        $tr.="</tr>";

        $tr.="<tr>";
        $tr.="<td rowspan='2'>3</td><td rowspan='2'>Industrial</td><td>Registration</td>";
        $tr.="<td>".$distinput[0]['industrial_Connections_Registration']."</td><td>".$distinputMonth[0]['industrial_Connections_Registration_m']."</td><td>".$distinputYear[0]['industrial_Connections_Registration_y']."</td><td>".$distinputPYear[0]['industrial_Connections_Registration_p']."</td><td>".$distinputTill[0]['industrial_Connections_Registration_t']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>Commissioned</td>";
        $tr.="<td>".$distinput[0]['industrial_Connections_Commissioned']."</td><td>".$distinputMonth[0]['industrial_Connections_Commissioned_m']."</td><td>".$distinputYear[0]['industrial_Connections_Commissioned_y']."</td><td>".$distinputPYear[0]['industrial_Connections_Commissioned_p']."</td><td>".$distinputTill[0]['industrial_Connections_Commissioned_t']."</td>";
        $tr.="</tr>";
        
        $tr.="<tr>";
        $tr.="<td rowspan='4'>4</td><td rowspan='4'>No. of CNG Stations</td><td>OMC Final PESO Applied</td>";
        $tr.="<td>".$distinput[0]['OMC_Final_PESO_Applied']."</td><td>".$distinputMonth[0]['OMC_Final_PESO_Applied_m']."</td><td>".$distinputYear[0]['OMC_Final_PESO_Applied_y']."</td><td>".$distinputPYear[0]['OMC_Final_PESO_Applied_p']."</td><td>".$distinputTill[0]['OMC_Final_PESO_Applied_t']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>OMC Commissioned</td>";
        $tr.="<td>".$distinput[0]['OMC_No_of_CNG_Stations_Commissioned']."</td><td>".$distinputMonth[0]['OMC_No_of_CNG_Stations_Commissioned_m']."</td><td>".$distinputYear[0]['OMC_No_of_CNG_Stations_Commissioned_y']."</td><td>".$distinputPYear[0]['OMC_No_of_CNG_Stations_Commissioned_p']."</td><td>".$distinputTill[0]['OMC_No_of_CNG_Stations_Commissioned_t']."</td>";
        $tr.="</tr>"; 
        $tr.="<tr>";
        $tr.="<td>COCO/CODO/DODO Final PESO Applied</td>";
        $tr.="<td>".$distinput[0]['COCO_CODO_DODO_Final_PESO_Applied']."</td><td>".$distinputMonth[0]['COCO_CODO_DODO_Final_PESO_Applied_m']."</td><td>".$distinputYear[0]['COCO_CODO_DODO_Final_PESO_Applied_y']."</td><td>".$distinputPYear[0]['COCO_CODO_DODO_Final_PESO_Applied_p']."</td><td>".$distinputTill[0]['COCO_CODO_DODO_Final_PESO_Applied_t']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>COCO/CODO/DODO Commissioned</td>";
        $tr.="<td>".$distinput[0]['COCO_CODO_DODO_No_of_CNG_Stations_Commissioned']."</td><td>".$distinputMonth[0]['COCO_CODO_DODO_No_of_CNG_Stations_Commissioned_m']."</td><td>".$distinputYear[0]['COCO_CODO_DODO_No_of_CNG_Stations_Commissioned_y']."</td><td>".$distinputPYear[0]['COCO_CODO_DODO_No_of_CNG_Stations_Commissioned_p']."</td><td>".$distinputTill[0]['COCO_CODO_DODO_No_of_CNG_Stations_Commissioned_t']."</td>";
        $tr.="</tr>";

        $tr.="<tr>";
        $tr.="<td rowspan='3'>5</td><td rowspan='3'>CNG Vehicles</td><td>OEM</td>";
        $tr.="<td>".$distinput[0]['CNG_Vehicles_OEM']."</td><td>".$distinputMonth[0]['CNG_Vehicles_OEM_m']."</td><td>".$distinputYear[0]['CNG_Vehicles_OEM_y']."</td><td>".$distinputPYear[0]['CNG_Vehicles_OEM_p']."</td><td>".$distinputTill[0]['CNG_Vehicles_OEM_t']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>Conversion</td>";
        $tr.="<td>".$distinput[0]['CNG_Vehicles_Conversion']."</td><td>".$distinputMonth[0]['CNG_Vehicles_Conversion_m']."</td><td>".$distinputYear[0]['CNG_Vehicles_Conversion_y']."</td><td>".$distinputPYear[0]['CNG_Vehicles_Conversion_p']."</td><td>".$distinputTill[0]['CNG_Vehicles_Conversion_t']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>Total</td>";
        $tr.="<td>".$distinput[0]['CNG_Vehicles_OEM']+$distinput[0]['CNG_Vehicles_Conversion']."</td><td>".$distinputMonth[0]['CNG_Vehicles_OEM_m']+$distinputMonth[0]['CNG_Vehicles_Conversion_m']."</td><td>".$distinputYear[0]['CNG_Vehicles_OEM_y']+$distinputYear[0]['CNG_Vehicles_Conversion_y']."</td><td>".$distinputPYear[0]['CNG_Vehicles_OEM_p']+$distinputPYear[0]['CNG_Vehicles_Conversion_p']."</td><td>".$distinputTill[0]['CNG_Vehicles_OEM_t']+$distinputTill[0]['CNG_Vehicles_Conversion_t']."</td>";
        $tr.="</tr>";
        $PE_Laying_in_Mtr=$distinput[0]['PE_Laying_in_Mtr']/1000;
        $PE_Commissioned_in_Mtr=$distinput[0]['PE_Commissioned_in_Mtr']/1000;
        $MDPE_Laid_20_mm=$distinput[0]['MDPE_Laid_20_mm']/1000;
        $MDPE_Commissioned_20_mm=$distinput[0]['MDPE_Commissioned_20_mm']/1000;

        $PE_Laying_in_Mtr_m=$distinputMonth[0]['PE_Laying_in_Mtr_m']/1000;
        $PE_Commissioned_in_Mtr_m=$distinputMonth[0]['PE_Commissioned_in_Mtr_m']/1000;
        $MDPE_Laid_20_mm_m=$distinputMonth[0]['MDPE_Laid_20_mm_m']/1000;
        $MDPE_Commissioned_20_mm_m=$distinputMonth[0]['MDPE_Commissioned_20_mm_m']/1000;

        $PE_Laying_in_Mtr_y=$distinputYear[0]['PE_Laying_in_Mtr_y']/1000;
        $PE_Commissioned_in_Mtr_y=$distinputYear[0]['PE_Commissioned_in_Mtr_y']/1000;
        $MDPE_Laid_20_mm_y=$distinputYear[0]['MDPE_Laid_20_mm_y']/1000;
        $MDPE_Commissioned_20_mm_y=$distinputYear[0]['MDPE_Commissioned_20_mm_y']/1000;

        $PE_Laying_in_Mtr_p=$distinputPYear[0]['PE_Laying_in_Mtr_p']/1000;
        $PE_Commissioned_in_Mtr_p=$distinputPYear[0]['PE_Commissioned_in_Mtr_p']/1000;
        $MDPE_Laid_20_mm_p=$distinputPYear[0]['MDPE_Laid_20_mm_p']/1000;
        $MDPE_Commissioned_20_mm_p=$distinputPYear[0]['MDPE_Commissioned_20_mm_p']/1000;
        
        $PE_Laying_in_Mtr_t=$distinputTill[0]['PE_Laying_in_Mtr_t']/1000;
        $PE_Commissioned_in_Mtr_t=$distinputTill[0]['PE_Commissioned_in_Mtr_t']/1000;
        $MDPE_Laid_20_mm_t=$distinputTill[0]['MDPE_Laid_20_mm_t']/1000;
        $MDPE_Commissioned_20_mm_t=$distinputTill[0]['MDPE_Commissioned_20_mm_t']/1000;
        
        $tr.="<tr>";
        $tr.="<td rowspan='4'>6</td><td rowspan='4'>MDPE Pipeline (in Km.)</td><td>(a)Laid</td>";
        $tr.="<td>".$PE_Laying_in_Mtr."</td><td>".$PE_Laying_in_Mtr_m."</td><td>".$PE_Laying_in_Mtr_y."</td><td>".$PE_Laying_in_Mtr_p."</td><td>".$PE_Laying_in_Mtr_t."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>(b)Commissioned</td>";
        $tr.="<td>".$PE_Commissioned_in_Mtr."</td><td>".$PE_Commissioned_in_Mtr_m."</td><td>".$PE_Commissioned_in_Mtr_y."</td><td>".$PE_Commissioned_in_Mtr_p."</td><td>".$PE_Commissioned_in_Mtr_t."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>(c)Laid - 20 mm</td>";
        $tr.="<td>".$MDPE_Laid_20_mm."</td><td>".$MDPE_Laid_20_mm_m."</td><td>".$MDPE_Laid_20_mm_y."</td><td>".$MDPE_Laid_20_mm_p."</td><td>".$MDPE_Laid_20_mm_t."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>(d)Commissioned - 20 mm</td>";
        $tr.="<td>".$MDPE_Commissioned_20_mm."</td><td>".$MDPE_Commissioned_20_mm_m."</td><td>".$MDPE_Commissioned_20_mm_y."</td><td>".$MDPE_Commissioned_20_mm_p."</td><td>".$MDPE_Commissioned_20_mm_t."</td>";
        $tr.="</tr>";
        
        $steel_Stringing_in_Mtr=$distinput[0]['steel_Stringing_in_Mtr']/1000;
        $steel_Commissioned_in_Mtr=$distinput[0]['steel_Commissioned_in_Mtr']/1000;

        $steel_Stringing_in_Mtr_m=$distinputMonth[0]['steel_Stringing_in_Mtr_m']/1000;
        $steel_Commissioned_in_Mtr_m=$distinputMonth[0]['steel_Commissioned_in_Mtr_m']/1000;

        $steel_Stringing_in_Mtr_y=$distinputYear[0]['steel_Stringing_in_Mtr_y']/1000;
        $steel_Commissioned_in_Mtr_y=$distinputYear[0]['steel_Commissioned_in_Mtr_y']/1000;
        
        $steel_Stringing_in_Mtr_p=$distinputPYear[0]['steel_Stringing_in_Mtr_p']/1000;
        $steel_Commissioned_in_Mtr_p=$distinputPYear[0]['steel_Commissioned_in_Mtr_p']/1000;
        
        $steel_Stringing_in_Mtr_t=$distinputTill[0]['steel_Stringing_in_Mtr_t']/1000;
        $steel_Commissioned_in_Mtr_t=$distinputTill[0]['steel_Commissioned_in_Mtr_t']/1000;
        
        $tr.="<tr>";
        $tr.="<td rowspan='2'>7</td><td rowspan='2'>Steel pipeline (in Km.)</td><td>(a)Stringing</td>";
        $tr.="<td>".$steel_Stringing_in_Mtr."</td><td>".$steel_Stringing_in_Mtr_m."</td><td>".$steel_Stringing_in_Mtr_y."</td><td>".$steel_Stringing_in_Mtr_p."</td><td>".$steel_Stringing_in_Mtr_t."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>(b)Commissioned</td>";
        $tr.="<td>".$steel_Commissioned_in_Mtr."</td><td>".$steel_Commissioned_in_Mtr_m."</td><td>".$steel_Commissioned_in_Mtr_y."</td><td>".$steel_Commissioned_in_Mtr_p."</td><td>".$steel_Commissioned_in_Mtr_t."</td>";
        $tr.="</tr>";

        $steel_Commissioned=$distinput[0]['steel_Commissioned']/1000;
        $steel_Stringing=$distinput[0]['steel_Stringing']/1000;
        $steel_Commissioned_m=$distinputMonth[0]['steel_Commissioned_m']/1000;
        $steel_Stringing_m=$distinputMonth[0]['steel_Stringing_m']/1000;
        $steel_Commissioned_y=$distinputYear[0]['steel_Commissioned_y']/1000;
        $steel_Stringing_y=$distinputYear[0]['steel_Stringing_y']/1000;
        $steel_Commissioned_p=$distinputPYear[0]['steel_Commissioned_p']/1000;
        $steel_Stringing_p=$distinputPYear[0]['steel_Stringing_p']/1000;
        $steel_Commissioned_t=$distinputTill[0]['steel_Commissioned_t']/1000;
        $steel_Stringing_t=$distinputTill[0]['steel_Stringing_t']/1000;
        $tr.="<tr>";
        $tr.="<td rowspan='2'>8</td><td rowspan='2'>Steel pipeline (inch-Km.)</td><td>(a)Stringing</td>";
        $tr.="<td>".$steel_Commissioned."</td><td>".$steel_Commissioned_m."</td><td>".$steel_Commissioned_y."</td><td>".$steel_Commissioned_p."</td><td>".$steel_Commissioned_t."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>(b)Commissioned</td>";
        $tr.="<td>".$steel_Stringing."</td><td>".$steel_Stringing_m."</td><td>".$steel_Stringing_y."</td><td>".$steel_Stringing_p."</td><td>".$steel_Stringing_t."</td>";
        $tr.="</tr>";
        $OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr=$distinput[0]['OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr']/1000;
        $OFC_Duct_Laying_with_MDPE_in_Mtr=$distinput[0]['OFC_Duct_Laying_with_MDPE_in_Mtr']/1000;
        $OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_m=$distinputMonth[0]['OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_m']/1000;
        $OFC_Duct_Laying_with_MDPE_in_Mtr_m=$distinputMonth[0]['OFC_Duct_Laying_with_MDPE_in_Mtr_m']/1000;
        $OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_y=$distinputYear[0]['OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_y']/1000;
        $OFC_Duct_Laying_with_MDPE_in_Mtr_y=$distinputYear[0]['OFC_Duct_Laying_with_MDPE_in_Mtr_y']/1000;
        $OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_p=$distinputPYear[0]['OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_p']/1000;
        $OFC_Duct_Laying_with_MDPE_in_Mtr_p=$distinputPYear[0]['OFC_Duct_Laying_with_MDPE_in_Mtr_p']/1000;
        $OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_t=$distinputTill[0]['OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_t']/1000;
        $OFC_Duct_Laying_with_MDPE_in_Mtr_t=$distinputTill[0]['OFC_Duct_Laying_with_MDPE_in_Mtr_t']/1000;
        $tr.="<tr>";
        $tr.="<td rowspan='2'>9</td><td rowspan='2'>OFC Duct Laying</td><td>(a)With Steel Pipeline (Kms)</td>";
        $tr.="<td>".$OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr."</td><td>".$OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_m."</td><td>".$OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_y."</td><td>".$OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_p."</td><td>".$OFC_Duct_Laying_with_Steel_Pipeline_in_Mtr_t."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td>(b)With MDPE (Kms)</td>";
        $tr.="<td>".$OFC_Duct_Laying_with_MDPE_in_Mtr."</td><td>".$OFC_Duct_Laying_with_MDPE_in_Mtr_m."</td><td>".$OFC_Duct_Laying_with_MDPE_in_Mtr_y."</td><td>".$OFC_Duct_Laying_with_MDPE_in_Mtr_p."</td><td>".$OFC_Duct_Laying_with_MDPE_in_Mtr_t."</td>";
        $tr.="</tr>";

        //sales section
        $sales=$query5->where("input_date",$alldata['input_date'])->get()->toArray();
        $salesM=$query6->where("input_date","LIKE","$mon%")->selectRaw("SUM(png_domestic_sales_scm) AS png_domestic_sales_scm,
        SUM(png_commercial_sales_scm) AS png_commercial_sales_scm,
        SUM(png_industrial_sales_scm) AS png_industrial_sales_scm,
        SUM(cng_sales_scm) AS cng_sales_scm,
        SUM(direct_lng_sales_scm) AS direct_lng_sales_scm")->get()->toArray();
        $salesY=$query7->where("input_date","LIKE","$mon%")->selectRaw("SUM(png_domestic_sales_scm) AS png_domestic_sales_scm,
        SUM(png_commercial_sales_scm) AS png_commercial_sales_scm,
        SUM(png_industrial_sales_scm) AS png_industrial_sales_scm,
        SUM(cng_sales_scm) AS cng_sales_scm,
        SUM(direct_lng_sales_scm) AS direct_lng_sales_scm")->get()->toArray();
        $salesPY=$query8->where("input_date","LIKE","$mon%")->selectRaw("SUM(png_domestic_sales_scm) AS png_domestic_sales_scm,
        SUM(png_commercial_sales_scm) AS png_commercial_sales_scm,
        SUM(png_industrial_sales_scm) AS png_industrial_sales_scm,
        SUM(cng_sales_scm) AS cng_sales_scm,
        SUM(direct_lng_sales_scm) AS direct_lng_sales_scm")->get()->toArray();
        $salesT=$query9->where("input_date","LIKE","$mon%")->selectRaw("SUM(png_domestic_sales_scm) AS png_domestic_sales_scm,
        SUM(png_commercial_sales_scm) AS png_commercial_sales_scm,
        SUM(png_industrial_sales_scm) AS png_industrial_sales_scm,
        SUM(cng_sales_scm) AS cng_sales_scm,
        SUM(direct_lng_sales_scm) AS direct_lng_sales_scm")->get()->toArray();
        $tr.="<tr><th colspan='8'>Sales</th></tr>";
        $tr.="<tr><th colspan='2'>Total Sales (SCM)</th><th></th><th>".@$sales[0]['png_domestic_sales_scm']+@$sales[0]['png_commercial_sales_scm']+@$sales[0]['png_industrial_sales_scm']+@$sales[0]['cng_sales_scm']+@$sales[0]['cng_sales_scm']."</th><th>".@$salesM[0]['png_domestic_sales_scm']+@$salesM[0]['png_commercial_sales_scm']+@$salesM[0]['png_industrial_sales_scm']+@$salesM[0]['cng_sales_scm']+@$salesM[0]['cng_sales_scm']."</th><th>".@$salesY[0]['png_domestic_sales_scm']+@$salesY[0]['png_commercial_sales_scm']+@$salesY[0]['png_industrial_sales_scm']+@$salesY[0]['cng_sales_scm']+@$salesY[0]['cng_sales_scm']."</th><th>".@$salesPY[0]['png_domestic_sales_scm']+@$salesPY[0]['png_commercial_sales_scm']+@$salesPY[0]['png_industrial_sales_scm']+@$salesPY[0]['cng_sales_scm']+@$salesPY[0]['cng_sales_scm']."</th><th>".@$salesT[0]['png_domestic_sales_scm']+@$salesT[0]['png_commercial_sales_scm']+@$salesT[0]['png_industrial_sales_scm']+@$salesT[0]['cng_sales_scm']+@$salesT[0]['cng_sales_scm']."</th></tr>";
        $tr.="<tr>";
        $tr.="<td colspan='2' >PNG-Domestic sales (SCM) – Est. </td><td>SCM</td>";
        $tr.="<td>".@$sales[0]['png_domestic_sales_scm']."</td><td>".@$salesM[0]['png_domestic_sales_scm']."</td><td>".@$salesY[0]['png_domestic_sales_scm']."</td><td>".@$salesPY[0]['png_domestic_sales_scm']."</td><td>".@$salesT[0]['png_domestic_sales_scm']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td colspan='2' >PNG-Commercial sales (SCM)-Est. </td><td>SCM</td>";
        $tr.="<td>".@$sales[0]['png_commercial_sales_scm']."</td><td>".@$salesM[0]['png_commercial_sales_scm']."</td><td>".@$salesY[0]['png_commercial_sales_scm']."</td><td>".@$salesPY[0]['png_commercial_sales_scm']."</td><td>".@$salesT[0]['png_commercial_sales_scm']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td colspan='2' >PNG-Industrial sales (SCM) </td><td>SCM</td>";
        $tr.="<td>".@$sales[0]['png_industrial_sales_scm']."</td><td>".@$salesM[0]['png_industrial_sales_scm']."</td><td>".@$salesY[0]['png_industrial_sales_scm']."</td><td>".@$salesPY[0]['png_industrial_sales_scm']."</td><td>".@$salesT[0]['png_industrial_sales_scm']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td colspan='2' >CNG sales (SCM) </td><td>SCM</td>";
        $tr.="<td>".@$sales[0]['cng_sales_scm']."</td><td>".@$salesM[0]['cng_sales_scm']."</td><td>".@$salesY[0]['cng_sales_scm']."</td><td>".@$salesPY[0]['cng_sales_scm']."</td><td>".@$salesT[0]['cng_sales_scm']."</td>";
        $tr.="</tr>";
        $tr.="<tr>";
        $tr.="<td colspan='2' >Direct LNG Sales</td><td>SCM</td>";
        $tr.="<td>".@$sales[0]['direct_lng_sales_scm']."</td><td>".@$salesM[0]['direct_lng_sales_scm']."</td><td>".@$salesY[0]['direct_lng_sales_scm']."</td><td>".@$salesPY[0]['direct_lng_sales_scm']."</td><td>".@$salesT[0]['direct_lng_sales_scm']."</td>";
        $tr.="</tr>";
        if($gaonly==1)
        {
            //compression Services
            $tr.="<tr><th colspan='8'>Compression Services</th></tr>";
            $tr.="<tr>";
            $tr.="<td colspan='2' >For AG&P GA</td><td>SCM</td>";
            $tr.="<td>0</td><td>0</td><td>0</td><td>0</td><td>0</td>";
            $tr.="</tr>";
            $tr.="<tr>";
            $tr.="<td colspan='2' >For AG&P GA</td><td>SCM</td>";
            $tr.="<td>0</td><td>0</td><td>0</td><td>0</td><td>0</td>";
            $tr.="</tr>";

            //highlights
            $tr.="<tr>";
            $tr.="<th colspan='8'>Highlights</th>";
            $tr.="</tr>";
            $highs=DprHighlights::where("ga_code",$alldata['ga_code'])->where("created_at",$alldata['input_date'])->get()->toArray();
            if(!empty($highs))
            {
                foreach($highs as $k=>$val)
                {
                    $tr.="<tr>";
                    $tr.="<td>".$val['field_name']."</td><td colspan='7'>".$val['field_value']."</td>";
                    $tr.="</tr>";
                }
            } 
        }

        echo $tr;
    }


            /*---------Highlights MASTER--------------*/
            public function dashboardHighlights(Request $request)
            {
                 $user=auth()->user();
                if(Auth::check()){
                    $display="ok";
                    if($display=="ok")
                    {
                        $ga=dd_masters("ga","ga_code");
                        $highlights  = DprHighlights::all();
                        if(isset($request->zid))
                        {
                            $zid=$request->zid;
                            $highlightsdetail  = DprHighlights::where("id",$zid)->first();
                            return view('dpr.highlights',['highlights'=>$highlights,'highlightsdetail'=>$highlightsdetail,'ga'=>$ga]);
                        }
                        else 
                        {
                            return view('dpr.highlights',['highlights'=>$highlights,'ga'=>$ga]);
                        }
                        
                    }
                    else
                    {
                         dd($display) ;
                    } 
                }
                else
                {
                     return redirect("/")->withSuccess('Opps! You do not have access');
                }
            }  
            public function dashboardHighlightsPost(Request $request)
            {
                $user=auth()->user();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                }
                else $zid="";
                
                $validator=  Validator::make($request->all(), [
                    "highlights"=>"required",
                ]
                );
        
                if($validator->fails()) {
                    return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Module Name is required!"]);
                }
                $highlights=$request->highlights;
                if(!empty($highlights))
                {
                    foreach($highlights as $kk=>$val)
                    {
                        $data =array(
                            "field_name"=>$kk,
                            "field_value"=>$val,
                            "status"=>"Active",
                            "ga_code"=>$request->ga_code,
                            "created_at"=>date("Y-m-d"),
                            "updated_at"=>date("Y-m-d"),
                            "user_id"=>$user['userId']
                        );
                        if($zid!="")
                        {
                            $create  = DprHighlights::where("id", $zid)->update($data); // add new row in user table
                        }
                        else
                        $create  = DprHighlights::insert($data); // add new row in user table
                    }
                }
                if(!is_null($create)) {
                    if($zid!="")
                    {
                        return redirect()->intended('dashboardHighlights')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Module updated successfully!"]);
                    }
                    else
                    return back()->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Module created successfully!"]);
                }
        
                else {
                    return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Module creation failed!"]);
                } 
            }
            public function dashboardHighlightsDelete($zid)
            {
                $delete  = DprHighlights::find($zid)->delete();// delete row in user table
                if($delete)
                {
                     return redirect()->intended('dashboardHighlights')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Module deleted successfully!"]);
                }
                else
                {
                    return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Module deletion failed!"]);
                }
            }
}