<?php
namespace App\Http\Controllers\Master;
use App\Models\User;
use App\Models\UserRoles;
use App\Http\Controllers\Controller;
use App\Models\MasterControlCenter;
use App\Models\MasterFunction;
use App\Models\MasterShift;
use App\Models\MasterGA;
use App\Models\MasterDistrict;
use App\Models\MasterShiftChecklist;
use App\Models\MasterEquipment;
use App\Models\MasterStations;
use App\Models\MasterSources;
use App\Models\MasterNetworks;
use App\Models\MasterModule;
use App\Models\Customer;
use App\Models\MasterRole;
use App\Models\UserBlocked;
use App\Models\MasterTankerno;
use App\Models\MasterGastype;



use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Exception;
use Log;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Schema;
use Storage;
use DB;
use Session;
  
class MasterController extends Controller
{
       /*---------MODULE MASTER--------------*/
    public function icons(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            return view('masters.icons',[]);
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    }
        /*---------MODULE MASTER--------------*/
    public function moduleMaster(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            // $display=checkRolesPage("Masters");
            $display="ok";
            if($display=="ok")
            {
                $module  = MasterModule::all();
                $parent_modules=MasterModule::where('status',"Active")->where("parent_module",NULL)->pluck("module_name","id")->all();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $moduledetail  = MasterModule::where("id",$zid)->first();
                    return view('masters.module',['parent_modules'=>$parent_modules,'modules'=>$module,'moduledetail'=>$moduledetail]);
                }
                else 
                {
                    return view('masters.module',['parent_modules'=>$parent_modules,'modules'=>$module]);
                }
                
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    }  
    public function moduleMasterPost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "module_name"=>"required"
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Module Name is required!"]);
        }

        $data =array(
            "parent_module"=>$request->parent_module,
            "module_name"=>$request->module_name,
            "module_link"=>$request->module_link,
            "status"=>$request->status,
            "module_icon"=>$request->module_icon,
        );
        
        if($zid!="")
        {
            $row_status=  MasterModule::where('id', '!=' , $zid)->where('parent_module', '=' , $request->parent_module)->where("module_name", $request->module_name)->first();// check for the unique module name
        }
        else
        $row_status=  MasterModule::where("module_name", $request->module_name)->where('parent_module', '=' , $request->parent_module)->first();// check for the unique module name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Module Name is already exists!"]);
        }
        if($zid!="")
        {
            $create  = MasterModule::where("id", $zid)->update($data); // add new row in user table
        }
        else
        $create  = MasterModule::insert($data); // add new row in user table

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('moduleMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Module updated successfully!"]);
            }
            else
            return back()->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Module created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Module creation failed!"]);
        }
    }
    public function moduleMasterDelete($zid)
    {
        $delete  = MasterModule::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('moduleMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Module deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Module deletion failed!"]);
        }
    }
     /*---------ASSIGN ROLE MASTER--------------*/
    public function roleMaster(Request $request)
    {
        $user=auth()->user();
        if(Auth::check()){
            // $display=checkRolesPage("Masters");
            $display="ok";
            if($display=="ok")
            {
                $allrole=MasterRole::get()->toArray();
               // $roles=User::where("role","!=","Super Admin")->pluck("role")->toArray();
               $roles=User::pluck("role")->toArray();
                $roles=array_unique($roles);
                $modu  = MasterModule::where("status","Active")->orderBy("id","asc")->get()->toArray();
                $module=array();
                if(!empty($modu))
                {
                    foreach($modu as $k=>$v)
                    {
                        if($v['parent_module']!="")
                        {
                            $module[$v['parent_module']][$k]['module_name']=$v['module_name'];
                            $module[$v['parent_module']][$k]['id']=$v['id'];
                        }
                    }
                }
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $roledetail  = MasterRole::where("id",$zid)->first();
                    return view('masters.role',['modules'=>$module,'roles'=>$roles,'allrole'=>$allrole,'roleDetail'=>$roledetail]);
                }
                else 
                {
                    return view('masters.role',['modules'=>$module,'roles'=>$roles,'allrole'=>$allrole]);
                }
                
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    }  
    public function roleMasterPost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "role_name"=>"required"
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Role Name is required!"]);
        }

        $data =array(
            "parent_module"=>$request->module,
            "designation"=>$request->role,
            "role_name"=>$request->role_name,
            "role_access"=>json_encode($request->role_access),
            "status"=>"Active",
            "created_at"=>date("Y-m-d H:i:s")
        );
        //print_r($data);exit;
        if($zid!="")
        {
            $row_status=  MasterRole::where('id', '!=' , $zid)->where("role_name", $request->role_name)->first();// check for the unique role name
        }
        else
        $row_status=  MasterRole::where("role_name", $request->role_name)->first();// check for the unique role name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Role Name is already exists!"]);
        }
        if($zid!="")
        {
            $create  = MasterRole::where("id", $zid)->update($data); // add new row in user table
        }
        else
        $create  = MasterRole::insert($data); // add new row in user table

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('roleMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Role updated successfully!"]);
            }
            else
            return back()->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Role created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Role creation failed!"]);
        }
    }
    
    public function createUser(Request $request)
    {
        $user=auth()->user();
          $userdetails = [];
        if(Auth::check()){
          $ga=MasterGA::pluck("ga_name","ga_code")->toArray();
          $roles=MasterRole::pluck("role_name","id")->toArray();
          $bg=Customer::select('BP_Grouping')->distinct()->get()->toArray();
          $designation=User::where("role","!=","Super Admin")->pluck("role")->toArray();
          $designation=array_unique($designation);
          if(isset($request->zid))
          {
            $zid=$request->zid;
            //$userdetail  = User::where("userId",$zid)->first();
            $userdetails=DB::table('users')
            ->leftJoin('users_role', 'users.userId', '=', 'users_role.user_id')
            ->where("userId",$zid)->where("users_role.status",1)->get()->map(function ($item) {
               return (array) $item;
				})
				->toArray();
			if (count($userdetails) != 0) {
            $userdetail = $userdetails[0];
			}else{
				$userdetail = $userdetails;
			}
			
          // print_r($userdetails);exit;
            return view('masters.createUser',['ga'=>$ga,'designation'=>$designation,'roles'=>$roles,'bg'=>$bg,'userdetail'=>$userdetail]);
          }
          else 
          {
            return view('masters.createUser',['ga'=>$ga,'designation'=>$designation,'roles'=>$roles,'bg'=>$bg]);
          }
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    /*post user*/
    public function createUserPost(Request $request)
    {
        $alldata=$request->all();
        $zid="";
        if(isset($alldata["zid"]))
        {
            $zid=$alldata["zid"];
            $validator=  Validator::make($request->all(), [
            "roles"=>"required"]);
            if($validator->fails()) {
                return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Role is required!"]);
            }
            $data=array(
                "updated_at"=>date("Y-m-d H:i:s"),
                "status"=>$alldata['status']
            );
            $user_roles=UserRoles::where("user_id",$zid)->update($data);
            $uid=Auth::user()->userId;
            $data1=array(
                "user_id"=>$alldata['zid'],
                "role"=>json_encode($alldata['roles']),
                "created_at"=>date("Y-m-d H:i:s"),
                "updated_at"=>date("Y-m-d H:i:s"),
                "status"=>1,
                "remarks"=>$alldata['remarks'],
                "assigned_by"=>$uid
                );
            $create=UserRoles::insertGetId($data1);
            if($alldata['status']==2)
            {
                $data3=array(
                    "user_id"=>$alldata['zid'],
                    "blocked_by"=>Auth::user()->userId,
                    "remarks"=>$alldata['reason'],
                    "created_at"=>date("Y-m-d H:i:s"),
                "updated_at"=>date("Y-m-d H:i:s"),
                );
                $create=UserBlocked::insertGetId($data3);
            }
        }
        else
        {
            $validator=  Validator::make($request->all(), [
                 "userId"=>"required",
                 "userName"=>"required",
                 "designation"=>"required",
                 "roles"=>"required"]);
            if($validator->fails()) {
                return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Field is required!"]);
            }
            $profile_picture=uploadDoc("profile_picture",$request->profile_picture,"profile_".$alldata['userId']);
            $data=array(
                "userId"=>$alldata['userId'],
                "userName"=>$alldata['userName'],
                "email"=>$alldata['email'],
                "phone"=>$alldata['phone'],
                "ga"=>$alldata['GA'],
                "role"=>$alldata['designation'],
                "dob"=>$alldata['dob'],
                "o_auth"=>$alldata['o_auth'],
                "profile_picture"=>$profile_picture,
                "created_at"=>date("Y-m-d H:i:s"),
                "updated_at"=>date("Y-m-d H:i:s"),
                "status"=>1,
				"employee_id"=>$alldata['emp_id'],
				"designation"=>$alldata['user_designation'],
				"employee_type"=>$alldata['employee_type']
            );
            
            $user_roles=User::insertGetId($data);
            $uid=Auth::user()->userId;
            $data1=array(
                "user_id"=>$alldata['userId'],
                "role"=>json_encode($alldata['roles']),
                "created_at"=>date("Y-m-d H:i:s"),
                "updated_at"=>date("Y-m-d H:i:s"),
                "status"=>1,
                "remarks"=>$alldata['remarks'],
                "assigned_by"=>$uid
                );
            $create=UserRoles::insertGetId($data1);
        }
        
        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('listAllUser')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "User updated successfully!"]);
            }
            else
            return back()->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "User created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Failed!"]);
        }
    }
    public function importOfficeUserPost(Request $request)
    {
        $requiredHeaders = array('id','userId','userName','password','email','phone','status','role','ga','created_at','dob','profile_picture','o_auth'
    );
        $aa="User";
        $path = $request->file('file')->getRealPath();
        $records = array_map('str_getcsv', file($path));
       
        if (! count($records) > 0) {
            return back()->with(["status" =>200,"code" => 1, "success" => false, "msg" => "No Records Found!"]);
        }
       $fields =$records[0];
        if ($fields !== $requiredHeaders) {
             return back()->with(["status" =>200,"code" => 0, "success" => false, "msg" => "Please upload data in correct format!"]);
             exit;
         }
        array_shift($records);
        foreach ($records as $record) {
            if (count($fields) != count($record)) {
                return back()->with(["status" => 200,"code" => 1, "success" => false, "msg" => "Invalid data!"]);
            }
            $record =  array_map("html_entity_decode", $record);
            $record = array_combine($fields, $record);
            $this->rows[] = $this->clearencodingstr($record);
        }
        foreach ($this->rows as $data) {
           // print_r($data);exit;
           // User::create($data);
            if($data['role']!="")
            {
                $vv=MasterRole::where("role_name","LIKE",$data["role"])->value("id");
                
                $role=array((string)$vv);
                 $data1=array(
                "user_id"=>$data['userId'],
                "role"=>json_encode($role),
                "created_at"=>date("Y-m-d H:i:s"),
                "updated_at"=>date("Y-m-d H:i:s"),
                "status"=>1,
                "remarks"=>"data imported",
                "assigned_by"=>Auth::user()->userid
                );
                print_r($data1);exit;
           // $create=UserRoles::create($data1);
            }
        }
        return back()->with(["status" => 200,"code" => 1, "success" => true, "msg" => "$aa list uploaded successfully!"]);
    }

   private function clearencodingstr($value)
    {
        if (is_array($value)) {
            $clean = [];
            foreach ($value as $key => $val) {
                if(!in_array($key,array('id','userId','userName','password','email','phone','status','role','ga','created_at','dob','profile_picture','o_auth')))
                $clean[$key] = mb_convert_encoding(encryptIt($val), 'UTF-8', 'UTF-8');
                else
                $clean[$key] = mb_convert_encoding($val, 'UTF-8', 'UTF-8');
              //  $clean[$key] = mb_convert_encoding($val, 'UTF-8', 'UTF-8');
            }
            return $clean;
        }
        return mb_convert_encoding($value, 'UTF-8', 'UTF-8');
    }
    public function listAllUser()
    {
        $user=auth()->user();
        if(Auth::check()){
            return view('masters.user_list',[]);
        }
        else
        {
            return redirect("/")->withSuccess('Opps! You do not have access');
             
        }
    }
    public function getAllUser(Request $request)
    {
        $alldata=$request->all();
        $form=$request->input('formdata');
        $params = array();
        if(isset($request->device))
        {
            $device=$request->device;
        }
        else
        {
            $device="";
        } 
        $uid=$alldata['userId'];
        $desig=User::where("userId",$uid)->value("role");
        $ga=User::where("userId",$uid)->value("ga");
        parse_str($form, $params);
        $query = User::query();
        $query=$query->where("id","!=","1")->where("role","!=","Surveyor");
        if($desig=="Super Admin" || $desig=="Admin")
        {
            $query = $query;
        }
        else
        {
            $query=$query->where("ga",$ga);
        }
        //echo $query->toSql();
        if(!empty($params))
        {
            foreach($params as $kk=>$vall)
            {
                if($vall!="")
                {
                    $query=$query->where($kk,$vall);
                }
            }
        }
        if($device=="web") 
        {
            $columns = ['id','userId','userName','email','phone','role','ga','employee_id','designation','employee_type','dob'];
            $totalData = User::count();
            $totalFiltered = $totalData;
            $limit = $request->input('length');
            $start = $request->input('start');
            $order = $columns[$request->input('order.0.column')];
            $dir = $request->input('order.0.dir');
             if(!empty($request->input('search.value')))
             {
                $search = $request->input('search.value'); 
                 $query = $query->where(function ($query) use ($search) {
              $query-> where('userId', 'LIKE',"%{$search}%")
                    ->orWhere('userName', 'LIKE',"%{$search}%") 
                    ->orWhere('ga', 'LIKE',"%{$search}%") 
                    ->orWhere('role', 'LIKE',"%{$search}%") 
                    ->orWhere('email', 'LIKE',"%{$search}%")
                    ->orWhere('phone', 'LIKE',"%{$search}%")
					
					->orWhere('dob', 'LIKE',"%{$search}%")
					
					->orWhere('employee_id', 'LIKE',"%{$search}%")
					->orWhere('designation', 'LIKE',"%{$search}%")
					->orWhere('employee_type', 'LIKE',"%{$search}%");
                 });
             }
            $totalFiltered= $query->count();
            if ($limit== -1){
                    $posts = $query->orderBy($order,$dir)
                    ->get();   
                }
                else{
                   $posts = $query->offset($start)
                            ->limit($limit)
                            ->orderBy($order,$dir)
                            ->get(); 
                }
            
        }
        else
        { 
            $posts = $query->get()->toArray();
        }
        $data = array();
        if (!empty($posts)) {
            if($device=="")
            {
                $data=$posts;
            }
            else
            {
                $i=0;
                foreach ($posts as $post) {
                    $i++;
                    $rols=array();
              $user_roles=json_decode(UserRoles::where("user_id",$post->userId)->where("status",1)->value("role"));
              if(!empty($user_roles))
              {
                  foreach($user_roles as $aa)
                  {
                      $rols[]=anyFiled("MasterRole","role_name",$aa);
                  }
              }
              $rol=implode(", ",$rols);
                $nestedData["slno"]=$i;  
				$nestedData["userId"]=$post->userId;  
                $nestedData['userName']=$post->userName;
                $nestedData['ga'] = $post->ga;
                $nestedData['role'] = $rol;
                $nestedData['email'] = $post->email;
                $nestedData['phone'] = $post->phone;
				
				$nestedData['dob'] = $post->dob;
				
				$nestedData['employee_id'] = $post->employee_id;
				$nestedData['designation'] = $post->designation;
				$nestedData['employee_type'] = $post->employee_type;
				
                $edit = route('createUser', ['zid'=>$post->userId]);
                $title="Edit";$icon="ti-pencil-alt";
                $nestedData['option']='<a href="' . $edit . '" title="'.$title.'" ><button type="button"  class="btn btn-info btn-sm mr-1"><i class="fas '.$icon.'"></i></button></a>';
                $data[] = $nestedData;
                }
            }
        }

        if($device=="web")
        {
            $json_data = array(
            "draw" => intval($request->input('draw')),
            "recordsTotal" => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data" => $data,);
            echo json_encode($json_data);
        }
        else
        {
            $logs = array(
                        'module' => "Survey",
                        'user' => $alldata['userId'],
                        'access_device' => $device,
                        'called_api' => route('listUser'),
                        'called_to' => "web",
                        'request_data' => json_encode($alldata),
                        'response_data' => json_encode($data1),
                        'method_name' => "POST",
        
                    );
            $log = manageLogs($logs);
            return response()->json(["status" => config("constants.OK"),"code" => 1, "msg" => "User Fetched!", "data"=>$data]);
        }

    }
    
    /*get District from GA*/
    public function getMenuList(Request $request)
    {
        $alldata=$request->all();
        $district=array();
        if($alldata['module']!="")
        {
            $district=MasterModule::where("parent_module",$alldata['module'])->pluck("module_name","id");
        }
        if($alldata['device']=="web")
        {
            echo json_encode($district);
        }
        else
        return response()->json(["status" => 200, "msg" => "Data fetched!","code" => config("constants.CODE_SUCCESS"),"data"=>$district]);
    }
   /*--------CONTROL CENTER MASTER--------------*/
    public function controlCenterMaster(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $controlCenter  = MasterControlCenter::all();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $controlCenterDetail  = MasterControlCenter::where("id",$zid)->first()->toArray();
                    return view('masters.controlCenter',['controlCenter'=>$controlCenter,'controlCenterDetail'=>$controlCenterDetail]);
                }
                else 
                {
                    return view('masters.controlCenter',['controlCenter'=>$controlCenter]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function controlCenterMasterPost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "control_center_name"=>"required",
             "control_center_code"=>"required"
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }

        $data =array(
            "control_center_name"=>$request->control_center_name,
            "control_center_code"=>$request->control_center_code,
            "status"=>$request->status,
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($zid!="")
        {
            $row_status=  MasterControlCenter::where('id', '!=' , $zid)->where("control_center_name", $request->control_center_name)->first();// check for the unique controlCenter name
        }
        else
        $row_status=  MasterControlCenter::where("control_center_name", $request->control_center_name)->first();// check for the unique controlCenter name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "control center name is already exists!"]);
        }
        if($zid!="")
        {
            $create  = MasterControlCenter::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = MasterControlCenter::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('controlCenterMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
            }
            else
            return redirect()->intended('controlCenterMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
        }
    }
    public function controlCenterMasterDelete($zid)
    {
        $delete  = MasterControlCenter::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('controlCenterMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
        }
    }
       /*--------FUNCTION MASTER--------------*/
    public function functionMaster(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $function  = MasterFunction::all();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $functionDetail  = MasterFunction::where("id",$zid)->first()->toArray();
                    return view('masters.function',['function'=>$function,'functionDetail'=>$functionDetail]);
                }
                else 
                {
                    return view('masters.function',['function'=>$function]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function functionMasterPost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "function_name"=>"required",
             "function_code"=>"required"
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }

        $data =array(
            "function_name"=>$request->function_name,
            "function_code"=>$request->function_code,
            "status"=>$request->status,
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($zid!="")
        {
            $row_status=  MasterFunction::where('id', '!=' , $zid)->where("function_name", $request->function_name)->first();// check for the unique function name
        }
        else
        $row_status=  MasterFunction::where("function_name", $request->function_name)->first();// check for the unique function name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "control center name is already exists!"]);
        }
        if($zid!="")
        {
            $create  = MasterFunction::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = MasterFunction::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('functionMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
            }
            else
            return redirect()->intended('functionMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
        }
    }
    public function functionMasterDelete($zid)
    {
        $delete  = MasterFunction::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('functionMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
        }
    }
       /*--------SHIFT MASTER--------------*/
    public function shiftMaster(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $shift  = MasterShift::all();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $shiftDetail  = MasterShift::where("id",$zid)->first()->toArray();
                    return view('masters.shift',['shift'=>$shift,'shiftDetail'=>$shiftDetail]);
                }
                else 
                {
                    return view('masters.shift',['shift'=>$shift]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function shiftMasterPost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "shift_name"=>"required",
             "shift_code"=>"required",
              "start_time"=>"required",
               "end_time"=>"required"
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }

        $data =array(
            "shift_name"=>$request->shift_name,
            "shift_code"=>$request->shift_code,
            "start_time"=>$request->start_time,
            "end_time"=>$request->end_time,
            "status"=>$request->status,
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($zid!="")
        {
            $row_status=  MasterShift::where('id', '!=' , $zid)->where("shift_name", $request->shift_name)->first();// check for the unique shift name
        }
        else
        $row_status=  MasterShift::where("shift_name", $request->shift_name)->first();// check for the unique shift name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "control center name is already exists!"]);
        }
        if($zid!="")
        {
            $create  = MasterShift::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = MasterShift::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('shiftMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
            }
            else
            return redirect()->intended('shiftMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
        }
    }
    public function shiftMasterDelete($zid)
    {
        $delete  = MasterShift::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('shiftMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
        }
    }
    /*--------GA MASTER--------------*/
    public function gaMaster(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $ga  = MasterGA::all();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $gaDetail  = MasterGA::where("id",$zid)->first()->toArray();
                    return view('masters.ga',['ga'=>$ga,'gaDetail'=>$gaDetail]);
                }
                else 
                {
                    return view('masters.ga',['ga'=>$ga]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function gaMasterPost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "ga_name"=>"required",
             "ga_code"=>"required",
             "ga_id"=>"required"
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }

        $data =array(
            "ga_name"=>$request->ga_name,
            "ga_code"=>$request->ga_code,
             "ga_id"=>$request->ga_id,
            "status"=>$request->status,
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($zid!="")
        {
            $row_status=  MasterGA::where('id', '!=' , $zid)->where("ga_name", $request->ga_name)->first();// check for the unique ga name
        }
        else
        $row_status=  MasterGA::where("ga_name", $request->ga_name)->first();// check for the unique ga name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "control center name is already exists!"]);
        }
        if($zid!="")
        {
            $create  = MasterGA::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = MasterGA::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('gaMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
            }
            else
            return redirect()->intended('gaMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
        }
    }
    public function gaMasterDelete($zid)
    {
        $delete  = MasterGA::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('gaMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
        }
    }
    /*--------District MASTER--------------*/
    public function districtMaster(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $district  = MasterDistrict::all();
                 $ga=dd_masters("ga","ga_code");
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $districtDetail  = MasterDistrict::where("id",$zid)->first()->toArray();
                    return view('masters.district',['district'=>$district,'districtDetail'=>$districtDetail,'ga'=>$ga]);
                }
                else 
                {
                    return view('masters.district',['district'=>$district,'ga'=>$ga]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function districtMasterPost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "address_district"=>"required",
             "pngrb_district"=>"required",
             "ga_code"=>"required"
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }

        $data =array(
            "address_district"=>$request->address_district,
            "pngrb_district"=>$request->pngrb_district,
             "ga_code"=>$request->ga_code,
            "status"=>$request->status,
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($zid!="")
        {
            $row_status=  MasterDistrict::where('id', '!=' , $zid)->where("address_district", $request->address_district)->first();// check for the unique district name
        }
        else
        $row_status=  MasterDistrict::where("address_district", $request->address_district)->first();// check for the unique district name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Address district name is already exists!"]);
        }
        if($zid!="")
        {
            $create  = MasterDistrict::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = MasterDistrict::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('districtMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
            }
            else
            return redirect()->intended('districtMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
        }
    }
    public function districtMasterDelete($zid)
    {
        $delete  = MasterDistrict::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('districtMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
        }
    }
    /*get District from GA*/
    public function getDistrict(Request $request)
    {
        $alldata=$request->all();
        $district=array();
        if($alldata['ga_code']!="")
        {
            $district=MasterDistrict::where("ga_code",$alldata['ga_code'])->pluck("address_district","address_district");
        }
        if($alldata['device']=="web")
        {
            echo json_encode($district);
        }
        else
        return response()->json(["status" => 200, "msg" => "Data fetched!","code" => config("constants.CODE_SUCCESS"),"data"=>$district]);
    }
    
    /*--------ShiftChecklist MASTER--------------*/
    public function shiftChecklistMaster(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $shiftChecklist  = MasterShiftChecklist::all();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $shiftChecklistDetail  = MasterShiftChecklist::where("id",$zid)->first()->toArray();
                    return view('masters.shiftChecklist',['shiftChecklist'=>$shiftChecklist,'shiftChecklistDetail'=>$shiftChecklistDetail]);
                }
                else 
                {
                    return view('masters.shiftChecklist',['shiftChecklist'=>$shiftChecklist]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function shiftChecklistMasterPost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "shiftChecklist_name"=>"required",
            
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }

        $data =array(
            "shiftChecklist_name"=>$request->shiftChecklist_name,
           
            "status"=>$request->status,
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($zid!="")
        {
            $row_status=  MasterShiftChecklist::where('id', '!=' , $zid)->where("shiftChecklist_name", $request->shiftChecklist_name)->first();// check for the unique shiftChecklist name
        }
        else
        $row_status=  MasterShiftChecklist::where("shiftChecklist_name", $request->shiftChecklist_name)->first();// check for the unique shiftChecklist name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "control center name is already exists!"]);
        }
        if($zid!="")
        {
            $create  = MasterShiftChecklist::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = MasterShiftChecklist::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('shiftChecklistMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
            }
            else
            return redirect()->intended('shiftChecklistMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
        }
    }
    public function shiftChecklistMasterDelete($zid)
    {
        $delete  = MasterShiftChecklist::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('shiftChecklistMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
        }
    }

    //Equipment Master
    public function equipmentMaster(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $equipmentMaster  = MasterEquipment::all();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $equipmentMasterDetail  = MasterEquipment::where("id",$zid)->first()->toArray();
                    return view('masters.equipment',['equipmentMaster'=>$equipmentMaster,'equipmentMasterDetail'=>$equipmentMasterDetail]);
                }
                else 
                {
                    return view('masters.equipment',['equipmentMaster'=>$equipmentMaster]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function equipmentMasterPost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "equipment_name"=>"required",
            
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }

        $data =array(
            "equipment_name"=>$request->equipment_name,
           
            "status"=>$request->status,
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($zid!="")
        {
            $row_status=  MasterEquipment::where('id', '!=' , $zid)->where("equipment_name", $request->equipment_name)->first();// check for the unique shiftChecklist name
        }
        else
        $row_status=  MasterEquipment::where("equipment_name", $request->equipment_name)->first();// check for the unique shiftChecklist name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Equipment center already exsist!"]);
        }
        if($zid!="")
        {
            $create  = MasterEquipment::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = MasterEquipment::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('equipmentMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
            }
            else
            return redirect()->intended('equipmentMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
        }
    }
    public function equipmentMasterDelete($zid)
    {
        $delete  = MasterEquipment::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('equipmentMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
        }
    }
    //Equipment Master

    //Station Master
    public function stationMaster(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $stations  = MasterStations::all();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $stationDetail  = MasterStations::where("id",$zid)->first()->toArray();
                    return view('masters.station',['stationMaster'=>$stations,'stationMasterDetail'=>$stationDetail]);
                }
                else 
                {
                    return view('masters.station',['stationMaster'=>$stations]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function stationMasterPost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "station_name"=>"required",
            
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }

        $data =array(
            "station_name"=>$request->station_name,
           
            "status"=>$request->status,
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($zid!="")
        {
            $row_status=  MasterStations::where('id', '!=' , $zid)->where("station_name", $request->equipment_name)->first();// check for the unique shiftChecklist name
        }
        else
        $row_status=  MasterStations::where("station_name", $request->station_name)->first();// check for the unique shiftChecklist name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Station name already exsist!"]);
        }
        if($zid!="")
        {
            $create  = MasterStations::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = MasterStations::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('stationMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
            }
            else
            return redirect()->intended('stationMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
        }
    }
    public function stationMasterDelete($zid)
    {
        $delete  = MasterStations::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('stationMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
        }
    }
    //Station Master



//Source Master
    public function masterSource(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $sources  = MasterSources::all();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $sourceDetail  = MasterSources::where("id",$zid)->first()->toArray();
                    return view('masters.source',['sourceMaster'=>$sources,'sourceMasterDetail'=>$sourceDetail]);
                }
                else 
                {
                    return view('masters.source',['sourceMaster'=>$sources]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function masterSourcePost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "source_name"=>"required",
            
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }

        $data =array(
            "source_name"=>$request->source_name,
            "source_code"=>$request->source_code,
            "status"=>$request->status,
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($zid!="")
        {
            $row_status=  MasterSources::where('id', '!=' , $zid)->where("source_name", $request->source_name)->first();// check for the unique shiftChecklist name
        }
        else
        $row_status=  MasterSources::where("source_name", $request->source_name)->first();// check for the unique shiftChecklist name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Source name already exsist!"]);
        }
        if($zid!="")
        {
            $create  = MasterSources::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = MasterSources::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('masterSource')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
            }
            else
            return redirect()->intended('masterSource')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
        }
    }
    public function masterSourceDelete($zid)
    {
        $delete  = MasterSources::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('masterSource')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
        }
    }
    //Source Master

    //Network Master
    public function masterNetwork(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $networks  = MasterNetworks::all();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $networkDetail  = MasterNetworks::where("id",$zid)->first()->toArray();
                    return view('masters.network',['networkMaster'=>$networks,'networkMasterDetail'=>$networkDetail]);
                }
                else 
                {
                    return view('masters.network',['networkMaster'=>$networks]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function masterNetworkPost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $validator=  Validator::make($request->all(), [
            "network"=>"required",
            
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }

        $data =array(
            "network"=>$request->network,
            "nominal_wall_thickness"=>$request->nominal_wall_thickness,
            "category"=>$request->category,
            "status"=>$request->status,
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($zid!="")
        {
            $row_status=  MasterNetworks::where('id', '!=' , $zid)->where("network", $request->network)->first();// check for the unique shiftChecklist name
        }
        else
        $row_status=  MasterNetworks::where("network", $request->network)->first();// check for the unique shiftChecklist name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Source name already exsist!"]);
        }
        if($zid!="")
        {
            $create  = MasterNetworks::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = MasterNetworks::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('masterNetwork')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
            }
            else
            return redirect()->intended('masterNetwork')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
        }
    }
    public function masterNetworkDelete($zid)
    {
        $delete  = MasterNetworks::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('masterNetwork')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
        }
    }
    //Network Master
    
           /*--------Tankerno MASTER--------------*/
       public function tankernoMaster(Request $request)
       {
            $user=auth()->user();
           if(Auth::check()){
               $display="ok";
               if($display=="ok")
               {
                   $tankerno  = MasterTankerno::all();
                   if(isset($request->zid))
                   {
                       $zid=$request->zid;
                       $tankernoDetail  = MasterTankerno::where("id",$zid)->first()->toArray();
                       return view('masters.tankerno',['tankerno'=>$tankerno,'tankernoDetail'=>$tankernoDetail]);
                   }
                   else 
                   {
                       return view('masters.tankerno',['tankerno'=>$tankerno]);
                   }
               }
               else
               {
                    dd($display) ;
               } 
           }
           else
           {
                return redirect("/")->withSuccess('Opps! You do not have access');
           }
       } 
       public function tankernoMasterPost(Request $request)
       {
           if(isset($request->zid))
           {
               $zid=$request->zid;
           }
           else $zid="";
           
           $validator=  Validator::make($request->all(), [
               "tankerno_name"=>"required",
                "tankerno_code"=>"required",
                
           ]
           );
   
           if($validator->fails()) {
               return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
           }
   
           $data =array(
               "tankerno_name"=>$request->tankerno_name,
               "tankerno_code"=>$request->tankerno_code,
               "status"=>$request->status,
               "updated_at"=>date("Y-m-d H:i:s")
           );
           if($zid!="")
           {
               $row_status=  MasterTankerno::where('id', '!=' , $zid)->where("tankerno_name", $request->tankerno_name)->first();// check for the unique tankerno name
           }
           else
           $row_status=  MasterTankerno::where("tankerno_name", $request->tankerno_name)->first();// check for the unique tankerno name
   
           if(!is_null($row_status)) {
               return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "control center name is already exists!"]);
           }
           if($zid!="")
           {
               $create  = MasterTankerno::where("id", $zid)->update($data); // add new row in user table
           }
           else
           {
               $data['created_at']=date("Y-m-d H:i:s");
           $create  = MasterTankerno::insert($data); // add new row in user table
           }
   
           if(!is_null($create)) {
               if($zid!="")
               {
                   return redirect()->intended('tankernoMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
               }
               else
               return redirect()->intended('tankernoMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
           }
   
           else {
               return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
           }
       }
       public function tankernoMasterDelete($zid)
       {
           $delete  = MasterTankerno::find($zid)->delete();// delete row in user table
           if($delete)
           {
                return redirect()->intended('tankernoMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
           }
           else
           {
               return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
           }
       }
 /*--------Gastype MASTER--------------*/
 public function gastypeMaster(Request $request)
 {
      $user=auth()->user();
     if(Auth::check()){
         $display="ok";
         if($display=="ok")
         {
             $gastype  = MasterGastype::all();
             if(isset($request->zid))
             {
                 $zid=$request->zid;
                 $gastypeDetail  = MasterGastype::where("id",$zid)->first()->toArray();
                 return view('masters.gastype',['gastype'=>$gastype,'gastypeDetail'=>$gastypeDetail]);
             }
             else 
             {
                 return view('masters.gastype',['gastype'=>$gastype]);
             }
         }
         else
         {
              dd($display) ;
         } 
     }
     else
     {
          return redirect("/")->withSuccess('Opps! You do not have access');
     }
 } 
 public function gastypeMasterPost(Request $request)
 {
     if(isset($request->zid))
     {
         $zid=$request->zid;
     }
     else $zid="";
     
     $validator=  Validator::make($request->all(), [
         "gastype_name"=>"required",
          "gastype_code"=>"required",
          
     ]
     );

     if($validator->fails()) {
         return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
     }

     $data =array(
         "gastype_name"=>$request->gastype_name,
         "gastype_code"=>$request->gastype_code,
         "status"=>$request->status,
         "updated_at"=>date("Y-m-d H:i:s")
     );
     if($zid!="")
     {
         $row_status=  MasterGastype::where('id', '!=' , $zid)->where("gastype_name", $request->gastype_name)->first();// check for the unique gastype name
     }
     else
     $row_status=  MasterGastype::where("gastype_name", $request->gastype_name)->first();// check for the unique gastype name

     if(!is_null($row_status)) {
         return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "control center name is already exists!"]);
     }
     if($zid!="")
     {
         $create  = MasterGastype::where("id", $zid)->update($data); // add new row in user table
     }
     else
     {
         $data['created_at']=date("Y-m-d H:i:s");
     $create  = MasterGastype::insert($data); // add new row in user table
     }

     if(!is_null($create)) {
         if($zid!="")
         {
             return redirect()->intended('gastypeMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data updated successfully!"]);
         }
         else
         return redirect()->intended('gastypeMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data created successfully!"]);
     }

     else {
         return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data creation failed!"]);
     }
 }
 public function gastypeMasterDelete($zid)
 {
     $delete  = MasterGastype::find($zid)->delete();// delete row in user table
     if($delete)
     {
          return redirect()->intended('gastypeMaster')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "Master data deleted successfully!"]);
     }
     else
     {
         return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Master data deletion failed!"]);
     }
 }
}
