<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Survey;

class SurveyController extends Controller
{

    public function index() {
   /*   try {
         $dbname = DB::connection()->getDatabaseName();
         echo "Connected successfully to the database. Database name is :".$dbname;
      } catch(Exception $e) {
         echo "Error in connecting to the database";
      } */
        return view('index');
    }
    
    public function store(Request $request)
    {
        
        $this->validate(request(), [
            'surveyor_name' => 'required',
            'customer_name' => 'required',
            'application_no' => 'required',
            'customer_mobile' => 'required',
            'customer_email' => 'required|email',
            'rent_paid' => 'required',
            'address' => 'required',
            'connection_status' => 'required',
            'meter_no' => 'required',
            'meter_reading' => 'required',
            'meter_photo' => 'required',
            'geyser_conn' => 'required',
            'tube_status' => 'required',
        ]);
        

        //add timestamp to file names
        $meterFileName = 'meter_'.time().'.'.$request->meter_photo->extension();  
        $siteFileName = 'site_'.time().'.'.$request->site_photo->extension();  
       
        $request->meter_photo->move(public_path('uploads'), $meterFileName);
        
        $request->site_photo->move(public_path('uploads'), $siteFileName);
        
        $request->meter_photo='uploads/'.$meterFileName;
        $request->site_photo='uploads/'.$siteFileName;
        
        $survey_data=[
            'surveyor_name' => "$request->surveyor_name",
            'customer_name' => "$request->customer_name",
            'application_no' => $request->application_no,
            'customer_mobile' => $request->customer_mobile,
            'customer_email' => "$request->customer_email",
            'rent_paid' => $request->rent_paid,
            'address' => "$request->address",
            'connection_status' => "$request->connection_status",
            'meter_no' => $request->meter_no,
            'meter_reading' => $request->meter_reading,
            'meter_photo' => "$request->meter_photo",
            'geyser_conn' => $request->geyser_conn,
            'tube_status' => "$request->tube_status",
            'site_photo' => "$request->site_photo",
        ];
        
       try {
        Survey::insert([$survey_data]);
       } catch(Exception $e) {

       }        
        return redirect()->to('/');
    }
}
