<?php
namespace App\Http\Controllers\WhatsApp;
use App\Models\User;
use App\Models\UserRoles;
use App\Http\Controllers\Controller;
use App\Models\MasterGA;
use App\Models\MasterDistrict;
use App\Models\WhatsAppTemplates;
use App\Models\WhatsAppTemplatesImages;
use App\Models\WhatsAppSendMessage;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Exception;
use Log;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Schema;
use Storage;
use DB;
use Session;
  
class WhatsAppController extends Controller
{

   /*--------WhatsApp Template--------------*/
    public function whatsAppTemplate(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $whatsAppTemplate  = WhatsAppTemplates::all();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $whatsAppTemplateDetail  = WhatsAppTemplates::where("id",$zid)->first()->toArray();
                    return view('whatsapp.whatsAppTemplate',['whatsAppTemplate'=>$whatsAppTemplate,'whatsAppTemplateDetail'=>$whatsAppTemplateDetail]);
                }
                else 
                {
                    return view('whatsapp.whatsAppTemplate',['whatsAppTemplate'=>$whatsAppTemplate]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function whatsAppTemplatePost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $uid=Auth::user()->userId;
        $validator=  Validator::make($request->all(), [
            "display_name"=>"required",
            "template_name"=>"required",
             "template_api"=>"required"
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }

        $data =array(
            "created_by"=>$uid,
            "display_name"=>$request->display_name,
            "template_name"=>$request->template_name,
            "template_api"=>$request->template_api,
            "status"=>$request->status,
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($zid!="")
        {
            $row_status=  WhatsAppTemplates::where('id', '!=' , $zid)->where("template_name", $request->template_name)->first();// check for the unique whatsAppTemplate name
        }
        else
        $row_status=  WhatsAppTemplates::where("template_name", $request->template_name)->first();// check for the unique whatsAppTemplate name

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "WhatsApp template is already exists!"]);
        }
        if($zid!="")
        {
            $create  = WhatsAppTemplates::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = WhatsAppTemplates::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('whatsAppTemplate')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "WhatsApp Template updated successfully!"]);
            }
            else
            return redirect()->intended('whatsAppTemplate')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "WhatsApp Template created successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "WhatsApp Template creation failed!"]);
        }
    }
    public function whatsAppTemplateDelete($zid)
    {
        $delete  = WhatsAppTemplates::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('whatsAppTemplate')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "WhatsApp Template deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "WhatsApp Template deletion failed!"]);
        }
    }
     /*--------WhatsApp Template Image Upload--------------*/
    public function whatsAppUploadImage(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $myga=Auth::user()->ga;
                $ga=dd_masters("ga","ga_code");
                $district=dd_masters("district","address_district");
                $whatsAppTemplate  = whatsAppTemplates::where("status","Active")->pluck("display_name","id");
                $whatsAppTemplateImage  = whatsAppTemplatesImages::where("ga_code",$myga)->get()->toArray();
                if(isset($request->zid))
                {
                    $zid=$request->zid;
                    $whatsAppTemplateImageDetail  = whatsAppTemplatesImages::where("id",$zid)->first()->toArray();
                    return view('whatsapp.whatsAppTemplateImage',['ga'=>$ga,'district'=>$district,'whatsAppTemplate'=>$whatsAppTemplate,'whatsAppTemplateImage'=>$whatsAppTemplateImage,'whatsAppTemplateImageDetail'=>$whatsAppTemplateImageDetail]);
                }
                else 
                {
                    return view('whatsapp.whatsAppTemplateImage',['ga'=>$ga,'district'=>$district,'whatsAppTemplate'=>$whatsAppTemplate,'whatsAppTemplateImage'=>$whatsAppTemplateImage]);
                }
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function whatsAppUploadImagePost(Request $request)
    {
        if(isset($request->zid))
        {
            $zid=$request->zid;
        }
        else $zid="";
        
        $uid=Auth::user()->userId;
        $validator=  Validator::make($request->all(), [
            "template_id"=>"required",
             "template_image"=>"required"
        ]
        );

        if($validator->fails()) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => $validator->errors()]);
        }
        
        $data =array(
            "created_by"=>$uid,
            "ga_code"=>$request->ga_code,
            "district_code"=>$request->district_code,
            "template_id"=>$request->template_id,
            "template_image"=>$request->template_image,
            "status"=>"Pending",
            "updated_at"=>date("Y-m-d H:i:s")
        );
        if($request->hasfile('template_image'))
        {
            $data['template_image']=uploadImage("whatsapp/template_image",$request->template_image,"template_image".$data['template_id']);
        }
        /*if($zid!="")
        {
            $row_status=  whatsAppTemplatesImages::where('id', '!=' , $zid)->where("ga_code",$request->ga_code)->where("district_code",$request->district_code)->where("template_id", $request->template_id)->first();
        }
        else
        $row_status=  whatsAppTemplatesImages::where("template_id", $request->template_id)->where("ga_code",$request->ga_code)->where("district_code",$request->district_code)->first();

        if(!is_null($row_status)) {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "WhatsApp template is already exists!"]);
        }*/
        if($zid!="")
        {
            $create  = whatsAppTemplatesImages::where("id", $zid)->update($data); // add new row in user table
        }
        else
        {
            $data['created_at']=date("Y-m-d H:i:s");
        $create  = whatsAppTemplatesImages::insert($data); // add new row in user table
        }

        if(!is_null($create)) {
            if($zid!="")
            {
                return redirect()->intended('whatsAppUploadImage')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "WhatsApp Template image uploaded successfully!"]);
            }
            else
            return redirect()->intended('whatsAppUploadImage')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "WhatsApp Template Image uploaded successfully!"]);
        }

        else {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "WhatsApp Template creation failed!"]);
        }
    }
    public function whatsAppUploadImageDelete($zid)
    {
        $delete  = whatsAppTemplatesImages::find($zid)->delete();// delete row in user table
        if($delete)
        {
             return redirect()->intended('whatsAppUploadImage')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "WhatsApp Template deleted successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "WhatsApp Template deletion failed!"]);
        }
    }
    
    public function whatsAppImageApproval(Request $request)
    {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $whatsAppTemplateImage  = whatsAppTemplatesImages::all();
                return view('whatsapp.whatsAppImageApproval',['whatsAppTemplateImage'=>$whatsAppTemplateImage]);
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function whatsAppImageAction(Request $request)
    {
        $alldata=$request->all();
        if($alldata['val']=="Update")
        {
            $delete  = whatsAppTemplatesImages::where("id",$alldata['zid'])->update(array("max_limit"=>$alldata['max_limit']));
        }
        else
        {
             if($alldata['val']=="Approved")
             {
                $delete  = whatsAppTemplatesImages::where("status","Approved")->where("template_id",$alldata['tem_id'])->where("ga_code",$alldata['ga'])->where("district_code",$alldata['district'])->update(array("status"=>"Old"));
             }
             
            $delete  = whatsAppTemplatesImages::where("id",$alldata['zid'])->update(array("status"=>$alldata['val']));
        }
        
        if($delete)
        {
             return redirect()->intended('whatsAppImageApproval')->with(["status" => config("constants.OK"),"code" => 1, "success" => true, "msg" => "WhatsApp Image ".$alldata['val']." successfully!"]);
        }
        else
        {
            return back()->with(["status" => config("constants.OK"),"code" => 0, "success" => false, "msg" => "Sorry try again!!"]);
        }
    }
    /*--------WhatsApp Message Sending--------------*/
    public function sendWhatsAppMessage(Request $request)
   {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $ga=dd_masters("ga","ga_code");
                $district=dd_masters("district","address_district");
                $whatsAppTemplate  = whatsAppTemplates::where("status","Active")->pluck("display_name","id");
                return view('whatsapp.whatsAppSendMessage',['ga'=>$ga,'district'=>$district,'whatsAppTemplate'=>$whatsAppTemplate]);
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function getWhatsAppTemplateDetails(Request $request)
    {
        $uid=Auth::user()->userId;
        $alldata=$request->all();
        $whatsAppTemplateDetail=DB::table('whatsapp_template')
            ->leftJoin('whatsapp_template_image', 'whatsapp_template.id', '=', 'whatsapp_template_image.template_id')
            ->where("whatsapp_template.id",$alldata['template_id']) ->where("whatsapp_template_image.ga_code",$alldata['ga_code']) ->where("whatsapp_template_image.district_code",$alldata['district_code'])->where("whatsapp_template_image.status","Approved")->get()->toArray();
             //print_r($whatsAppTemplateDetail);exit;
            $whatsAppTemplateDetail[0]->send_limit=WhatsAppSendMessage::where("template_id",$whatsAppTemplateDetail[0]->template_id)->where("template_image_id",$whatsAppTemplateDetail[0]->id)->count();
          // print_r($whatsAppTemplateDetail);exit;
        return $whatsAppTemplateDetail;
    }
     public function sendWhatsAppMessagePost(Request $request)
    {
        $alldata=$request->all();
        $uid=Auth::user()->userId;
        //print_r($alldata);exit;
        $requiredHeaders = array('phone_number');
        $path = $request->file('file')->getRealPath();
        $records = array_map('str_getcsv', file($path));
        if (! count($records) > 0) {
            return back()->with(["status" =>200,"code" => 1, "success" => false, "msg" => "No Records Found!"]);
        }
       $fields =$records[0];
        if ($fields !== $requiredHeaders) {
             return back()->with(["status" =>200,"code" => 0, "success" => false, "msg" => "Please upload data in correct format!"]);
             exit;
         }
        array_shift($records);
        foreach ($records as $record) {
            if (count($fields) != count($record)) {
                return back()->with(["status" => 200,"code" => 1, "success" => false, "msg" => "Invalid data!"]);
            }
            $record =  array_map("html_entity_decode", $record);
            $record = array_combine($fields, $record);
            $this->rows[] = $record;
        }
        $i=WhatsAppSendMessage::where("template_id",$alldata['template_id'])->where("template_image_id",$alldata['template_image_id'])->count();
       
        foreach ($this->rows as $data) {
            $i++;
            if($i<=$alldata['max_limit'])
            {
                $dtt['template_name']=$alldata['template_name'];
                $dtt['template_api']=$alldata['template_api'];
                $dtt['image_link']=url($alldata['template_image']);
                $dtt['phone_number']=$data['phone_number'];
               // print_r($dtt);exit;
                $sendImage=sendWhatsappMessage($dtt);
                $dt['user_id']=$uid;
                $dt['message']=$sendImage;
                $dt['created_at']=date("Y-m:d H:i:s");
                $dt['updated_at']=date("Y-m:d H:i:s");
                $dt['template_id']=$alldata['template_id'];
                $dt['template_image_id']=$alldata['template_image_id'];
                $dt['status']="Sent";
                //print_r($dt);exit;
                $create=WhatsAppSendMessage::insert($dt);
            }
            else{
                return back()->with(["status" => 200,"code" => 0, "success" => false, "msg" => "Max Limit Crossed!!"]);
            }
            
        }
        if($sendImage)
        return back()->with(["status" => 200,"code" => 1, "success" => true, "msg" => " whatsapp message sent successfully!"]);
        else
        return back()->with(["status" => 200,"code" => 0, "success" => false, "msg" => "Failed!"]);
        
    }
    public function whatsAppReport(Request $request)
   {
         $user=auth()->user();
        if(Auth::check()){
            $display="ok";
            if($display=="ok")
            {
                $ga=dd_masters("ga","ga_code");
                $district=dd_masters("district","address_district");
                $whatsAppTemplate  = whatsAppTemplates::where("status","Active")->pluck("display_name","id");
                return view('whatsapp.whatsAppReport',['ga'=>$ga,'district'=>$district,'whatsAppTemplate'=>$whatsAppTemplate]);
            }
            else
            {
                 dd($display) ;
            } 
        }
        else
        {
             return redirect("/")->withSuccess('Opps! You do not have access');
        }
    } 
    public function getWhatsAppReport(Request $request)
    {
        $alldata=$request->all();
        $form=$request->input('formdata');
        $params = array();
        if(isset($request->device))
        {
            $device=$request->device;
        }
        else
        {
            $device="";
        } 
        $uid=$alldata['userId'];
        $desig=User::where("userId",$uid)->value("role");
        $ga=User::where("userId",$uid)->value("ga");
        parse_str($form, $params);
        $query = whatsAppTemplatesImages::query();
        if($desig=="Super Admin" || $desig=="Admin")
        {
            $query = $query;
        }
        else
        {
            $query=$query->where("ga_code",$ga);
        }
        if(!empty($params))
        {
            foreach($params as $kk=>$vall)
            {
                if($vall!="")
                {
                    if($kk=='created_at')
                    $query=$query->where($kk,"LIKE","%".$vall."%");
                    else
                    $query=$query->where($kk,$vall);
                    
                }
            }
        }
         $columns = ['id','ga_code', 'district_code', 'template_id', 'template_image_id','template_image'];
            $totalData = whatsAppTemplatesImages::count();
            $totalFiltered = $totalData;
            $limit = $request->input('length');
            $start = $request->input('start');
            $order = $columns[$request->input('order.0.column')];
            $dir = $request->input('order.0.dir');
            $totalFiltered= $query->count();
            if ($limit== -1){
                    $posts = $query->orderBy($order,$dir)
                    ->get();   
                }
                else{
                   $posts = $query->offset($start)
                            ->limit($limit)
                            ->orderBy($order,$dir)
                            ->get()->toArray(); 
                }
        $data = array();
        if (!empty($posts)) {
           $i=0;
                foreach ($posts as $post) {
                    $i++;
                    $send_limit=WhatsAppSendMessage::where("template_id",$post['template_id'])->where("template_image_id",$post['id'])->count();
                    $nestedData['slNo'] = $i;
                    $nestedData['ga_code'] = $post['ga_code'];
                    $nestedData['district_code'] =  $post['district_code'];
                    $nestedData['template_name'] = anyFiled("WhatsAppTemplates","display_name",$post['template_id']);
                    $nestedData['template_image']=' <img width="50" height="50" src="/uploads/whatsapp/template_image/'.$post['template_image'].'">';
                    $nestedData['max_limit'] = $post['max_limit'];
                    $nestedData['send_limit'] = $send_limit;
                    $nestedData['options'] = '<a href="" data-bs-toggle="modal" data-bs-target=".bs-example-modal-lg" id="openModal_'.$post['template_id']."_".$post['id'].'"><i class="ti-eye"></i></a>';
                    $data[]=$nestedData;
                }
        }
        $json_data = array(
                "draw" => intval($request->input('draw')),
                "recordsTotal" => intval($totalData),
                "recordsFiltered" => intval($totalFiltered),
                "data" => $data,);
                echo json_encode($json_data);
        


    }
    public function getWhatsAppReportDetails(Request $request)
    {
        $alldata=$request->all();
        $form=$request->input('formdata');
        $params = array();
        if(isset($request->device))
        {
            $device=$request->device;
        }
        else
        {
            $device="";
        } 
        $uid=$alldata['userId'];
        $desig=User::where("userId",$uid)->value("role");
        $ga=User::where("userId",$uid)->value("ga");
        parse_str($form, $params);
        $query = WhatsAppSendMessage::query();
        $query=$query->where("template_id",$alldata['template_id'])->where("template_image_id",$alldata['template_image_id']);
        
         $columns = ['id','ga_code', 'district_code', 'template_id', 'template_image_id'];
            $totalData = WhatsAppSendMessage::where("template_id",$alldata['template_id'])->where("template_image_id",$alldata['template_image_id'])->count();
            $totalFiltered = $totalData;
            $limit = $request->input('length');
            $start = $request->input('start');
            $order = $columns[$request->input('order.0.column')];
            $dir = $request->input('order.0.dir');
            $totalFiltered= $query->count();
            if ($limit== -1){
                    $posts = $query->orderBy($order,$dir)
                    ->get();   
                }
                else{
                   $posts = $query->offset($start)
                            ->limit($limit)
                            ->orderBy($order,$dir)
                            ->get()->toArray(); 
                }
        $data = array();
        if (!empty($posts)) {
            $pos=whatsAppTemplatesImages::where("id",$alldata['template_image_id'])->get()->toArray();
            $pp=$pos[0];
           $i=0;
                foreach ($posts as $k=>$post) {
                    
                    $i++;
                     $pho=json_decode($post['message'],true);
                    $nestedData['slNo'] = $i;
                    $nestedData['ga_code'] = $pp['ga_code'];
                    $nestedData['district_code'] =  $pp['district_code'];
                    $nestedData['template_name'] = anyFiled("WhatsAppTemplates","display_name",$pp['template_id']);
                    $nestedData['phone'] = $pho['contacts'][0]['input'];
                    $nestedData['created_at'] = $post['created_at'];
                     $nestedData['user_id'] = $post['user_id'];
                    $data[]=$nestedData;
                }
        }
        $json_data = array(
                "draw" => intval($request->input('draw')),
                "recordsTotal" => intval($totalData),
                "recordsFiltered" => intval($totalFiltered),
                "data" => $data,);
                echo json_encode($json_data);
        


    }
}
