@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">CNG/CBG Purchase Input</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">CNG/CBG Purchase Input Sheet</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
           
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
             $myga=anyFiled("User","ga",Auth::user()->id);
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 mt-2 text-white pull-left" id="gaDistrictInputname">CNG/CBG Purchase Input Sheet</h4>
                </div>
                <form id="form-filter" class="form-horizontal" action="{{ route('cngPurchaseInput.post') }}" method="POST">
                     {{ csrf_field() }}
                    <input type="hidden" name="device" value="web">
                    <input type="hidden" name="user_id" value="{{Auth::user()->userId}}">
                      @if(!empty($input_details))
                       <div class="card-body">
                        @php
                        $sources=dd_masters("source","source_code");
                        $source='<select name="Source" id="Source"  class="cng " data-placeholder="Choose a Sources"><option>Please Select Source</option>';
                        foreach($sources as $k=>$v)
                        {
                        $source.='<option value="'.$k.'">'.$v.' ('.$k.')</option>';
                        }
                        $source.='</select>';
                        @endphp
                        <table id="customers" class="table table-bordered table-striped">
                            <thead>
                                <tr> 
                                    <th>MCV Loading Date</th>
                                    <th>Source</th>
                                    <th>Invoice qty in kg</th>
                                    <th>Dispatch qty in (M3) at 15deg Temp as per Joint ticket</th>
                                    <th>CF</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
        <td><input type="date" class="cng" name="MCV_Loading_Date"></td>
        <td>{{$source}}</td>
            <td><input type="number" step="0.01" class="cng" name="Invoice_qty_in_kg" id="qty_c"></td>
        <td><input type="number" step="0.01" class="cng" name="Dispatch_qty_in_M3_at_15deg_Temp_as_per_Joint_ticket" id="qty_d"></td>
        <td><input type="number" step="0.001" class="cng" name="CF" id="CF"></td>
         <td><button type="submit" class="button-info" id="submit" value="Submit">Submit</button></td>
        </tr>
                            </tbody>
                        </table>     
                    </div>
                      @else
                    <div class="card-body">
                        
                        <table id="customers" class="table table-bordered table-striped">
                            <thead>
                                <tr> 
                                    <th>MCV Loading Date</th>
                                    <th>Source</th>
                                    <th>Invoice qty in kg</th>
                                    <th>Dispatch qty in (M3) at 15deg Temp as per Joint ticket</th>
                                    <th>CF</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody id="new_data">
                            </tbody>
                        </table>     
                    </div>
                    @endif
                </form>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>
$(document).ready(function()
{
      
    load_it();
})
function load_it()
{
     $.ajax({
            url: "{{url('api/getCngPurchaseInputs')}}",
            type: "POST",
            data: {
              "device":"web",
                _token: '{{csrf_token()}}'
            },
            dataType: 'json',
            success: function (result) {
                console.log(result);
                $("#customers").dataTable().fnDestroy();
                $("#new_data").html(result);
                var table =  new DataTable('#customers', {  
                    dom: 'rti',
                    order:[0,"asc"],
                    scrollX:true,
                    scrollCollapse: true,
                    scrollY: '65vh',
                    autoWidth: true,
                 });
                }
    });
}

$(document).on("keyup","[id^='qty_']",function()
{
    var qty_c=$("#qty_c").val();
    var qty_d=$("#qty_d").val();
    if(qty_c=="" || qty_d=="" || qty_c==0 || qty_d==0)var v=0;
    else
    var v=parseFloat(qty_d)/parseFloat(qty_c);
    $("#CF").val(v.toFixed(3));
});

$(document).on("submit","#form-filter",function()
{
    var MCV_Loading_Date=$("#MCV_Loading_Date").val();
    if(MCV_Loading_Date!="")
    {
     var form=$("#form-filter");
    $.ajax({
            url:form.attr("action"),
            data:$("#form-filter").serialize(),//only input
            type: "POST",
            Type: 'json',
            success: function (result) {
                if(result=="Success")
                {
                    $.toast({
                    heading: 'AG&P Pratham',
                    position: 'top-right',
                    loaderBg:'#ff6849',
                   hideAfter: 3500, 
                    stack: 6,
                     icon: 'success',
                    text: "Data submitted successfully!"
                  });
                }
                if(result=="Failed")
                {
                    $.toast({
                    heading: 'AG&P Pratham',
                    position: 'top-right',
                    loaderBg:'#ff6849',
                    hideAfter: 3500, 
                    stack: 6,
                    icon: 'error',
                    text: "Failed! Please try again!"
                  });
                }
               load_it();
            }
        });   
    }
    
});
</script>
@endpush