@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">Industry Input</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">Industry Input Sheet</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
           
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
             $myga=anyFiled("User","ga",Auth::user()->id);
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 mt-2 text-white pull-left" id="gaDistrictInputname">Industry Input Sheet</h4>
                </div>
                <form id="form-filter" class="form-horizontal" action="{{ route('industryInput.post') }}" method="POST">
                     {{ csrf_field() }}
                    <input type="hidden" name="device" value="web">
                    <input type="hidden" name="user_id" value="{{Auth::user()->userId}}">
                    <div class="card-body">
                        
                        <table id="customers" class="table table-bordered table-striped">
                            <thead>
                                <tr> 
                                    <th>Date</th>
                                    <th>Industrial Volume (AMR) EVC with P&T Compensation</th>
                                    <!--<th>Volume 1 Bar with EVC & Fix Correction Factor (SCM)</th>
                                    <th>Volume 1 Bar without EVC (SCM) Correction Factor  to be applied (1.889)</th>-->
                                    <th>PD Meter Volume
                                        (Mechanical Counter only)
                                        110 mbar skid
                                        (Correction factor not to be applied here)</th>
                                    <th>Volume Correction Factor</th>
                                    <th>PD Meter Volume
                                        (Mechanical Counter only)
                                        250 mbar skid
                                        (Correction factor not to be applied here)</th>
                                    <th>Volume Correction Factor</th>
                                    <th>PD Meter Volume
                                        (Mechanical Counter only)
                                        300 mbar skid
                                        (Correction factor not to be applied here)</th>
                                    <th>Volume Correction Factor</th>
                                    <th>PD Meter Volume
                                        (Mechanical Counter only)
                                        400 mbar skid
                                        (Correction factor not to be applied here)</th>
                                    <th>Volume Correction Factor</th>
                                    <th>Total Sales Volume(SCM)</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody id="new_data">
                            </tbody>
                        </table>     
                    </div>
                </form>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>
$(document).ready(function()
{
      
    load_it();
})
function load_it()
{
     $.ajax({
            url: "{{url('api/getIndustryInputs')}}",
            type: "POST",
            data: {
              "device":"web",
                _token: '{{csrf_token()}}'
            },
            dataType: 'json',
            success: function (result) {
                console.log(result);
                $("#customers").dataTable().fnDestroy();
                $("#new_data").html(result);
                var table =  new DataTable('#customers', {  
                     paging: false,
                    order:[0,"asc"],
                    scrollX:true,
                    scrollCollapse: true,
                    scrollY: '65vh',
                    autoWidth: true,
                 });
                }
    });
}

$(document).on("keyup","[id^='pd_meter_volume_']",function()
{
    var pd_meter_volume_400=$("#pd_meter_volume_400").val();
    var pd_meter_volume_300=$("#pd_meter_volume_300").val();
    var pd_meter_volume_250=$("#pd_meter_volume_250").val();
    var pd_meter_volume_110=$("#pd_meter_volume_110").val();
    var Volume_Correction_Factor_400=$("#Volume_Correction_Factor_400").val();
    var Volume_Correction_Factor_300=$("#Volume_Correction_Factor_300").val();
    var Volume_Correction_Factor_250=$("#Volume_Correction_Factor_250").val();
    var Volume_Correction_Factor_110=$("#Volume_Correction_Factor_110").val();
    var volume_bar_without_evc=$("#volume_bar_without_evc").val();
    var volume_bar_with_evc=$("#volume_bar_with_evc").val();
    var industrial_volume=$("#industrial_volume").val();
    if(pd_meter_volume_400=="")pd_meter_volume_400=0;
    if(pd_meter_volume_300=="")pd_meter_volume_300=0;
    if(pd_meter_volume_250=="")pd_meter_volume_250=0;
    if(pd_meter_volume_110=="")pd_meter_volume_110=0;
    if(Volume_Correction_Factor_400=="")Volume_Correction_Factor_400=0;
    if(Volume_Correction_Factor_300=="")Volume_Correction_Factor_300=0;
    if(Volume_Correction_Factor_250=="")Volume_Correction_Factor_250=0;
    if(Volume_Correction_Factor_110=="")Volume_Correction_Factor_110=0;
    if(volume_bar_without_evc=="")volume_bar_without_evc=0;
    if(volume_bar_with_evc=="")volume_bar_with_evc=0;
    if(industrial_volume=="")industrial_volume=0;
   // var v=parseFloat(industrial_volume)+(parseFloat(pd_meter_volume_110)*parseFloat(Volume_Correction_Factor_110))+(parseFloat(pd_meter_volume_250)*parseFloat(Volume_Correction_Factor_250))+(parseFloat(pd_meter_volume_300)*parseFloat(Volume_Correction_Factor_300))+(parseFloat(pd_meter_volume_400)*parseFloat(Volume_Correction_Factor_400));
   var v=parseFloat(industrial_volume)+parseFloat(pd_meter_volume_110)+parseFloat(pd_meter_volume_250)+parseFloat(pd_meter_volume_300)+parseFloat(pd_meter_volume_400);
    $("#total_sales").val(v.toFixed());
});

$(document).on("submit","#form-filter",function(e)
{
    //e.preventDefault();
    $("#submit").attr("disabled",true);
    /*var pd_meter_volume_400=$("#pd_meter_volume_400").val();
    if(pd_meter_volume_400!="" || pd_meter_volume_400!=0)
    {
     var form=$("#form-filter");
    $.ajax({
            url:form.attr("action"),
            data:$("#form-filter").serialize(),//only input
            type: "POST",
            Type: 'json',
            success: function (result) {
                if(result=="Success")
                {
                    $.toast({
                    heading: 'AG&P Pratham',
                    position: 'top-right',
                    loaderBg:'#ff6849',
                   hideAfter: 3500, 
                    stack: 6,
                     icon: 'success',
                    text: "Data submitted successfully!"
                  });
                }
                if(result=="Failed")
                {
                    $.toast({
                    heading: 'AG&P Pratham',
                    position: 'top-right',
                    loaderBg:'#ff6849',
                    hideAfter: 3500, 
                    stack: 6,
                    icon: 'error',
                    text: "Failed! Please try again!"
                  });
                }
               load_it();
            }
        });   
    }*/
    
});
</script>
@endpush