@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">Assigned Applications</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">Assigned Applications</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
            <!--<form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 mt-2 text-white pull-left">List of Applications assigned to surveyor</h4>
                    <a  class="btn waves-effect waves-light btn-light pull-right" href="{{ route('surveyAssignment') }}">New Assignment</a>
                </div>
                <div class="card-body">
                    <table id="customers" class="table table-bordered table-striped">
                        <thead>
                            <tr>
                                <th>SL#</th>
                                <th>Assignment Id</th>
                                <th>Surveyor</th>
                                <th>CA</th>
                                <th>Customer Name</th>
                                <th>Mobile</th>
                                <th>Email</th>
                                <th>Meter Number</th>
                                <th>Installation Number</th>
                                <th>Application Number</th>
                            </tr>
                        </thead>
                    </table>     
                </div>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>

$(document).ready(function()
{
   var table =  new DataTable('#customers', {  
       dom: 'Blfrtip',
        processing: true,
        serverSide: true,
        scrollX:true,
        lengthMenu: [ [100, 250, -1], [100, 250, 'All'] ],
        order:[1,"asc"],
        "buttons": ["csv", "excel", "pdf", "print", "colvis"],
        "ajax":{
                     "url": "{{ url('api/customerList') }}",
                     "dataType": "json",
                     "type": "POST",
                     "data":
                     function(data)
                     {  
                        data.device= "web",
                        data.agpUser="{{Auth::user()->userId}}",
                        data._token= "{{csrf_token()}}",
                        data.formdata = $('#form-filter').serialize();
                     }
                   },
                    "columns": [
		        { "data": "slno" },
				{ "data": "assignment_id" },
				{ "data": "agp_user" },
				{ "data": "ca" },
				{ "data": "name_of_the_customer" },
				{ "data": "contact_no" },
				{ "data": "customer_email" },
                { "data": "meter_serial_no" },
                { "data": "installation_no" },
                { "data": "application_no" },
            ],
            
			"columnDefs": [ 
        {
"targets": [],
"orderable": false
} 
    ],
});
$('#submit').on("click",function(){ //button filter event click
        table.ajax.reload();  //just reload table
    });
$('#btn-reset').click(function(){ //button reset event click
        $('#form-filter')[0].reset();
        table.ajax.reload();  //just reload table
    }); 

});

</script>
@endpush