@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">Survey Assignment</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">Survey Assignment</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
           <!-- <form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">Survey Assignment</h4>
                </div>
                <div class="card-body">
                   
                        <div class="form-body">
                           
                           <form id="form-filter" class="form-horizontal">
                    <div class="row">
                        <div class="form-group element col-3">
                            <label for="text-input" class=" form-control-label">Charge Area Code
                            </label>
                           <select name="Charge_Area_Code" id="Charge_Area_Code" class="form-control select2">
                                <option value="">Please select</option>
                               @foreach($cac as $v)
                               <option value="{{$v}}">{{$v}}</option>
                               @endforeach
                            </select>
                        </div>
                        <div class="form-group element col-3">
                            <label for="text-input" class=" form-control-label">BP Grouping
                            </label>
                           <select name="BP_Grouping" id="BP_Grouping" class="form-control select2">
                                <option value="">Please select</option>
                               @foreach($bg as $v)
                               <option value="{{$v}}">{{$v}}</option>
                               @endforeach
                            </select>
                        </div>
                        <div class="form-group element col-3">
                            <label for="text-input" class=" form-control-label">MRU
                            </label>
                           <select name="MRU" class="form-control select2">
                                <option value="">Please select</option>
                               @foreach($mru as $v)
                               <option value="{{$v}}">{{$v}}</option>
                               @endforeach
                            </select>
                        </div>
                      
                         <div>
                            <input id="submit" class="btn btn-primary text-white" type="button" value="Search"> 
                           <input type="reset" id="btn-reset" class="btn btn-secondary" value="Cancel">
                        </div>
                    </div>
                </form>
                <div> &nbsp;</div>
                <div class="ms-auto mt-3 mt-md-0">
                <input class="btn btn-warning text-white col-3" type="button" id="assign" value="Assign To"  data-bs-toggle="modal" data-bs-target="#myModal" disabled> 
                </div>
                <table id="customers" class="table table-bordered table-striped col-12">
                    <thead>
                        <tr>
                            <th><input type="checkbox" class="chk" id="all"/></th>
                            <th>SL#</th>
                            <th>GA</th>
                            <th>Charge Area code</th>
                            <th>BP Grouping</th>
                            <th>MRU</th>
                            <th>CA</th>
                            <th>Application Number</th>
                            <th>Customer Name</th>
                            <th>Meter Number</th>
                            <th>PNGRB District</th>
                            <th>Address District</th>
                            <!--<th>Action</th>-->
                        </tr>
                    </thead>
                </table>     
                            <!--/row-->
                        </div>
                        <div class="form-actions">
                        
                       
                <!-- Modal -->
                <div class="modal" id="myModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel1">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title" id="exampleModalLabel1">Assign To</h4>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"><span aria-hidden="true"></span></button>
            </div>
            <form class="form-horizontal"  action="{{ route('surveyAssignment.post') }}" method="POST">
                {{ csrf_field() }}
            <div class="modal-body">
                
                    <div class="form-group">
                        <label for="agp_user" class="form-label">Surveyor:</label>
                        <input type="hidden" name="ca" value="" id="ca">
                        <select name="agp_user" id="agp_user" class="form-control">
                             <option value="">Please select</option>
                            @foreach($surveyor as $k=>$v)
                            <option value="{{$k}}">{{$v}}({{$k}})</option>
                            @endforeach
                         </select>
                    </div>
                    <div class="form-group">
                        <label for="message-text" class="form-label">Message:</label>
                        <textarea class="form-control" id="message-text1"></textarea>
                    </div>
                
            </div>
            <div class="modal-footer">
        
                <button type="button" class="btn btn-default" data-bs-dismiss="modal">Close</button>
                <button type="submit" name="assign_submit" value="assign" class="btn btn-primary text-white">Submit</button>
            </div>
            </form>
        </div>
    </div>
</div>
                
                
                
                
                        </div>
                   
                </div>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>

$(document).ready(function()
{
     
   var table =  new DataTable('#customers', {  
       dom: 'Blfrtip',
    "buttons": ["csv", "excel", "pdf", "print", "colvis"],
        processing: true,
        serverSide: true,
        'lengthMenu': [ [100, 250, -1], [100, 250, 'All'] ],
        order:[1,"asc"],
        scrollX: true,
        "ajax":{
                     "url": "{{ url('api/getCustomer') }}",
                     "dataType": "json",
                     "type": "POST",
                     
                     "data":
                     function(data)
                     {  
                        data.device= "web",
                        data.userId="{{Auth::user()->userId}}",
                        data._token= "{{csrf_token()}}",
                        data.formdata = $('#form-filter').serialize();
                     }
                   },
                    "columns": [
		        { "data": "chk" },
		        { "data": "slno" },
		        { "data": "GA" },
				{ "data": "Charge_Area_Code" },
				{ "data": "BP_Grouping" },
				{ "data": "MRU" },
				{ "data": "CA" },
				{ "data": "Application_Number" },
                { "data": "Name_of_the_Customer" },
                { "data": "Meter_Serial_No" },
                { "data": "PNGRB_District_t" },
                { "data": "Address_District" },
               //{ "data": "options" },
            ],
            
			"columnDefs": [ 
        {
"targets": [0],
"orderable": false
} 
    ],
});
$('#submit').on("click",function(){ //button filter event click
        table.ajax.reload();  //just reload table
    });
$('#btn-reset').click(function(){ //button reset event click
        $('#form-filter')[0].reset();
        table.ajax.reload();  //just reload table
    }); 
$('#all').click(function (e) {
    $('#customers tbody :checkbox').prop('checked', $(this).is(':checked'));
    if($( ".chk:checked" ).length >= 1)
  {
    $('#assign').prop('disabled', false);
  }
  else
  {
    $('#assign').prop('disabled', true);
  }  
    e.stopImmediatePropagation();
});
});
    $(document).on( "click", ".chk", function() {
  if($( ".chk:checked" ).length >= 1)
  {
    $('#assign').prop('disabled', false);
  }
  else
  {
    $('#assign').prop('disabled', true);
  }  
});
$(document).on("click","#assign",function()
{
    var va=[];
            $("#customers tbody :checkbox:checked").each(function() { 
                va.push($(this).val()); 
            });  
            $.ajax({
                    url: "{{url('api/getSurveyor')}}",
                    type: "POST",
                    data: {
                      "customer": va,"device":"web",
                        _token: '{{csrf_token()}}'
                    },
                    dataType: 'json',
                    success: function (result) {
                       //console.log(res);
                       var tr="<option>Please Select</option>";
                        $.each(result,function(key,value){
                            tr+="<option value='"+key+"'>"+value+"("+key+")</option>";
                        });
                            $("#agp_user").html(tr);
                            $("#ca").val(va);
                    }
                });
})
</script>
@endpush