@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">Network</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">Network</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
            <!--<form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">Network Master Form</h4>
                </div>
                <div class="card-body">
                    <form name="controlCenter" action="{{ route('masterNetworkPost') }}" method="POST" class="needs-validation" novalidate >
                        {{ csrf_field() }}
                        <div class="form-body">
                            <input type="hidden" name="device" value="web">
                            @if(isset($networkMasterDetail))
                             <input type='hidden' name='zid'  value='{{$networkMasterDetail["id"]}}'>
                             @endif
                            <div class="row p-t-20">
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label class="form-label">Network Size</label>
                                        <input type="text" name="network" id="network" required="true" placeholder="Enter Network Size" class="form-control" value="{{@$networkMasterDetail['network_name']}}">
                                        <small class="form-control-feedback text-primary"> Name of the network</small>
                                    </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-2">
                                    <div class="form-group">
                                        <label class="form-label">Nominal Wall Thickness</label>
                                        <input type="text" name="nominal_wall_thickness" id="nominal_wall_thickness" class="form-control " placeholder="Enter Nominal Wall Thickness" value="{{@$networkMasterDetail['nominal_wall_thickness']}}">
                                        <small class="form-control-feedback text-primary"> This is code or short form(if any)of the network. Or add data same as network name </small> </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-2">
                                    <div class="form-group">
                                        <label class="form-label">Category</label>
                                        <select  name="category" id="category" required="true" class="form-control form-select">
                                            <option value="PE"  {{ (@$networkMasterDetail['category'] == 'PE' ? "selected":"") }}>PE</option>
                                            <option value="Steel" {{ (@$networkMasterDetail['category'] == 'Steel' ? "selected":"") }}>Steel</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-2">
                                    <div class="form-group">
                                        <label class="form-label">Status</label>
                                        <select  name="status" id="status" required="true" class="form-control form-select">
                                            <option value="Active"  {{ (@$networkMasterDetail['status'] == 'Active' ? "selected":"") }}>Active</option>
                                            <option value="Inactive" {{ (@$networkMasterDetail['status'] == 'Inactive' ? "selected":"") }}>Inactive</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="form-actions col-md-3 mt-4">
                                    <button type="submit" name="submit" id="submit" value="Submit" class="btn btn-primary text-white "> <i class="fa fa-check"></i> Save</button>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                        </div>
                    </form>
                    <!--Table Data-->
                    <table id="controlCenter" class="table table-bordered table-striped ">
                        <thead>
                            <tr>
                                <th>SL#</th>
                                <th>Network</th>
                                <th>Nominal Wall Thickness</th>
                                <th>Category</th>
                                <th>Status</th>
                                <th>Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                            @if(!empty($networkMaster))
                            @foreach($networkMaster as $k=>$cc)
                            <tr>
                                <td>{{$loop->iteration}}</td>
                                <td>{{$cc['network']}}</td>
                                <td>{{$cc['nominal_wall_thickness']}}</td>
                                <td>{{$cc['category']}}</td>
                                @if($cc['status']=="Active")
                                <td><span class="label label-success">{{$cc['status']}}</span></td>
                                @else
                                <td><span class="label label-danger">{{$cc['status']}}</span></td>
                                @endif
                                <td><a style="float:left; margin-right:10px;" href="{{route('masterNetwork', ['zid'=>$cc['id']])}}"><button type="button" class="btn btn-info btn-sm"><i class="ti-pencil"></i></button></a>
                                 <form method="post" action="{{route('masterNetworkDelete',$cc['id'])}}">
                            @csrf
                                <button type="submit" onclick="return confirm('Are you sure?')"  class="btn btn-warning btn-sm"><i class="ti-trash"></i></button>
                                </form></td>
                            </tr>
                            @endforeach
                            @endif
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script>
    $(function()
    {
        $('#controlCenter').DataTable();
    })
</script>
@endpush