@extends('layout')
    @section('content')
<div class="container-fluid">
        <div class="row page-titles">
        <div class="col-md-12">
            <h4 class="text-white">CCC Log Entry</h4>
        </div>
        <div class="col-md-6">
            <ol class="breadcrumb justify-content-end">
                <li class="breadcrumb-item"><a href="{{route('dashboard')}}">Home</a></li>
                <li class="breadcrumb-item active">CCC Log Entry</li>
            </ol>
        </div>
        <div class="col-md-6 text-end">
            <!--<form class="app-search d-none d-md-block d-lg-block">
                <input type="text" class="form-control" placeholder="Search &amp; enter">
            </form>-->
        </div>
    </div>
    <!-- ============================================================== -->
    <!-- End Bread crumb and right sidebar toggle -->
    <!-- ============================================================== -->
    <!-- ============================================================== -->
    <!-- Start Page Content -->
    <!-- ============================================================== -->
    <!-- Row -->
     @php
        $success="";
        $error="";
            if (Session::has('msg') && Session::has('code'))
            {
                if (Session::get('code') == 1)
                {
                    $success=Session::get('msg');
                }
                else
                {
                    $error=Session::get('msg');
               }
            }
        @endphp
    <div class="row">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header bg-info">
                    <h4 class="m-b-0 text-white">AG&P CCC Log Entry Form</h4>
                </div>
                <div class="card-body">
                    <form name="registration" action="{{ route('EnterWebGALog') }}" method="POST" class="needs-validation" novalidate >
                        {{ csrf_field() }}
                        <div class="form-body">
                            <h3 class="card-title">CCC Log Entry</h3>
                            <hr>
                            <input type="hidden" name="device" value="web">
                            <input type="hidden" name="user_id" value="{{Auth::user()->userId}}">
                            <div class="row p-t-20">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Date</label>
                                        <input type="date" name="attendance_date" id="attendance_date" required="true" placeholder="Enter Date" class="form-control">
                                        <small class="form-control-feedback"> Please select date</small>
                                        <!--<div class="invalid-feedback">
                                            Please enter userid.
                                        </div>
                                        -->
                                        </div>
                                </div>
                                <!--/span-->
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Shift</label>
                                        <select name="shift_code" id="shift_code"  class="form-control form-select" data-placeholder="Choose a Shift">
                                            <option>Please Select Shift</option>
                                            @foreach($shift as $v)
                                                <option value="{{$v}}">{{$v}}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                                <!--/span-->
                            </div>
                            <!--/row-->
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Timing</label>
                                        <input type="text" name="start_end_time" id="start_end_time"  class="form-control" value="" readonly>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">Function</label>
                                        <select name="function_code" id="function_code"  class="form-control form-select" data-placeholder="Choose a function">
                                            <option>Please Select function</option>
                                            @foreach($function as $v)
                                                <option value="{{$v}}">{{$v}}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                                </div>
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="form-label">User</label>
                                        <select name="user_id" id="user_id"  class="form-control form-select" data-placeholder="Choose User">
                                            <option>Please Select User</option>
                                            @foreach($user as $v)
                                                <option value="{{$v['userName']}}">{{$v['userName']}}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                                <!--/span-->
                                
                                <!--/span-->
                            </div>
                            <!--/row-->
                        </div>
                        <div class="form-actions">
                            <button type="submit" name="submit" id="submit" value="Submit" class="btn btn-primary text-white"> <i class="fa fa-check"></i> Save</button>
                            <button type="reset" class="btn btn-secondary">Reset</button>
                            <input type="hidden" name="source" value="web" />
                        </div>
                    </form>
                    <!--Table Data-->
                    <table id="function" class="table table-bordered table-striped ">
                        <thead>
                            <tr>
                                <th>SL#</th>
                                <th>Date</th>
                                <th>Shift</th>
                                <th>Timing</th>
                                <th>Function</th>
                                <th>User</th>
                                <th>Status</th>
                            </tr>
                        </thead>
                        <tbody>
                            @if(!empty($allLogsEntry))
                            @foreach($allLogsEntry as $key=>$value)
                            <tr>
                                <td>{{$loop->iteration}}</td>
                                <td>{{$value['ga_day']}}</td>
                                <td>{{$value['shift']}}</td>
                                <td>{{$value['start_time'] .'-'. $value['end_time']}}</td>
                                <td>{{$value['function']}}</td>
                                <td>{{$value['userId']}}</td>
                            </tr>
                            @endforeach
                            @endif
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
    <!-- Row -->
</div>
     @endsection
@push('custom-scripts')
<script type="text/javascript">
$(document).ready(function(){
$("#shift_code").change(function(){
var selectedValue = $(this).val();
$.ajax({url: "/api/getShift", method: "post", data: { shift : selectedValue },
success: function(result){
const myArr = JSON.parse(result);
const newTimeValue = myArr.start_time + "-" + myArr.end_time;
    $("#start_end_time").val(newTimeValue);
  }});
});
});
</script>
@endpush