<?php

use Illuminate\Support\Facades\App;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

use App\Http\Controllers\Login\LoginController;
use App\Http\Controllers\Survey\SurveyCountController;
use App\Http\Controllers\Admin\AdminController;
use App\Http\Controllers\DPR\DcuController;
use App\Http\Controllers\Shiftlog\ShiftlogController;
use App\Http\Controllers\Master\MasterController;
use App\Http\Controllers\DPR\DPRController;
//by purnima on 1-2-2024

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "api" middleware group. Make something great!
|
*/

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});

/*by purnima*/
Route::post('login', [LoginController::class, 'postLogin']);
Route::post('updateEnv', [LoginController::class, 'updateEnv'])->name('updateEnv');


Route::any('customerList', [SurveyCountController::class, 'customerList'])->name('customerList');
Route::post('getUser', [AdminController::class, 'getUser'])->name('getUser');
Route::post('getCustomer', [AdminController::class, 'getCustomer'])->name('getCustomer');
Route::post('getSurveyor', [AdminController::class, 'getSurveyor'])->name('getSurveyor');
Route::post('postSurvey', [SurveyCountController::class, 'postSurvey'])->name('postSurvey');
Route::post('getCompletedSurvey', [SurveyCountController::class, 'getCompletedSurvey'])->name('getCompletedSurvey');

/*shiftlog routes start*/
Route::post('attendancePost', [ShiftlogController::class, 'attendancePost'])->name('attendancePost');
Route::post('standingInstructionPost', [ShiftlogController::class, 'standingInstructionPost'])->name('standingInstructionPost');

/*DPR System routes start*/
Route::any('getMenuList', [MasterController::class, 'getMenuList'])->name('getMenuList');
Route::post('getAllUser', [MasterController::class, 'getAllUser'])->name('getAllUser');


Route::any('getDistrict', [MasterController::class, 'getDistrict'])->name('getDistrict');
Route::post('dcuPost', [DcuController::class, 'dcuPost'])->name('dcuPost');
Route::any('getDcu', [DcuController::class, 'getDcu'])->name('getDcu');
Route::any('getInputs', [DcuController::class, 'getInputs'])->name('getInputs');
Route::any('getInputsGA', [DcuController::class, 'getInputsGA'])->name('getInputsGA');
Route::any('getStorageTank', [DcuController::class, 'getStorageTank'])->name('getStorageTank');
Route::any('getIndustryInputs', [DcuController::class, 'getIndustryInputs'])->name('getIndustryInputs');
Route::any('getCngPurchaseInputs', [DcuController::class, 'getCngPurchaseInputs'])->name('getCngPurchaseInputs');
Route::any('getDistrictCNGReport', [DcuController::class, 'getDistrictCNGReport'])->name('getDistrictCNGReport');
Route::any('getDistCgdRecoReport', [DcuController::class, 'getDistCgdRecoReport'])->name('getDistCgdRecoReport');
Route::any('getDailyMisReport', [DcuController::class, 'getDailyMisReport'])->name('getDailyMisReport');
Route::any('dashboardCalculations', [DcuController::class, 'dashboardCalculations'])->name('dashboardCalculations');

/*Purnima's code end*/
/* Debakant's Code */
Route::post('EnterGALog', [ShiftlogController::class, 'EnterGALog'])->name('EnterGALog');
Route::any('getShift', [ShiftlogController::class, 'getShift'])->name('getShift');
Route::any('grossSUGKgValue', [DPRController::class, 'grossSUGKgValue'])->name('grossSUGKgValue');
Route::any('gasFilledToMCVPerMonthInKg', [DPRController::class, 'gasFilledToMCVPerMonthInKg'])->name('gasFilledToMCVPerMonthInKg');
Route::any('CumMonthlyPurchaseInSCM', [DPRController::class, 'CumMonthlyPurchaseInSCM'])->name('CumMonthlyPurchaseInSCM');
Route::any('CumYearlyPurchaseInSCM', [DPRController::class, 'CumYearlyPurchaseInSCM'])->name('CumYearlyPurchaseInSCM');
Route::any('GasFilledtoMCVFromSalawas', [DPRController::class, 'GasFilledtoMCVFromSalawas'])->name('GasFilledtoMCVFromSalawas');
Route::any('quantityOfLNGInvoiced', [DPRController::class, 'quantityOfLNGInvoiced'])->name('quantityOfLNGInvoiced');
Route::any('volumeAvailableStationaryCascade', [DPRController::class, 'volumeAvailableStationaryCascade'])->name('volumeAvailableStationaryCascade');
Route::any('totalClosingStock', [DPRController::class, 'totalClosingStock'])->name('totalClosingStock');
Route::any('lossCalculation', [DPRController::class, 'lossCalculation'])->name('lossCalculation');
Route::any('lossCalculationMTD', [DPRController::class, 'lossCalculationMTD'])->name('lossCalculationMTD');
Route::any('lossCalculationYTD', [DPRController::class, 'lossCalculationYTD'])->name('lossCalculationYTD');
Route::any('checkIfRecordExsists', [DPRController::class, 'checkIfRecordExsists'])->name('checkIfRecordExsists');
Route::any('lossDuringUnloading', [DPRController::class, 'lossDuringUnloading'])->name('lossDuringUnloading');
Route::any('cngSideKnownLoss', [DPRController::class, 'cngSideKnownLoss'])->name('cngSideKnownLoss');
Route::any('getNominalThickness', [DPRController::class, 'getNominalThickness'])->name('getNominalThickness');
Route::any('getFinalSuctionMFM', [DPRController::class, 'getFinalSuctionMFM'])->name('getFinalSuctionMFM');
Route::any('getWeightedAvreageCorrectionFactor', [DPRController::class, 'getWeightedAvreageCorrectionFactor'])->name('getWeightedAvreageCorrectionFactor');
/* Debakant's Code */